'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 4 April 2005 at 11:04:47 pm'!
"Change Set:		QuestForPants
Date:			25 March 2005
Author:			Chris Reuter

Quest For Pants: An (Extremely) Unauthorized Sequel to Nethack.

This code is released under the terms of the GNU General Public License
with some exceptions added.  See the file 'Copyright.txt' for details.

"!

Object subclass: #GmAbstractCreatureBrain
	instanceVariableNames: 'owner '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Brainzzzzz'!
Object subclass: #GmAction
	instanceVariableNames: 'doer recipient argument '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Actions'!
GmAction subclass: #GmAttack
	instanceVariableNames: 'recipientNotification '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Actions'!

!GmAttack commentStamp: 'cr 3/9/2005 18:25' prior: 0!
This is the abstract base class for all attacks.
!

Object subclass: #GmBuilderHack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Junk'!

!GmBuilderHack commentStamp: 'cr 3/26/2005 13:12' prior: 0!
This class contains some utility methods used to generate creature classes.  These
are meant as a one-time thing--DO NOT USE.

!

Object subclass: #GmDeploymentSlot
	instanceVariableNames: 'name item type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stuff Management'!

!GmDeploymentSlot commentStamp: 'cr 3/6/2005 18:47' prior: 0!
This is a structure representing a place you can put a Thing.  (For example, "feet"
which can wear "boots").

Structure:
 name			String		-- Descriptive name of the slot.
 item			GmThing	-- The item itself or 'nil' if the slot is empty.
XXX fitTest			Symbol		-- The name of a method to send to a prospective item to
								determine if it is of the right type to fit here.

For example, a DeploymentSlot representing the left hand (for the purpose of wearing
a ring) would have the name 'left hand' and the fitTest #isPutOnAble.


Any further useful comments about the general approach of this implementation.!

Object subclass: #GmDeployments
	instanceVariableNames: 'slots '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stuff Management'!

!GmDeployments commentStamp: 'cr 3/6/2005 14:13' prior: 0!
This object manages wielding, wearing and putting-on.  What can be done by an object is determined by
the object itself.  This means that the above actions have a unified interface.  The downside is that you
can't have object that can, for example. be wielded OR worn.  You can do at most ONE of the above with
an object.

!

Object subclass: #GmDungeonBuilder
	instanceVariableNames: 'dungeon initialState genManagers game progressBarBlock progressCount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Dungeon Builders'!

!GmDungeonBuilder commentStamp: 'cr 2/26/2005 03:40' prior: 0!
This is responsible for creating the dungeon initially.

In theory, it should be all lazy and stuff, only creating levels when the player wanders into
them, but screw that--it's too much work.

The initial generation state defaults to an instance of GmDungeonBuilderState but you can set
your own using #initialState:.


=====

Notes: I really have no idea what to do here so I'm going to just hack something together
and see how that goes.  Elegance can come later.

Appendum: okay, I sort of see how this is supposed to work.  Basically, the GmDungeonBuilder
is a big object-as-function that constructs levels according to the whims of whatever 
GmDungeonBuilderState is being used.

Note that GmDungeonBuilderState instances get copied for each new level so the behaviour has
to be in the class.

Hmmm.  Should we embed the *State object in the map itself as a kind of signpost to the nature
of the map?  It would be handy in opening up what sort of descriptions we can use.


!

Object subclass: #GmDungeonBuilderState
	instanceVariableNames: 'level mapGeneratorClasses '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Dungeon Builders'!

!GmDungeonBuilderState commentStamp: 'cr 2/23/2005 16:05' prior: 0!
When a DungeonBuilder constructs a dungeon, it does so recursively so that we can have things
like branches and merges.  Information about the dungeon is passed to each recursive call and
is held in each instance.

Note: at some point in the future, this may be split into an abstract base class and one or more subclasses.
Since right now I don't know what goes were, I'm making this class concrete and suitable for generating a
simple dungeon.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

GmAbstractCreatureBrain subclass: #GmGenericBrain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Brainzzzzz'!
Object subclass: #GmInventory
	instanceVariableNames: 'items owner '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stuff Management'!
Object subclass: #GmManagedObjectInfo
	instanceVariableNames: 'itemClass numCreated '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-State Managers'!

!GmManagedObjectInfo commentStamp: 'cr 3/5/2005 20:58' prior: 0!
Data structure for managing creature or Thing creation.

Instances are created from an array.  As fields get added, we'll need to increase the
fields.

NOT DONE!!!!!!  Note that I'm moving from creating one of these from an array to using it's class.

Structure:
	itemClass			The	 class of the creature.
	numCreated 		The number created so far.
	maxAllowed			The maximum number that can be created (nil == unlimited).

These are to be removed.  Use #canCreateIn: instead.
	toughness			(TO DO: a number/function??? to set the creature's starting exp. level.)
	minLevel			The lowest level at which one may be created.
	maxLevel			The highest level at which one may be created (nil == infinity).
	branchConstraint	Block applied to a map to determine if an object may be created here.
!

Object subclass: #GmMap
	instanceVariableNames: 'game items creatureCache changedPoints creationState '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Map'!

!GmMap commentStamp: 'cr 3/10/2005 02:54' prior: 0!
Instances represent an individual map level and contain the entire contents of the
level.

Notes:

	-#at:putCreature: updates the monster list.  It's currently the only way to add
	 creatures so this guarantees that the monster list contains every creature on the map
	 (and them some, but that's another issue).

	 Always use #at:putCreature: or if you're going to add another way to put monsters,
	 make sure it also updates the list.

	 Removing monsters isn't necessary--we just filter out the ones that no longer reference
	 this map.

!

Object subclass: #GmMapBuilder
	instanceVariableNames: 'map initialExtent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Map Builders'!
GmMapBuilder subclass: #GmBigRoomBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Map Builders'!

!GmBigRoomBuilder commentStamp: 'cr 1/3/2004 18:05' prior: 0!
This is a MapBuilder which creates a map consisting of one big room.
!

Object subclass: #GmMapEntry
	instanceVariableNames: 'feature creature pileOfStuff '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Map'!

!GmMapEntry commentStamp: '<historical>' prior: 0!
Data structure holding the contents of a map square.

Structure:
 monster		type -- The monster, if any, occupying this sector
 feature		type -- The kind of floor or wall we have here.
 pileOfStuff
!

Object subclass: #GmMessage
	instanceVariableNames: 'messageString '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmMessage commentStamp: 'cr 2/17/2005 22:38' prior: 0!
This is the base class for all game messages.

GmMessages are the messages the system gives when game objects make a request
and what game object use to notify other game objects of things.  GmMessages must be
'readable' by both the system and by humans.  Thus, they also contain human-readable
content.  Right now, this is a string but it's possible to extend this to contain multimedia
content such as, e.g., an object which a graphical interface could interpret as meaning
"Draw a fireball here".


!

Object subclass: #GmNotesInComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game'!

!GmNotesInComment commentStamp: 'cr 3/26/2005 13:20' prior: 0!
This class exists solely so that I have a place to put these notes that'll go into the changeset.  Other such notes may also go into methods.  We'll see.

(Notes deleted as they were obsolete and didn't make sense to anyone other than me.  I'll
write new ones that are more generally relevant if I have the time.)


	!

GmMessage subclass: #GmNotification
	instanceVariableNames: 'sender '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmNotification commentStamp: 'cr 2/27/2005 02:13' prior: 0!
Subinstances of this class are used to inform a game entity that something has
happened to it.

Note: Notifications (currently) have a hostility level.  This is an integer and the
higher it is, the more hostile the message will be considered.  Negative hostility
is also allowed and is interpreted benignly.

To do: define names for the hostility levels.
!

GmNotification subclass: #GmAttackNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmAttackNotification subclass: #GmAttacked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmAttackNotification subclass: #GmAttackedUnsuccessfully
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmNotification subclass: #GmDisplacedAtPortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmDisplacedAtPortal commentStamp: 'cr 2/27/2005 02:01' prior: 0!
You were standing on a stairway or magic portal and got knocked aside when someone
came through.  Deal with it.

(Actually, you can get this message just by standing near a stairway because the displacements
may ripple.  That is, someone gets bumped out and they bump into you.!

Object subclass: #GmObjGenManager
	instanceVariableNames: 'game itemInfo '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-State Managers'!

!GmObjGenManager commentStamp: 'cr 3/26/2005 13:25' prior: 0!
This is an abstract base class.

Subinstances manage things like where an object can be generated and how many
can exist in total.

Class and object attributes such as #maxAllowed and #isUnique are intended as
hints to the relevant GmObjManager, which can (but probably shouldn't) override
them.

!

GmObjGenManager subclass: #GmBestiary
	instanceVariableNames: 'creatureInfo '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-State Managers'!

!GmBestiary commentStamp: 'cr 3/26/2005 13:26' prior: 0!
Subinstances(?) are used to manage how, where and when creatures are created in
the level.
!

Object subclass: #GmObjStat
	instanceVariableNames: 'value owner changed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!

!GmObjStat commentStamp: 'cr 2/6/2005 16:06' prior: 0!
This is the base class for in-game stats.

Stats contain a name, a value and a pointer to the object holding them.  To create a new
kind of stat, you create a subclass and implement the relevant bits of the core protocol, then
add it to the relevant list in the game object so that it'll get added to new objects.

Reading a stat in the normal way causes the stat object to search the owner for things that
modify the stat and then take that into account.  For example, if the player is wearing an
amulet that adds three points to strength, the strength attribute object will take that bonus into
account.  (The actual implementation of such tests are left as an exercise to the user.)

Likewise, setting a stat in the normal way can trigger side effects.  For example, a "HitPoints"
class could mark the owner as dead if it ever goes below zero.

!

GmObjStat subclass: #GmBoolStat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmBoolStat subclass: #GmConfused
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmObjStat subclass: #GmNumStat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmNumStat subclass: #GmArmorClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmNumStat subclass: #GmBoringNumStat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmBoringNumStat subclass: #GmCharisma
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmBoringNumStat subclass: #GmConstitution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmBoringNumStat subclass: #GmDexterity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmNumStat subclass: #GmDungeonLevel
	instanceVariableNames: 'lastLevel '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!

!GmDungeonLevel commentStamp: 'cr 3/24/2005 21:58' prior: 0!
This isn't really a stat and shouldn't be set to anything.  It's here so that the control panel
has no trouble displaying it.

Its descriptionString method describes the current dungeon level and its value is the numeric
value of the level.

It determines whether it's changed by comparing the map with the map from the last time
it checked.
!

GmNumStat subclass: #GmExperience
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmNumStat subclass: #GmHitPoints
	instanceVariableNames: 'maxHitpoints '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!

!GmHitPoints commentStamp: 'cr 3/10/2005 00:19' prior: 0!
This holds the number of hitpoints and their maximum.

The number of hitpoints is a float that gets truncated when read.  This way, we can increment
it by small amounts and have it still grow.
!

GmBoringNumStat subclass: #GmIntelligence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
Object subclass: #GmObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!

!GmObject commentStamp: 'cr 1/8/2004 21:04' prior: 0!
This is the base class for game objects.  From here, we have three radically different subclasses:

	-Creatures (i.e. things that move and possibly attack).
	-Features (Parts of the level)
	-Things (Stuff that you find)

The (only) thing that they have in common is that they are visible to the player and they know
their map.

(The above may change but for the moment, I'm keeping them conceptually different so as to not go polymorphism crazy.)

=====

Engine notes:

	Inter-object ineractions happen at a higher abstraction level than system message passing.  We use GmMessage and subclasses for this.

	GmMessage implements constraints.  E.g. i X shoots Y, the GmShootMessage checks that X has a gun, bullets, etc.

	The three classes of game objects are more different than the same.  The system should treat them differently.  In particular, walls are different from fountains--walls are part of the map while fountains are fixed objects.  Doors are just a wierd kind of wall.




!

GmObject subclass: #GmCreature
	instanceVariableNames: 'map coordinates stats brain viewRegion inventory slots '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmObject subclass: #GmFeature
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmFeature subclass: #GmDoor
	instanceVariableNames: 'isOpen '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmFeature subclass: #GmFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
Object subclass: #GmObjectDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!
GmObjectDescription subclass: #GmAsciiObjectDescription
	instanceVariableNames: 'letter color name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!

!GmAsciiObjectDescription commentStamp: '<historical>' prior: 0!
Instances (or subinstances) are used to tell the front end what a particular game object
looks like.  The representation is (I hope) independent of the nature of the front end.

Instances determine their descriptions from the object they're describing:

	GmObjectDescription of: someObject

'someObject' knows nothing about its own graphical (or otherwise) representation.

Right this minute, it assumes a single ASCII character tile and a short textual description.

!

GmAsciiObjectDescription class
	instanceVariableNames: 'knownClasses '!
Object subclass: #GmPanelEntry
	instanceVariableNames: 'morph object message messageArgs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!

!GmPanelEntry commentStamp: 'cr 1/31/2005 11:46' prior: 0!
Connects an expression (message sent to object) with a Prefab text field.  Whenever it receives the message #update,
it performs the expression and sets the Prefab's text to the result.

This is intended to be used when updating the scoreboard panel.

!

GmAbstractCreatureBrain subclass: #GmPlayerBrain
	instanceVariableNames: 'game '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Brainzzzzz'!
GmFloor subclass: #GmPortal
	instanceVariableNames: 'map endPoint '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!

!GmPortal commentStamp: 'cr 2/23/2005 05:13' prior: 0!
This is the base-class for things that take you from one map to another.

Structure:
 endPoint		GmPortal -- the portal in which the creature emerges.

It's considered a kind of floor because it's a floor with stuff on it.!

GmMessage subclass: #GmResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmResponse commentStamp: 'cr 2/27/2005 01:49' prior: 0!
This is the abstract base class for messages an object receives in response to
something it attempted.  Subclasses must therefore be either a kind of GmSuccess
or GmFailure.

!

GmResponse subclass: #GmFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmFailure commentStamp: 'cr 1/4/2004 15:28' prior: 0!
Instances of this class indicate failure.

!

GmFailure subclass: #GmAlreadyUsed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmAlreadyUsed commentStamp: 'cr 3/9/2005 00:03' prior: 0!
Caller attempted to #deploy an object that had already been deployed.  (E.g. tried to wear a ring
on two fingers at once).!

GmFailure subclass: #GmCancelled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmFailure subclass: #GmDontHave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmFailure subclass: #GmImpossible
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmImpossible commentStamp: 'cr 3/6/2005 14:39' prior: 0!
You have attempted something that is conceptually implausible.
!

GmFailure subclass: #GmKnapsackFull
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmFailure subclass: #GmMissed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmFailure subclass: #GmMoveFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmMoveFailed subclass: #GmInaccessible
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmInaccessible commentStamp: 'cr 1/4/2004 15:38' prior: 0!
Instances of this class are used to indicate that the move attempt didn't work because the destination is blocked, typically by a fixture or the edge of the map.
!

GmFailure subclass: #GmNoInventory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmFailure subclass: #GmNoSlotsLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmMoveFailed subclass: #GmOccupied
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmOccupied commentStamp: 'cr 1/4/2004 15:39' prior: 0!
This class indicates that a move failed because the sector is occupied by another creature.
!

GmMapBuilder subclass: #GmRoguelikeMapBuilder
	instanceVariableNames: 'rooms '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Map Builders'!

!GmRoguelikeMapBuilder commentStamp: 'cr 2/24/2005 23:06' prior: 0!
This generates a Rogue-style dungeon level.

Cleverness alert: we use exceptions to bail out of certain infinite loops.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

GmPortal subclass: #GmStairway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmStairway subclass: #GmDownStairway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmBoringNumStat subclass: #GmStrength
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmObjGenManager subclass: #GmStuffManager
	instanceVariableNames: 'stuffInfo '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-State Managers'!
GmResponse subclass: #GmSuccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmSuccess commentStamp: 'cr 1/3/2004 10:21' prior: 0!
Instances of this class indicate success.
!

GmSuccess subclass: #GmHitTarget
	instanceVariableNames: 'target '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmSuccess subclass: #GmItemDropped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmHitTarget subclass: #GmKilledTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmSuccess subclass: #GmSilentSuccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmSilentSuccess commentStamp: 'cr 10/4/2004 01:06' prior: 0!
This class represents success which are self-evident and so don't need to contain a human-friendly message.

(Actually, it should carry a message, but the UI shouldn't display it.)
!

GmSuccess subclass: #GmSuccessfullyStoredItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmObject subclass: #GmThing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!

!GmThing commentStamp: 'cr 1/2/2004 20:00' prior: 0!
This is the base class for all Things.

Things are those game objects which are neither monsters nor level features.
!

GmThing subclass: #GmClothing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmClothing subclass: #GmBoots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmThing subclass: #GmGem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmClothing subclass: #GmGloves
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmClothing subclass: #GmHelmet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmHelmet subclass: #GmAssHat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmThing subclass: #GmJewelry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmClothing subclass: #GmPants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmJewelry subclass: #GmRing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmRing subclass: #GmRingOfNothing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmClothing subclass: #GmSuit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmSuit subclass: #GmDragonSuit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmObjectDescription subclass: #GmTiledObjectDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!
GmCreature subclass: #GmToolUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmToolUser subclass: #GmHumanoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmFloor subclass: #GmTunnelFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!

!GmTunnelFloor commentStamp: 'cr 1/21/2004 01:04' prior: 0!
Just like GmFloor except with a different glyph.
!

Object subclass: #GmTunneller
	instanceVariableNames: 'map position direction hitDoor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Map Builders'!

!GmTunneller commentStamp: 'cr 2/24/2005 23:34' prior: 0!
Instances of this class are used to dig a single tunnel for a GmRoguelikeMapBuilder.  The tunnel
starts inside a room and ends either when 1) another room is reached (or more specifically, a
second door is created) 2) enough tunnel has been dug or 3) we leave the map.

Structure:
 map			GmMap		-- The map to dig.
 position		Point		-- The current position, i.e. the last point dug.
 direction		Point		-- The value added to position to move to the next square.
 hitDoor			Boolean		-- If true, it means we've created one door already.

As a bit of cleverness, I pass around a block containing a return to use as a non-local return.
This may, in retrospect, be better done using an exception but I'm not going to bother with that
right now.

To do: when creating a door, first check if the adjacent wall section already has a door and if so,
tunnel through it instead.  This will eliminate those walls made of doors that sometimes happen.

!

GmAttack subclass: #GmUnarmedAttack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Actions'!
Error subclass: #GmUnlikelyEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Exceptions'!

!GmUnlikelyEvent commentStamp: 'cr 2/26/2005 00:57' prior: 0!
This is the base class for those exceptions that get thrown when something that is highly unlikely
and undesirable happens.  For example, if you attempt to teleport but there are no spots on the
level to which you can be moved, the relevant routine would throw this exception.

If the intervening call stack does not catch this, the bottom-level will and display an
appropriately pithy message to the user.  (Note: This isn't done yet.)

When using this, be careful not to leave things half done.  For example, if you've removed the player from
the map only to discover that there's no place to put him, you need to catch this exception so that you can
put him back or (preferably) don't change anything until you know it'll succeed.

!

GmUnlikelyEvent subclass: #GmAttemptsExceeded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Exceptions'!

!GmAttemptsExceeded commentStamp: 'cr 2/24/2005 23:03' prior: 0!
This is an exception which gets thrown when multiple attempts at getting a random result
that fits certain constraints (e.g. a room which fits on the map around a particular point)
fail.

It is an error not to catch this exception if it occurs.

It is meant primarily as a way to exit some stage of level construction.

!

GmUnlikelyEvent subclass: #GmNoRoom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Exceptions'!

!GmNoRoom commentStamp: 'cr 2/26/2005 00:59' prior: 0!
Exception that gets thrown when there is no room to put a thing on a map.

!

GmFeature subclass: #GmUnusedSpace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!

!GmUnusedSpace commentStamp: 'cr 1/16/2004 00:00' prior: 0!
This is the null fixture.  It represents a solid, untouched sector.

!

GmStairway subclass: #GmUpStairway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmUpStairway subclass: #GmDungeonExit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
Object subclass: #GmViewRegion
	instanceVariableNames: 'viewer viewableRect enteredRoom '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Vision'!

!GmViewRegion commentStamp: 'cr 3/2/2005 23:20' prior: 0!
The region of the map in which the view can see everything.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

GmFeature subclass: #GmWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmWall subclass: #GmCornerWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmWall subclass: #GmEastWestWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmWall subclass: #GmNorthSouthWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Features'!
GmThing subclass: #GmWeapon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmWeapon subclass: #GmBluntWeapon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmBluntWeapon subclass: #GmAluminumBaseballBat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Weapons'!
GmWeapon subclass: #GmEdgedWeapon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmEdgedWeapon subclass: #GmBattleSpork
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Weapons'!
GmEdgedWeapon subclass: #GmKnife
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmKnife subclass: #GmCrudeDagger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Weapons'!
GmEdgedWeapon subclass: #GmSword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Abstract'!
GmSword subclass: #GmLongSword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Weapons'!
GmSword subclass: #GmShortSword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Weapons'!
GmAttack subclass: #GmWeaponAttack
	instanceVariableNames: 'weapon '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Actions'!

!GmWeaponAttack commentStamp: 'cr 3/9/2005 18:57' prior: 0!
This is the vanilla weapon attack.  More specialized attacks may be subclassed from here.

Does all the die rolling.

Warning: I have no idea what I'm doing here.
!

GmBoringNumStat subclass: #GmWisdom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmNotification subclass: #GmYouAttack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmSuccess subclass: #GmYouSee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!
GmMoveFailed subclass: #GmYouSeeNoNounHere
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game Messages'!

!GmYouSeeNoNounHere commentStamp: 'cr 2/26/2005 01:22' prior: 0!
Indicates that you tried to do something that affects your environment when there
is no such object nearby.  For example, trying to open a door when you are not near
a door.
!

PrefabManager subclass: #GmPrefabFullScreenManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!

!GmPrefabFullScreenManager commentStamp: 'cr 3/13/2005 22:16' prior: 0!
This is a manager which will fill the entire World and at the back.  It will resize 
itself to continue to fill the World via a #step method.

The purpose of this is to make the entire image look like an application window.

!

GmGem subclass: #NhAmber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmGem subclass: #NhAmethyst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmGem subclass: #NhAquamarine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmSuit subclass: #NhBandedMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmBestiary subclass: #NhBestiary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-State Managers'!
GmDragonSuit subclass: #NhBlackDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhBlackDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmToolUser subclass: #NhBlackNagaHatchling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmDragonSuit subclass: #NhBlueDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhBlueDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmSuit subclass: #NhBronzePlateMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmHumanoid subclass: #NhBugbear
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhChainMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmHelmet subclass: #NhCommonHelmet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmHelmet subclass: #NhCornuthaum
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmSuit subclass: #NhCrystalPlateMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmHelmet subclass: #NhDentedPot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmGem subclass: #NhDiamond
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmGem subclass: #NhDilithiumCrystal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmCreature subclass: #NhDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyBlackDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyBlueDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyGrayDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyGreenDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyOrangeDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyRedDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabySilverDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyWhiteDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhBabyYellowDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHelmet subclass: #NhDunceCap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDungeonBuilderState subclass: #NhDungeonBuilderState
	instanceVariableNames: 'branchNum branchName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Dungeon Builders'!
GmHumanoid subclass: #NhDwarf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhDwarfKing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhDwarfLord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHelmet subclass: #NhDwarvishIronHelm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmSuit subclass: #NhDwarvishMithrilCoat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmHumanoid subclass: #NhElfin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhElfin subclass: #NhElf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhElfin subclass: #NhElfLord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHelmet subclass: #NhElvenLeatherHelm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmSuit subclass: #NhElvenMithrilCoat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmGem subclass: #NhEmerald
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmHelmet subclass: #NhFedora
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmGem subclass: #NhFluorite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmCreature subclass: #NhFlyingThing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFlyingThing subclass: #NhBat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFlyingThing subclass: #NhCrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmCreature subclass: #NhFogCloud
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmToolUser subclass: #NhForestCentaur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
Object subclass: #NhGame
	instanceVariableNames: 'dungeon view player creatureManager stuffManager mapThisTurn debugMode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Game'!

!NhGame commentStamp: 'cr 3/11/2005 14:57' prior: 0!
The game object.  Each instance represents a game in play.

!

GmGem subclass: #NhGarnet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
NhFlyingThing subclass: #NhGiantBat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhGnomoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGnomoid subclass: #NhGnome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGnomoid subclass: #NhGnomeKing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGnomoid subclass: #NhGnomeLord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhGoblinoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGoblinoid subclass: #NhGoblin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmToolUser subclass: #NhGoldenNagaHatchling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmCreature subclass: #NhGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGolem subclass: #NhGlassGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmDragonSuit subclass: #NhGrayDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhGrayDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhGreenDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhGreenDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhElfin subclass: #NhGreenElf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhElfin subclass: #NhGreyElf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmToolUser subclass: #NhGuardianNagaHatchling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmBoots subclass: #NhHighBoots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhGoblinoid subclass: #NhHillOrc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhHobbit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGoblinoid subclass: #NhHobgoblin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhHuman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmBoolStat subclass: #NhHungover
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Stats'!
GmCreature subclass: #NhImp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmCreature subclass: #NhInsect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhInsect subclass: #NhCaveSpider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhInsect subclass: #NhGiantAnt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhInsect subclass: #NhGiantBeetle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGolem subclass: #NhIronGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmBoots subclass: #NhIronShoes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmGem subclass: #NhJade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmGem subclass: #NhJasper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmHumanoid subclass: #NhKoboldoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhKoboldoid subclass: #NhKobold
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhKoboldoid subclass: #NhKoboldLord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhKoboldoid subclass: #NhLargeKobold
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhLeatherArmor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmGloves subclass: #NhLeatherGloves
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmSuit subclass: #NhLeatherJacket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhImp subclass: #NhLemure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmBoots subclass: #NhLowBoots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhImp subclass: #NhManes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhDragon subclass: #NhMauveDragon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmCreature subclass: #NhMinorDemon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhMinotaur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmCreature subclass: #NhMisc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!

!NhMisc commentStamp: 'cr 3/11/2005 21:40' prior: 0!
This is a base class for stuff I don't know what to do with.  This class should eventually
be eliminated.
!

NhMisc subclass: #NhApe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhCarnivorousApe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhGargoyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhGlassPiercer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhIronPiercer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGoblinoid subclass: #NhMordorOrc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmToolUser subclass: #NhMountainCentaur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhDwarfMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhElfMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhEttinMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhGiantMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhGnomeMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhHumanMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhKoboldMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhOgroid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhOgroid subclass: #NhOgre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhOgroid subclass: #NhOgreKing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhOgroid subclass: #NhOgreLord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmGem subclass: #NhOpal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmDragonSuit subclass: #NhOrangeDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhOrangeDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhGoblinoid subclass: #NhOrc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGoblinoid subclass: #NhOrcCaptain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMummy subclass: #NhOrcMummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhOrcishChainMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmHelmet subclass: #NhOrcishHelm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmSuit subclass: #NhOrcishRingMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmPants subclass: #NhPantsOfYendor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhGolem subclass: #NhPaperGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmToolUser subclass: #NhPlainsCentaur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhPlateMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmCreature subclass: #NhQuadruped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhQuadruped subclass: #NhCanid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhCoyote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhDingo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhDog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhQuadruped subclass: #NhFeline
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhFox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFeline subclass: #NhHousecat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhJackal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFeline subclass: #NhJaguar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFeline subclass: #NhKitten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFeline subclass: #NhLargeCat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhLargeDog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhQuadruped subclass: #NhLargeQuadruped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhBaluchitherium
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhHorse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhLeocrotta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhLittleDog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhMastodon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhMumak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhPony
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhInsect subclass: #NhQueenBee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFlyingThing subclass: #NhRaven
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmDragonSuit subclass: #NhRedDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhRedDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmToolUser subclass: #NhRedNagaHatchling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhRingMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmRing subclass: #NhRingOfCharisma
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmRing subclass: #NhRingOfConstitution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmRing subclass: #NhRingOfDexterity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmRing subclass: #NhRingOfIntelligence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmRing subclass: #NhRingOfStrength
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmRing subclass: #NhRingOfStudliness
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
GmRing subclass: #NhRingOfWisdom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Rings'!
NhMisc subclass: #NhRockPiercer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhQuadruped subclass: #NhRodent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhRodent subclass: #NhDevilBunny
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhRodent subclass: #NhGiantRat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhRodent subclass: #NhRockMole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGolem subclass: #NhRopeGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhRothe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmGem subclass: #NhRuby
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmGem subclass: #NhSapphire
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
NhMisc subclass: #NhSasquatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhRodent subclass: #NhSewerRat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhShade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmDragonSuit subclass: #NhSilverDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhSilverDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhInsect subclass: #NhSoldierAnt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhSplintMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhGolem subclass: #NhStoneGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhGolem subclass: #NhStrawGolem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmSuit subclass: #NhStuddedLeatherArmor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmStuffManager subclass: #NhStuffManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-State Managers'!
NhImp subclass: #NhTengu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhFeline subclass: #NhTiger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhTitanothere
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmGem subclass: #NhTopaz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
GmToolUser subclass: #NhTrolloid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhTrolloid subclass: #NhOlogHai
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhTrolloid subclass: #NhTroll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmGem subclass: #NhTurquoise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Gems'!
NhGoblinoid subclass: #NhUrukHai
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhWarg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhWarhorse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmDragonSuit subclass: #NhWhiteDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhWhiteDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhMisc subclass: #NhWingedGargoyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhCanid subclass: #NhWolf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhRodent subclass: #NhWoodchuck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhElfin subclass: #NhWoodlandElf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhWumpus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhMisc subclass: #NhXorn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmDragonSuit subclass: #NhYellowDragonScaleMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
GmDragonSuit subclass: #NhYellowDragonScales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Armour'!
NhMisc subclass: #NhYeti
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
GmHumanoid subclass: #NhZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhDwarfZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhElfZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhEttinZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhGhoul
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhGiantZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhGnomeZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhHumanZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhKoboldZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhOrcZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhZombie subclass: #NhSkeleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
NhLargeQuadruped subclass: #NhZruty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Objects-Creatures'!
Prefab subclass: #RoguelikeMapDisplay
	instanceVariableNames: 'characters font highlightPoint '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!
Object subclass: #SimpleGUI
	instanceVariableNames: 'game manager panel controlPanel messagePanel maxMsgLines tileExtentCache keyTranslationTable statDict map seenLevels monsterPoints '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjHack-Display'!
SimpleGUI class
	instanceVariableNames: 'cachedMapPanel '!

!BlockContext methodsFor: '*ObjHack-evaluating' stamp: 'cr 3/6/2005 16:22'!
valueMaybeWith: arg
	self numArgs = 0
		ifTrue: [^self value]
		ifFalse: [^self value: arg].
! !


!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 3/5/2005 23:08'!
ifChoicePickOneOr: cancelBlock withCaption: caption
	self size = 1 ifTrue: [^self anyOne].
	^self pickOneOr: cancelBlock withCaption: caption.
		! !

!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 3/5/2005 18:57'!
pickOneOr: cancelBlock
	^self pickOneOr: cancelBlock withCaption: 'Pick an item:'.
! !

!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 4/3/2005 15:12'!
pickOneOr: cancelBlock withCaption: caption
	^self pickOneOr: cancelBlock withCaption: caption ifMatches: [ :i | false] addLabel: ''.

"
	| list labels index |
	self isEmpty ifTrue: [^cancelBlock value].

	list := self asOrderedCollection.
	labels := (list collect: [ :item | item descriptionString]), #('Cancel').
	
	index := (PopUpMenu labelArray: labels lines: {list size}) startUpWithCaption: caption.
	(list includesIndex: index)	""I may not be able to trust PopUpMenu""
		ifFalse: [^cancelBlock value]
		ifTrue: [^list at: index].
"! !

!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 4/3/2005 00:09'!
pickOneOr: cancelBlock withCaption: caption ifMatches: testBlock addLabel: labelAdded
	| list labels index |
	self isEmpty ifTrue: [^cancelBlock value].

	list := self asOrderedCollection.
	labels := list withIndexCollect: [ :item :ndx |
		ndx asString, ' ', (	(testBlock valueMaybeWith: item)
								ifTrue: [item descriptionString, labelAdded]
								ifFalse: [item descriptionString])
	].

	labels add: 'Cancel'.
	
	index := (PopUpMenu labelArray: labels lines: {list size}) startUpWithCaption: caption.
	(list includesIndex: index)	"I may not be able to trust PopUpMenu"
		ifFalse: [^cancelBlock value]
		ifTrue: [^list at: index].
! !

!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 3/5/2005 22:55'!
pickOneWithCaption: caption
	^self pickOneOr: [^nil] withCaption: caption! !

!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 3/6/2005 20:15'!
pickOneWithFirst: anElement appending: firstLabel withCaption: caption or: cancelBlock

	^self pickOneOr: cancelBlock withCaption: 'Pick an item:'.
! !

!Collection methodsFor: '*ObjHack-GUI' stamp: 'cr 4/3/2005 00:11'!
pickWeaponWhileHolding: wielded withCaption: caption or: cancelBlock
	"Let the user select a weapon to wield, assuming that wielded already contains weapons
	 being wielded and thus means the same as cancel.  Also adds a 'bare hands' option."
	| list labels index wieldedOrdered |

	"Blech!! This code needs to be cleaned up."

	(self isEmpty and: [wielded isEmpty]) ifTrue: [^cancelBlock value].

	wieldedOrdered := wielded asOrderedCollection.

	list := self asOrderedCollection copyWithoutAll: wielded.
	labels := (list withIndexCollect: [ :item :ndx | ndx asString, ' ', item descriptionString]),
				 #('Nothing' 'Cancel').
	list addAllFirst: wieldedOrdered.
	labels addAllFirst: (wieldedOrdered collect: [ :item | item descriptionString, ' (wielded)']).

	"this is so that we return nil for bare-handed."
	list add: nil.	

	index := (PopUpMenu labelArray: labels lines: {list size - 1. list size}) startUpWithCaption: caption.
	(list includesIndex: index)	"I may not be able to trust PopUpMenu"
		ifTrue: [^list at: index]
		ifFalse: [^cancelBlock value].
! !

!Collection methodsFor: '*ObjHack-printing' stamp: 'cr 3/8/2005 23:17'!
contentsString
	self size = 1 ifTrue: [^self anyOne asString].
	^self allButFirst inject: self first into: [ :result :item  | result, ', ', item asString]! !

!Collection methodsFor: '*ObjHack-printing' stamp: 'cr 3/6/2005 00:03'!
objDescriptionListString
	^(self collect: [ :obj | obj descriptionString]) contentsString! !

!Collection methodsFor: '*ObjHack-debugging' stamp: 'cr 4/2/2005 23:38'!
showHistogram
	GraphMorph new 
		data: (self asBag sortedElements collect: [ :assoc | assoc value]);
		openInWorld.
! !


!GmAbstractCreatureBrain methodsFor: 'initialization' stamp: 'cr 3/3/2005 14:57'!
for: aCreature
	owner := aCreature.
! !

!GmAbstractCreatureBrain methodsFor: 'stimulus' stamp: 'cr 3/3/2005 15:04'!
notify: aNotification
	^self subclassResponsibility
! !

!GmAbstractCreatureBrain methodsFor: 'response' stamp: 'cr 3/3/2005 15:02'!
makeMove
	^self subclassResponsibility
! !

!GmAbstractCreatureBrain methodsFor: 'constants' stamp: 'cr 3/10/2005 23:27'!
directions
	^#('north' 'south' 'east' 'west' 'northEast' 'northWest' 'southEast' 'southWest')! !

!GmAbstractCreatureBrain methodsFor: 'tests' stamp: 'cr 3/10/2005 03:02'!
isPlayerBrain
	^false
! !


!GmAbstractCreatureBrain class methodsFor: 'instance creation' stamp: 'cr 3/3/2005 14:58'!
for: aCreature
	^self new for: aCreature.
! !


!GmAction methodsFor: 'core protocol' stamp: 'cr 3/9/2005 14:37'!
applyTo: rcpt
	^self applyTo: rcpt with: nil! !

!GmAction methodsFor: 'core protocol' stamp: 'cr 4/3/2005 23:08'!
applyTo: rcpt with: arg
	| actionResult |
	self recipient: rcpt.
	self argument: arg.

	actionResult := self doAction.
"	self informRecipient."		"do from doAction"
	^actionResult.		
! !

!GmAction methodsFor: 'accessing' stamp: 'cr 3/9/2005 14:28'!
argument
	^argument! !

!GmAction methodsFor: 'accessing' stamp: 'cr 3/9/2005 14:28'!
argument: newValue
	argument := newValue! !

!GmAction methodsFor: 'accessing' stamp: 'cr 3/9/2005 14:26'!
doer
	^doer! !

!GmAction methodsFor: 'accessing' stamp: 'cr 3/9/2005 14:26'!
doer: newValue
	doer := newValue! !

!GmAction methodsFor: 'accessing' stamp: 'cr 3/9/2005 14:26'!
recipient
	^recipient! !

!GmAction methodsFor: 'accessing' stamp: 'cr 3/9/2005 14:26'!
recipient: newValue
	recipient := newValue! !

!GmAction methodsFor: 'overrides' stamp: 'cr 3/9/2005 14:34'!
recipientNotification
	"This is what tells the recipient that it's being acted on."
	^self subclassResponsibility.
! !

!GmAction methodsFor: 'actions' stamp: 'cr 3/9/2005 14:38'!
doAction
	^self subclassResponsibility
! !

!GmAction methodsFor: 'actions' stamp: 'cr 3/9/2005 14:33'!
informRecipient
	recipient inform: self recipientNotification.
! !


!GmAction class methodsFor: 'instance creation' stamp: 'cr 3/9/2005 23:25'!
doer: theDoer
	^self new
		doer: theDoer;
		yourself.
! !


!GmAttack methodsFor: 'notifications' stamp: 'cr 4/3/2005 00:18'!
rcptHitHarmlesslyNotification
	^GmAttackedUnsuccessfully theCreature: self doer does: 'hits, but the blow glances off.'! !

!GmAttack methodsFor: 'notifications' stamp: 'cr 4/2/2005 23:13'!
rcptHitNotification
	^GmAttacked theCreature: self doer does: self attacksMessage.
! !

!GmAttack methodsFor: 'notifications' stamp: 'cr 4/2/2005 13:49'!
rcptMissedNotification
	^GmAttackedUnsuccessfully theCreature: self doer does: 'swings at you but misses'.
! !

!GmAttack methodsFor: 'notifications' stamp: 'cr 4/2/2005 13:54'!
recipientNotification
	^recipientNotification
		ifNil: [
			"We shouldn't get here.  If we do, indicate failure but return a
			 stealth debug message."
			GmAttackedUnsuccessfully theCreature: doer does: 'glares at you.'
		].! !

!GmAttack methodsFor: 'notifications' stamp: 'cr 4/3/2005 23:13'!
setRcptNotificationForDamage: damage
	recipientNotification := 
		damage > 0
			ifTrue: [self rcptHitNotification]
			ifFalse: [self rcptHitHarmlesslyNotification].
! !

!GmAttack methodsFor: 'utility' stamp: 'cr 4/3/2005 22:38'!
attacksMessage
	^'hits you', (self weapon ifNil: ['.'] ifNotNil: [' with ', self weapon descriptionString]).
! !

!GmAttack methodsFor: 'utility' stamp: 'cr 4/2/2005 23:13'!
weapon
	^nil		"so that attacksMessage will work."! !

!GmAttack methodsFor: 'rolls' stamp: 'cr 4/2/2005 23:55'!
canHitTarget
	^(doer toHitRating d: doer atStatDexterity) > (1 d: recipient atStatDexterity)! !

!GmAttack methodsFor: 'rolls' stamp: 'cr 4/2/2005 22:55'!
damageAmount
	^doer atStatStrength d: self doerDamageRating * 3.
! !

!GmAttack methodsFor: 'rolls' stamp: 'cr 4/3/2005 15:04'!
defenseRoll
	^recipient atStatArmorClass atRandom - 1.! !

!GmAttack methodsFor: 'rolls' stamp: 'cr 4/3/2005 23:14'!
doDamage
	| damage |
	damage := self damageAmount - self defenseRoll.

	self setRcptNotificationForDamage: damage.
	self informRecipient.

	damage > 0
		ifTrue: [recipient statHitPoints subtract: damage].
! !

!GmAttack methodsFor: 'actions' stamp: 'cr 4/3/2005 15:34'!
doAction

	self canHitTarget
		ifFalse: [
			recipientNotification := self rcptMissedNotification.
			^GmMissed creature: recipient
		].

	self doDamage.

	recipient isDead
		ifTrue: [^GmKilledTarget creature: recipient]
		ifFalse: [^GmHitTarget creature: recipient]
! !

!GmAttack methodsFor: 'debug' stamp: 'cr 4/3/2005 15:25'!
averageDamage
	"Return the average damage this attack will do."
	^((1 to: 100000) collect: [ :x | self defenseRoll asFloat max: 0]) average! !

!GmAttack methodsFor: 'debug' stamp: 'cr 4/3/2005 15:22'!
canHitFraction
	"Return the probability that canHitTarget will return true."
	^((1 to: 10000) collect: [ :x | self canHitTarget ifTrue: [1.0] ifFalse: [0]]) average! !


!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:56'!
addDefaultStatsAc: ac level: level damage: damage toHit: th
	| code |
	code := 'initialStatValues\	^super initialStatValues,\	{\'.

	code := code, '		GmStrength		-> ', (level + 4 min: 18) printString, '.\'.
	code := code, '		GmConstitution	-> ', (level + damage min: 18) printString, '.\'.
	code := code, '		GmExperience	-> ', level printString, '.\'.
	code := code, '		GmDexterity		-> ', (level + 6 min: 18) printString, '.\'.
	code := code, '	}.\'.

	^code withCRs.! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:57'!
constMethodNamed: mthName string: str
	^(mthName, '\	^', str, '\') withCRs

! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:57'!
constMethodNamed: mthName value: val
	^(mthName, '\	^', val printString, '\') withCRs

! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:57'!
creationTestForLevel: level
	^('canCreateIn: aMap\	^aMap level >= ', level printString, '\') withCRs.

! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:57'!
makeClass: newName
	^self subclass: ('Nh', newName wordsToStudlyCaps) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ObjHack-Objects-Creatures'.
! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 05:48'!
makeClassForCreature: newName subclassOf: baseClass
	^baseClass subclass: ('Nh', newName wordsToStudlyCaps) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ObjHack-Objects-Creatures'.
! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 05:53'!
makeCreatureClassTo: item

	"

	WARNING!!!!!!	WARNING!!!!!!		WARNING!!!!!!		WARNING!!!!!!

	This method will (re)create classes, destroying any modifications.

	It takes an entry from munged Nethack monster list in #monsterList
	and generates a class from it.  Rerunning this will overwrite that class.

	"

	| baseClass symbol level ac damage toHit newClass creatureName |
	baseClass := item first.
	symbol := item second.
	creatureName := item third.
	level := item fourth.
	ac := item fifth.

	damage := item last first.
	toHit := item last last.

	newClass := self makeClassForCreature: creatureName subclassOf: baseClass.
	self addAsciiTileMethodTo: newClass class for: symbol and: creatureName.
	newClass class compile: (self constMethodNamed: 'isConcrete' value: true) 
					classified: 'object management stats'.

	newClass compile: (self constMethodNamed: 'damageRating' value: damage)
					classified: 'attributes'.
	newClass compile: (self constMethodNamed: 'toHitValue' value: toHit)
					classified: 'attributes'.
	newClass compile: (self constMethodNamed: 'experienceValue' value: (level + 1) * 40)
					classified: 'attributes'.

	newClass class compile: (self constMethodNamed: 'minCreationLevel' value: level)
					classified: 'object management stats'.

	newClass class compile: (self addDefaultStatsAc: ac level: level + 1 damage: damage toHit: toHit)
					classified: 'stat defaults'.


	^newClass
! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:57'!
makeSubclassTo: item

	"

	WARNING!!!!!!	WARNING!!!!!!		WARNING!!!!!!		WARNING!!!!!!

	This method will (re)create classes, destroying any modifications.

	It takes an entry from munged Nethack monster list in #monsterList
	and generates a class from it.  Rerunning this will overwrite that class.

	"

	| baseClass symbol level ac damage toHit newClass creatureName |
	baseClass := item first.
	symbol := item second.
	creatureName := item third.
	level := item fourth.
	ac := item fifth.

	damage := item last first.
	toHit := item last last.

	newClass := baseClass makeClass: creatureName.
	newClass addAsciiTileMethodFor: symbol and: creatureName.
	newClass class compile: (self constMethodNamed: 'isConcrete' value: true) 
					classified: 'object management stats'.

	newClass compile: (self constMethodNamed: 'damageRating' value: damage)
					classified: 'attributes'.
	newClass compile: (self constMethodNamed: 'toHitValue' value: toHit)
					classified: 'attributes'.
	newClass compile: (self constMethodNamed: 'experienceValue' value: (level + 1) * 40)
					classified: 'attributes'.

	newClass class compile: (self constMethodNamed: 'minCreationLevel' value: level)
					classified: 'object management stats'.

	newClass class compile: (self addDefaultStatsAc: ac level: level + 1 damage: damage toHit: toHit)
					classified: 'stat defaults'.

	[baseClass. symbol. creatureName. level. ac. damage. toHit.].	"suppress warnings"

	^newClass
! !

!GmBuilderHack methodsFor: 'all' stamp: 'cr 3/12/2005 02:57'!
monsterList
"letter name level ac attacks"
^{
"superclass tile descripton level AC {damage-value to-hit-value}"

{NhInsect. $a. 'giant ant'. 2. 3. {1. 4}}.
{NhInsect. $a. 'soldier ant'. 3. 3. 2. {3. 4}}.
{NhInsect. $a. 'giant beetle'. 5. 4. {3. 6}}.
{NhInsect. $a. 'queen bee'. 9. -4. {1. 8}}.
{NhCanid. $d. 'jackal'. 0. 7. {1. 2}}.
{NhCanid. $d. 'fox'. 0. 7. {1. 3}}.
{NhCanid. $d. 'coyote'. 1. 7. {1. 4}}.
{NhCanid. $d. 'little dog'. 2. 6. {1. 6}}.
{NhCanid. $d. 'dog'. 4. 5. {1. 6}}.
{NhCanid. $d. 'large dog'. 6. 4. {2. 4}}.
{NhCanid. $d. 'dingo'. 4. 5. {1. 6}}.
{NhCanid. $d. 'wolf'. 5. 4. {2. 4}}.
{NhCanid. $d. 'warg'. 7. 4. {2. 6}}.
{NhFeline. $f. 'kitten'. 2. 6. {1. 6}}.
{NhFeline. $f. 'housecat'. 4. 5. {1. 6}}.
{NhFeline. $f. 'jaguar'. 4. 6. {1. 8}}.
{NhFeline. $f. 'large cat'. 6. 4. {2. 4}}.
{NhFeline. $f. 'tiger'. 6. 6. {1.10}}.
{NhMisc. $g. 'gargoyle'. 6. -4. {2. 4}}.
{NhMisc. $g. 'winged gargoyle'. 9. -2. {3. 4}}.
{GmHumanoid. $h. 'hobbit'. 1. 10. {1. 6}}.
{GmHumanoid. $h. 'dwarf'. 2. 10. {1. 8}}.
{GmHumanoid. $h. 'bugbear'. 3. 5. {2. 4}}.
{GmHumanoid. $h. 'dwarf lord'. 4. 10. 2. {2. 4}}.
{GmHumanoid. $h. 'dwarf king'. 6. 10. 2. {2. 6}}.
{NhImp. $i. 'manes'. 1. 7. 1. 1. {1. 4}}.
{NhImp. $i. 'lemure'. 3. 7. {1. 3}}.
{NhImp. $i. 'tengu'. 6. 5. {1. 7}}.
{NhKoboldoid. $k. 'kobold'. 0. 10. {1. 4}}.
{NhKoboldoid. $k. 'large kobold'. 1. 10. {1. 6}}.
{NhKoboldoid. $k. 'kobold lord'. 2. 10. {2. 4}}.
{NhGoblinoid. $o. 'goblin'. 0. 10. {1. 4}}.
{NhGoblinoid. $o. 'hobgoblin'. 1. 10. {1. 6}}.
{NhGoblinoid. $o. 'orc'. 1. 10. {1. 8}}.
{NhGoblinoid. $o. 'hill orc'. 2. 10. {1. 6}}.
{NhGoblinoid. $o. 'Mordor orc'. 3. 10. {1. 6}}.
{NhGoblinoid. $o. 'Uruk-hai'. 3. 10. {1. 8}}.
{NhGoblinoid. $o. 'orc-captain'. 5. 10. 2. {2. 4}}.
{NhMisc. $p. 'rock piercer'. 3. 3. {2. 6}}.
{NhMisc. $p. 'iron piercer'. 5. 0. {3. 6}}.
{NhMisc. $p. 'glass piercer'. 7. 0. {4. 6}}.
{NhLargeQuadruped. $q. 'rothe'. 2. 7. 1. 1. {1. 8}}.
{NhLargeQuadruped. $q. 'mumak'. 5. 0. 4. {2. 6}}.
{NhLargeQuadruped. $q. 'leocrotta'. 6. 4. 2. 2. {2. 6}}.
{NhLargeQuadruped. $q. 'wumpus'. 8. 2. {3. 6}}.
{NhLargeQuadruped. $q. 'titanothere'. 12. 6. {2. 8}}.
{NhLargeQuadruped. $q. 'baluchitherium'. 14. 5. {5. 4}}.
{NhLargeQuadruped. $q. 'mastodon'. 20. 5. {4. 8}}.
{NhRodent. $r. 'sewer rat'. 0. 7. {1. 3}}.
{NhRodent. $r. 'giant rat'. 1. 7. {1. 3}}.
{NhRodent. $r. 'rock mole'. 3. 0. {1. 6}}.
{NhRodent. $r. 'woodchuck'. 3. 0. {1. 6}}.
{NhInsect. $s. 'cave spider'. 1. 3. {1. 2}}.
{NhLargeQuadruped. $u. 'pony'. 3. 6. 1. {1. 2}}.
{NhLargeQuadruped. $u. 'horse'. 5. 5. 1. {1. 3}}.
{NhLargeQuadruped. $u. 'warhorse'. 7. 4. 1. {1. 4}}.
{GmCreature. $v. 'fog cloud'. 3. 0. {1. 6}}.
{NhLargeQuadruped. $z. 'zruty'. 9. 3. 3. 3. {3. 6}}.
{NhFlyingThing. $B. 'bat'. 0. 8. {1. 4}}.
{NhFlyingThing. $B. 'giant bat'. 2. 7. {1. 6}}.
{NhFlyingThing. $B. 'raven'. 4. 6. 1. {1. 6}}.
{GmToolUser. $C. 'plains centaur'. 4. 4. 1. {1. 6}}.
{GmToolUser. $C. 'forest centaur'. 5. 3. 1. {1. 6}}.
{GmToolUser. $C. 'mountain centaur'. 6. 2. 1. 1. {1. 6}}.
{NhDragon. $D. 'baby gray dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby silver dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby red dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby white dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby orange dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby black dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby blue dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby green dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'baby yellow dragon'. 12. 2. {2. 6}}.
{NhDragon. $D. 'mauve dragon'. 15. -1. {8. 6}}.
{NhGnomoid. $G. 'gnome'. 1. 10. {1. 6}}.
{NhGnomoid. $G. 'gnome lord'. 3. 10. {1. 8}}.
{NhGnomoid. $G. 'gnome king'. 5. 10. {2. 6}}.
{GmHumanoid. $H. 'minotaur'. 15. 6. 3. 3. {2. 8}}.
{NhMummy. $M. 'kobold mummy'. 3. 6. {1. 4}}.
{NhMummy. $M. 'gnome mummy'. 4. 6. {1. 6}}.
{NhMummy. $M. 'orc mummy'. 5. 5. {1. 6}}.
{NhMummy. $M. 'dwarf mummy'. 5. 5. {1. 6}}.
{NhMummy. $M. 'elf mummy'. 6. 4. {2. 4}}.
{NhMummy. $M. 'human mummy'. 6. 4. 2. {2. 4}}.
{NhMummy. $M. 'ettin mummy'. 7. 4. 2. {2. 6}}.
{NhMummy. $M. 'giant mummy'. 8. 3. 3. {3. 4}}.
{GmToolUser. $N. 'red naga hatchling'. 3. 6. {1. 4}}.
{GmToolUser. $N. 'black naga hatchling'. 3. 6. {1. 4}}.
{GmToolUser. $N. 'golden naga hatchling'. 3. 6. {1. 4}}.
{GmToolUser. $N. 'guardian naga hatchling'. 3. 6. {1. 4}}.
{NhOgroid. $O. 'ogre'. 5. 5. {2. 5}}.
{NhOgroid. $O. 'ogre lord'. 7. 3. {2. 6}}.
{NhOgroid. $O. 'ogre king'. 9. 4. {3. 5}}.
{NhTrolloid. $T. 'troll'. 7. 4. 4. 4. {2. 6}}.
{NhTrolloid. $T. 'Olog-hai'. 13. -4. 2. 3. {2. 6}}.
{NhMisc. $X. 'xorn'. 8. -2. 1. 1. 1. {4. 6}}.
{NhMisc. $Y. 'ape'. 4. 6. 1. 1. {1. 6}}.
{NhMisc. $Y. 'yeti'. 5. 6. 1. 1. {1. 4}}.
{NhMisc. $Y. 'carnivorous ape'. 6. 6. 1. 1. {1. 8}}.
{NhMisc. $Y. 'sasquatch'. 7. 6. {1. 8}}.
{NhZombie. $Z. 'kobold zombie'. 0. 10. {1. 4}}.
{NhZombie. $Z. 'gnome zombie'. 1. 10. {1. 5}}.
{NhZombie. $Z. 'orc zombie'. 2. 9. {1. 6}}.
{NhZombie. $Z. 'dwarf zombie'. 2. 9. {1. 6}}.
{NhZombie. $Z. 'elf zombie'. 3. 9. {1. 7}}.
{NhZombie. $Z. 'human zombie'. 4. 8. {1. 8}}.
{NhZombie. $Z. 'ettin zombie'. 6. 6. 1. {1. 10}}.
{NhZombie. $Z. 'giant zombie'. 8. 6. 2. {2. 8}}.
{NhZombie. $Z. 'ghoul'. 3. 10. {1. 2}}.
{NhZombie. $Z. 'skeleton'. 12. 4. {1. 6}}.
{NhGolem. $'. 'straw golem'. 3. 10. {1. 2}}.
{NhGolem. $'. 'paper golem'. 3. 10. {1. 3}}.
{NhGolem. $'. 'rope golem'. 4. 8. {6. 1}}.
{NhGolem. $'. 'stone golem'. 14. 5. {3. 8}}.
{NhGolem. $'. 'glass golem'. 16. 1. {2. 8}}.
{NhGolem. $'. 'iron golem'. 18. 3. {4. 6}}.
{NhElfin. $@. 'elf'. 10. 10. {1. 8}}.
{NhElfin. $@. 'Woodland-elf'. 4. 10. {2. 4}}.
{NhElfin. $@. 'Green-elf'. 5. 10. {2. 4}}.
{NhElfin. $@. 'Grey-elf'. 6. 10. {2. 4}}.
{NhElfin. $@. 'elf-lord'. 8. 10. 2. {2. 4}}.
{NhMisc. Character space. 'ghost'. 10. -5. {1. 1}}.
{NhMisc. Character space. 'shade'. 12. 10. {2. 6}}
}.! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 02:56'!
addAsciiTileMethodTo: aClass for: tile and: description

	| code |
	code := 'asciiObjectDescription\	^GmAsciiObjectDescription letter: ', tile printString,
		' color: Color black name: ', description printString, '\\'.
	aClass compile: code withCRs classified: 'ascii tiles'
! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 03:37'!
gemList
^
{
{'dilithium crystal'.     4500}.
{'diamond'.               4000}.
{'sapphire'.              3000}.
{'emerald'.               2500}.
{'turquoise'.             2000}.
{'aquamarine'.            1500}.
{'amber'.                 1000}.
{'topaz'.                  900}.
{'opal'.                   800}.
{'garnet'.                 700}.
{'amethyst'.               600}.
{'jasper'.                 500}.
{'fluorite'.               400}.
{'jade'.                   300}
}.
! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 03:50'!
makeClass: newName subclassOf: baseClass
	^baseClass subclass: ('Nh', newName wordsToStudlyCaps) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ObjHack-Objects-Gems'.
! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 03:52'!
makeGemClass: item

	"

	WARNING!!!!!!	WARNING!!!!!!		WARNING!!!!!!		WARNING!!!!!!

	This method will (re)create classes, destroying any modifications.

	It takes an entry from munged Nethack monster list in #monsterList
	and generates a class from it.  Rerunning this will overwrite that class.

	"

	| newClass  |
	newClass := self makeClass: item first subclassOf: GmGem.
	self addAsciiTileMethodTo: newClass class for: $* and: item first.

	newClass class compile: (self constMethodNamed: 'isConcrete' value: true) 
					classified: 'object management stats'.

	newClass compile: (self constMethodNamed: 'pointValue' value: item second)
					classified: 'type info'.
	^newClass
! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 04:15'!
makeRingClass: attrName

	"

	WARNING!!!!!!	WARNING!!!!!!		WARNING!!!!!!		WARNING!!!!!!

	This method will (re)create classes, destroying any modifications.

	It takes an entry from munged Nethack monster list in #monsterList
	and generates a class from it.  Rerunning this will overwrite that class.

	"

	| newClass  name |

	name := 'ring of ', attrName unCapitalized.
	newClass := self makeRingClass: name subclassOf: GmRing.
	self addAsciiTileMethodTo: newClass class for: $= and: name.

	newClass class compile: (self constMethodNamed: 'isConcrete' value: true) 
					classified: 'object management stats'.

	newClass compile: (self constMethodNamed: (attrName unCapitalized, 'Mod') value: 3)
					classified: 'stat modifications'.

	GmThing compile:  (self constMethodNamed: (attrName unCapitalized, 'Mod') value: 0)
					classified: 'stat modifications'.
	^newClass
! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 04:15'!
makeRingClass: newName subclassOf: baseClass
	^baseClass subclass: ('Nh', newName wordsToStudlyCaps) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ObjHack-Objects-Rings'.
! !

!GmBuilderHack methodsFor: 'gems' stamp: 'cr 3/12/2005 04:08'!
ringTypes
 	^#('Strength' 'Wisdom' 'Intelligence' 'Dexterity' 'Constitution' 'Charisma').
! !

!GmBuilderHack methodsFor: 'armor' stamp: 'cr 3/12/2005 04:52'!
armorEntries

^ {
"base class   description           cost  AC"
{GmSuit. 'leather jacket'.             10. 1}.
{GmSuit. 'leather armor'.               5. 2}.
{GmSuit. 'orcish ring mail'.           80. 2}.
{GmSuit. 'studded leather armor'.      15. 3}.
{GmSuit. 'ring mail'.                 100. 3}.
{GmSuit. 'scale mail'.                 45. 4}.
{GmSuit. 'orcish chain mail'.          75. 4}.
{GmSuit. 'chain mail'.                 75. 5}.
{GmSuit. 'elven mithril coat'.        240. 5}.
{GmSuit. 'splint mail'.                80. 6}.
{GmSuit. 'banded mail'.                90. 6}.
{GmSuit. 'dwarvish mithril coat'.     240. 6}.
{GmSuit. 'bronze plate mail'.         400. 6}.
{GmSuit. 'plate mail'.                600. 7}.
{GmSuit. 'crystal plate mail'.        820. 7}.
{GmDragonSuit. 'red dragon scales'.         500. 3}.
{GmDragonSuit. 'white dragon scales'.       500. 3}.
{GmDragonSuit. 'orange dragon scales'.      500. 3}.
{GmDragonSuit. 'blue dragon scales'.        500. 3}.
{GmDragonSuit. 'green dragon scales'.       500. 3}.
{GmDragonSuit. 'yellow dragon scales'.      500. 3}.
{GmDragonSuit. 'black dragon scales'.       700. 3}.
{GmDragonSuit. 'silver dragon scales'.      700. 3}.
{GmDragonSuit. 'gray dragon scales'.        700. 3}.
{GmDragonSuit. 'red dragon scale mail'.     900. 9}.
{GmDragonSuit. 'white dragon scale mail'.   900. 9}.
{GmDragonSuit. 'orange dragon scale mail'.  900. 9}.
{GmDragonSuit. 'blue dragon scale mail'.    900. 9}.
{GmDragonSuit. 'green dragon scale mail'.   900. 9}.
{GmDragonSuit. 'yellow dragon scale mail'.  900. 9}.
{GmDragonSuit. 'black dragon scale mail'.  1200. 9}.
{GmDragonSuit. 'silver dragon scale mail'. 1200. 9}.
{GmDragonSuit. 'gray dragon scale mail'.   1200. 9}.
{GmHelmet. 'fedora'.                      1. 0}.
{GmHelmet. 'dunce cap'.                   1. 0}.
{GmHelmet. 'cornuthaum'.                 80. 0}.
{GmHelmet. 'dented pot'.                  8. 1}.
{GmHelmet. 'elven leather helm'.          8. 1}.
{GmHelmet. 'helmet'.            10. 1}.
{GmHelmet. 'orcish helm'.                10. 1}.
{GmHelmet. 'helm of brilliance'.         50. 1}.
{GmHelmet. 'hm of opposite alignment'.   50. 1}.
{GmHelmet. 'helm of telepathy'.          50. 1}.
{GmHelmet. 'dwarvish iron helm'.         20. 2}.
{GmGloves. 'leather gloves'.              8. 1}.
{GmBoots. 'low boots'.                   8. 1}.
{GmBoots. 'high boots'.                 12. 2}.
{GmBoots. 'iron shoes'.                 16. 2}
}.
! !

!GmBuilderHack methodsFor: 'armor' stamp: 'cr 3/12/2005 05:27'!
makeArmorClass: item

	"

	WARNING!!!!!!	WARNING!!!!!!		WARNING!!!!!!		WARNING!!!!!!

	This method will (re)create classes, destroying any modifications.

	It takes an entry from munged Nethack monster list in #monsterList
	and generates a class from it.  Rerunning this will overwrite that class.

	"

	| newClass  baseClass name cost ac |
	baseClass := item first.
	name := item second.
	cost := item third.
	ac := item fourth.

	self halt: 'these have been hand-modified.  Don''t rerun this.'.

	newClass := self makeClass: name subclassOf: baseClass.
	self addAsciiTileMethodTo: newClass class for: $[ and: name.

	newClass class compile: (self constMethodNamed: 'isConcrete' value: true) 
					classified: 'object management stats'.

	newClass class compile: (self constMethodNamed: 'minCreationLevel' value: cost // 100) 
					classified: 'object management stats'.

	newClass compile: (self constMethodNamed: 'armorClassMod' value: ac)
					classified: 'stat modifications'.
	^newClass
! !

!GmBuilderHack methodsFor: 'armor' stamp: 'cr 3/12/2005 04:54'!
makeClassForArmor: newName subclassOf: baseClass
	^baseClass subclass: ('Nh', newName wordsToStudlyCaps) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ObjHack-Objects-Armor'.
! !

!GmBuilderHack methodsFor: 'broken' stamp: 'cr 3/12/2005 02:56'!
addAsciiTileMethodFor: tile and: description

	| code |
	code := 'asciiObjectDescription\	^GmAsciiObjectDescription letter: ', tile printString,
		' color: Color black name: ', description printString, '\\'.
	self class compile: code withCRs classified: 'ascii tiles'
! !


!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 19:04'!
clear
	self item: nil.
! !

!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 17:15'!
item
	^item! !

!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 17:15'!
item: newValue
	item := newValue! !

!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 17:15'!
name
	^name! !

!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 17:15'!
name: newValue
	name := newValue! !

!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 17:41'!
type
	^type! !

!GmDeploymentSlot methodsFor: 'accessing' stamp: 'cr 3/6/2005 18:43'!
type: newValue

	[GmDeployments knownSlotTypeNames includes: newValue] assert.

	type := newValue.
! !

!GmDeploymentSlot methodsFor: 'tests' stamp: 'cr 3/6/2005 17:25'!
isEmpty
	^item isNil
! !


!GmDeploymentSlot class methodsFor: 'instance creation' stamp: 'cr 3/6/2005 19:04'!
name: n type: t
	^self new
		name: n;
		type: t;
		yourself.
! !


!GmDeployments methodsFor: 'initialization' stamp: 'cr 3/6/2005 16:37'!
initialize
	slots := OrderedCollection new.
! !

!GmDeployments methodsFor: 'deployment' stamp: 'cr 3/8/2005 00:27'!
deploy: aThing or: errorBlock
	| slot |
	(self isDeploying: aThing) ifTrue: [^errorBlock value: GmAlreadyUsed new].

	slot := self emptySlotFor: aThing or: [ :rsp | ^errorBlock value: rsp].
	slot item: aThing.
	^GmSilentSuccess new.
			! !

!GmDeployments methodsFor: 'deployment' stamp: 'cr 3/6/2005 16:25'!
undeploy: aThing or: errorBlock
	| slot |
	slot := self slotHolding: aThing or: [ :rsp | ^errorBlock valueMaybeWith: rsp].
	slot item: nil.
	^GmSilentSuccess new.
! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/12/2005 03:18'!
allInSlots
	^slots select: [ :sl | sl isEmpty not] thenCollect: [ :sl | sl item]! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/7/2005 17:40'!
allInSlots: slotTypeNames
	^slots select: [ :sl | sl item notNil and: [slotTypeNames includes: sl type]] thenCollect: [ :sl | sl item]! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/7/2005 23:31'!
allPutOn
	^self allInSlots: self class putOnSlotTypeNames! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/7/2005 17:59'!
allWielded
	^self allInSlots: self class wieldSlotTypeNames! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/7/2005 17:41'!
allWorn
	^self allInSlots: self class wearSlotTypeNames
! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/8/2005 00:28'!
isDeploying: aThing
	slots do: [ :slot | slot item == aThing ifTrue: [^true]].
	^false

	! !

!GmDeployments methodsFor: 'queries' stamp: 'cr 3/8/2005 16:54'!
sumOf: aBlock
	^slots inject: 0 into: [ :sum :slot | slot item ifNil: [sum] ifNotNil: [sum + aBlock value: slot item]]
! !

!GmDeployments methodsFor: 'slots' stamp: 'cr 3/6/2005 16:38'!
addSlot: aDeploymentSlot
	slots add: aDeploymentSlot.
! !

!GmDeployments methodsFor: 'slots' stamp: 'cr 3/7/2005 14:32'!
emptySlotFor: aThing or: errorBlock
	| canSlot |
	canSlot := false.
	slots do: [ :slot | ((aThing fitsInSlot: slot) and: [canSlot := true. slot isEmpty]) ifTrue: [^slot]].
	^errorBlock valueMaybeWith: (canSlot ifTrue: [GmNoSlotsLeft] ifFalse: [GmImpossible]) new.
! !

!GmDeployments methodsFor: 'slots' stamp: 'cr 3/6/2005 19:50'!
slotHolding: aThing or: errorBlock
	slots do: [ :slot | slot item == aThing ifTrue: [^slot]].
	^errorBlock valueMaybeWith: (GmDontHave item: aThing).! !


!GmDeployments class methodsFor: 'instance creation' stamp: 'cr 3/6/2005 19:06'!
new
	^self basicNew initialize
! !

!GmDeployments class methodsFor: 'instance creation' stamp: 'cr 3/6/2005 19:40'!
newForHumanoid
	^self fromDescrArray: {

		"Wielding:"		
		{'weapon hand'. #wield}.

		"Wearing:"
		{'head'.			#head}.
		{'hands'.		#hands}.
		{'feet'.			#feet}.
		{'upper body'.	#upperBody}.
		{'lower body'.	#lowerBody}.

		"Putting on:"
		{'left hand'.		#finger}.
		{'right hand'.	#finger}.
		{'neck'.			#neck}
	}! !

!GmDeployments class methodsFor: 'constants' stamp: 'cr 3/6/2005 19:45'!
knownSlotTypeNames
	"The following is the list of slot type names that we're allowed to use."
	^self putOnSlotTypeNames, self wearSlotTypeNames, self wieldSlotTypeNames.! !

!GmDeployments class methodsFor: 'constants' stamp: 'cr 3/6/2005 19:44'!
putOnSlotTypeNames
	"The following is the list of slot type names that can be used to hold jewelry."
	^#(finger neck) ! !

!GmDeployments class methodsFor: 'constants' stamp: 'cr 3/6/2005 19:43'!
wearSlotTypeNames
	"The following is the list of slot type names that refer to clothing."
	^#(head hands feet upperBody lowerBody) ! !

!GmDeployments class methodsFor: 'constants' stamp: 'cr 3/6/2005 19:45'!
wieldSlotTypeNames
	"The following is the list of slot type names that refer to weapons."
	^#(wield)! !

!GmDeployments class methodsFor: 'private instance creation' stamp: 'cr 3/6/2005 19:03'!
fromDescrArray: descrArray
	| instance |
	instance := self new.
	descrArray
		do: [ :entry | instance addSlot: (GmDeploymentSlot name: entry first type: entry second)].
	^instance
! !


!GmDungeonBuilder methodsFor: 'initialization' stamp: 'cr 3/10/2005 04:11'!
game: theGame initialState: newState genManagers: mgrs
	self initialize.

	game := theGame.
	initialState := newState.
	genManagers := mgrs.
! !

!GmDungeonBuilder methodsFor: 'initialization' stamp: 'cr 3/5/2005 22:17'!
initialize
	progressCount := 0.
	genManagers := #().! !

!GmDungeonBuilder methodsFor: 'accessing' stamp: 'cr 2/26/2005 00:42'!
dungeon
	^dungeon! !

!GmDungeonBuilder methodsFor: 'dungeon creation' stamp: 'cr 2/25/2005 01:01'!
attachMap: map to: portal

	| entrance |
	portal 
		ifNil: [
			dungeon := map.
			^self.
		].

	entrance := portal endpointClass new.
	entrance endPoint: portal.
	map addPortal: entrance.
	! !

!GmDungeonBuilder methodsFor: 'dungeon creation' stamp: 'cr 2/26/2005 03:33'!
buildDungeon

	'    Constructing levels...    '
		displayProgressAt: Display extent // 2
		from: 0 to: initialState totalMapsToBeGenerated
		during: [:bar | self buildDungeonUpdating: bar].


! !

!GmDungeonBuilder methodsFor: 'dungeon creation' stamp: 'cr 2/26/2005 03:32'!
buildDungeonUpdating: barBlock
	progressCount := 0.
	progressBarBlock := barBlock.

	self generateLevel: initialState fromPortal: nil.

	progressBarBlock := nil.
! !

!GmDungeonBuilder methodsFor: 'dungeon creation' stamp: 'cr 3/12/2005 11:56'!
generateLevel: state fromPortal: portal
	| map |

	self updateProgressBar.

	map := (state mapGenerator mapExtent: state defaultMapExtent)
				buildMap;
				map.

	map
		creationState: state;
		game: game.

	self attachMap: map to: portal.
	genManagers do: [ :mgr | mgr setupMap: map].
	state finalChangesTo: map.

	self generateNextLevelFrom: map accordingTo: state! !

!GmDungeonBuilder methodsFor: 'dungeon creation' stamp: 'cr 2/25/2005 00:00'!
generateNextLevelFrom: map accordingTo: state

	state outPortalsHere withIndexDo: [ :portal :index | 
		map addPortal: portal.
		self generateLevel: (state nextLevelOnBranch: index) fromPortal: portal.
	]
! !

!GmDungeonBuilder methodsFor: 'progress' stamp: 'cr 2/26/2005 03:28'!
updateProgressBar

	progressCount := progressCount + 1.
	progressBarBlock 
		ifNotNil: [progressBarBlock value: progressCount].
! !


!GmDungeonBuilder class methodsFor: 'instance creation' stamp: 'cr 3/10/2005 04:10'!
inGame: game withState: state genManagers: mgrs
	^ self new initialize;
		game: game initialState: state genManagers: mgrs;
		yourself.
! !


!GmDungeonBuilderState methodsFor: 'initialization' stamp: 'cr 2/23/2005 16:11'!
initialize
	level := 1.
	mapGeneratorClasses := GmMapBuilder allSubclasses.
! !

!GmDungeonBuilderState methodsFor: 'copying' stamp: 'cr 2/24/2005 23:57'!
nextLevelOnBranch: branchNum

	"Insert cleverness here.  Specifically, we can use branchnum and index to figure whether
	 this is a sidebranch and if so how to deal with it.  For now, we ignore the branch number."

	^self copy
		level: level + 1;
		yourself.! !

!GmDungeonBuilderState methodsFor: 'level information' stamp: 'cr 3/12/2005 11:12'!
mapGenerator

"	should be: ^self subclassResponsibility."	
"	^mapGeneratorClasses atRandom"
	^level = 3
		ifTrue: [GmBigRoomBuilder]
		ifFalse: [GmRoguelikeMapBuilder]
! !

!GmDungeonBuilderState methodsFor: 'level information' stamp: 'cr 2/25/2005 00:20'!
outPortalsHere
	"Return the portal objects leading out of here (to new levels)."
	| result |

	self isBottom ifTrue: [^#()].

	result := OrderedCollection with: GmDownStairway new.

	"There are branches at levels 2 and 4."
	(level = 2 or: [level = 4])
		ifTrue: [result add: GmDownStairway new].

	^result.! !

!GmDungeonBuilderState methodsFor: 'level information' stamp: 'cr 2/26/2005 02:58'!
totalMapsToBeGenerated

	"This needs to be calculated in advance, since it's used for showing a progress bar."
	
	^3 * self maxLevelsPerBranch.
! !

!GmDungeonBuilderState methodsFor: 'level customization' stamp: 'cr 3/12/2005 11:14'!
finalChangesTo: aMap
	"no-op.  Override if you want to add any final touches."
! !

!GmDungeonBuilderState methodsFor: 'map information' stamp: 'cr 3/3/2005 14:51'!
descriptionString
	^'Dungeon of Blah, level ', level printString
! !

!GmDungeonBuilderState methodsFor: 'testing' stamp: 'cr 2/26/2005 02:58'!
isBottom
	^level >= self maxLevelsPerBranch! !

!GmDungeonBuilderState methodsFor: 'testing' stamp: 'cr 3/12/2005 11:37'!
isTop
	^level = 1.
! !

!GmDungeonBuilderState methodsFor: 'accessing' stamp: 'cr 2/23/2005 15:58'!
level
	^level! !

!GmDungeonBuilderState methodsFor: 'accessing' stamp: 'cr 2/23/2005 15:58'!
level: newValue
	level := newValue! !

!GmDungeonBuilderState methodsFor: 'constants' stamp: 'cr 2/25/2005 00:57'!
defaultMapExtent
	^160@50
! !

!GmDungeonBuilderState methodsFor: 'constants' stamp: 'cr 2/26/2005 02:57'!
maxLevelsPerBranch
	^5! !


!GmDungeonBuilderState class methodsFor: 'instance creation' stamp: 'cr 2/23/2005 15:56'!
new
	^self basicNew initialize.
! !


!GmGenericBrain methodsFor: 'stimulus' stamp: 'cr 3/10/2005 02:41'!
notify: aNotification
	"no-op for now pending better creature AI."
! !

!GmGenericBrain methodsFor: 'attacking' stamp: 'cr 3/10/2005 16:17'!
canAttackPlayer
	| pc |
	pc := owner map playerCoordsOr: [^false].
	^self coordinates eightNeighbors includes: pc
! !

!GmGenericBrain methodsFor: 'response' stamp: 'cr 3/12/2005 12:06'!
getsDistracted
	^ (owner coordinates - (owner map playerCoordsOr: [^false])) r > (5 d: 3).! !

!GmGenericBrain methodsFor: 'response' stamp: 'cr 3/10/2005 23:33'!
goInRandomDirection
	^owner perform: ('go', self possibleDirections atRandom capitalized) asSymbol.! !

!GmGenericBrain methodsFor: 'response' stamp: 'cr 3/10/2005 23:17'!
makeMove
	self tryToAttackPlayer and: [^self].
	self tryToMoveTowardPlayer and: [^self].
	self goInRandomDirection.
! !

!GmGenericBrain methodsFor: 'response' stamp: 'cr 3/11/2005 00:44'!
tryToAttackPlayer

	| map |
	map := owner map.
	(owner coordinates eightNeighbors includes: (map playerCoordsOr: [^false]))
		ifFalse: [^false].

	"I move instead of attacking in this direction because the attack will happen if there's something
	 there.  If there's a bug in the above code, though, at last SOMETHING happens so it doesn't look
	 as obviously buggy and I don't look as bad.  Genius!!"
	owner goInDirection: self directionOfPlayer.
	^true.! !

!GmGenericBrain methodsFor: 'response' stamp: 'cr 3/12/2005 12:01'!
tryToMoveTowardPlayer
	
	owner map containsPlayer ifFalse: [^false].

	(self walkableDirections includes: self directionOfPlayer) ifFalse: [^false].

	self getsDistracted ifTrue: [^false].

	owner goInDirection: self directionOfPlayer.
	^true.

! !

!GmGenericBrain methodsFor: 'response' stamp: 'cr 3/10/2005 23:24'!
walkableDirections
	^self directions select: [ :dir | owner map canPutCreature: owner at: (owner pointToThe: dir)]
! !

!GmGenericBrain methodsFor: 'player direction' stamp: 'cr 3/10/2005 22:21'!
directionOfPlayer
	^owner map directionFrom: owner coordinates to: owner map player coordinates! !

!GmGenericBrain methodsFor: 'player direction' stamp: 'cr 3/10/2005 23:33'!
possibleDirections 
	^self directions select: [ :dir | owner map terrainAt: (owner pointToThe: dir) fitFor: owner]
! !


!GmInventory methodsFor: 'initialization' stamp: 'cr 3/5/2005 16:31'!
initialize
	items := IdentitySet new.
! !

!GmInventory methodsFor: 'stuff management' stamp: 'cr 3/5/2005 16:27'!
insert: anObject
	^self insert: anObject or: [ :rsp | rsp].
! !

!GmInventory methodsFor: 'stuff management' stamp: 'cr 3/5/2005 16:26'!
insert: anObject or: errorBlock
	items size >= self maxItems
		ifTrue: [^errorBlock value: GmKnapsackFull new].

	items add: anObject.
	^GmSuccessfullyStoredItem item: anObject.
! !

!GmInventory methodsFor: 'stuff management' stamp: 'cr 3/5/2005 18:04'!
remove: aThing
	^self remove: aThing or: [ :rsp | ^rsp]
! !

!GmInventory methodsFor: 'stuff management' stamp: 'cr 3/5/2005 23:13'!
remove: aThing or: errBlock
	(items includes: aThing)
		ifFalse: [^GmDontHave item: aThing].

	items remove: aThing.
	^GmItemDropped item: aThing.
! !

!GmInventory methodsFor: 'contents' stamp: 'cr 3/7/2005 17:37'!
allClothing
	^self allContentsOrdered select: [ :th | th isWearable].
! !

!GmInventory methodsFor: 'contents' stamp: 'cr 3/5/2005 22:59'!
allContentsOrdered
	^items asArray.

	"To do: use a better ordering scheme than just what the conversion routine feels like doing."
! !

!GmInventory methodsFor: 'contents' stamp: 'cr 3/7/2005 23:41'!
allPutOnables
	^self allContentsOrdered select: [ :th | th isPutOnAble].
! !

!GmInventory methodsFor: 'contents' stamp: 'cr 3/6/2005 20:11'!
allWeapons
	^self allContentsOrdered select: [ :th | th isWieldable].
! !

!GmInventory methodsFor: 'constants' stamp: 'cr 3/5/2005 23:19'!
maxItems
	^52! !


!GmInventory class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 16:32'!
new
	^self basicNew initialize
! !


!GmManagedObjectInfo methodsFor: 'initialization' stamp: 'cr 3/5/2005 21:02'!
initializeOn: ic
	itemClass := ic.
	numCreated := 0.
! !

!GmManagedObjectInfo methodsFor: 'accessing' stamp: 'cr 3/5/2005 20:15'!
itemClass
	^itemClass! !

!GmManagedObjectInfo methodsFor: 'accessing' stamp: 'cr 3/5/2005 21:03'!
maxAllowed
	^self itemClass maxAllowed! !

!GmManagedObjectInfo methodsFor: 'accessing' stamp: 'cr 2/13/2005 20:45'!
numCreated
	^numCreated! !

!GmManagedObjectInfo methodsFor: 'testing' stamp: 'cr 3/5/2005 21:04'!
canCreateIn: map
	^self countExhausted not and: [itemClass canCreateIn: map].
! !

!GmManagedObjectInfo methodsFor: 'testing' stamp: 'cr 2/13/2005 22:19'!
countExhausted
	^self maxAllowed notNil and: [self maxAllowed > self numCreated]
! !

!GmManagedObjectInfo methodsFor: 'item creation' stamp: 'cr 3/5/2005 22:33'!
create
	[itemClass maxAllowed isNil or: [numCreated < itemClass maxAllowed]] assert.

	numCreated := numCreated + 1.
	^itemClass new.
! !

!GmManagedObjectInfo methodsFor: 'item creation' stamp: 'cr 2/13/2005 23:01'!
uncreate
	"Call this when the creature was created but couldn't be placed in the game for some reason."
	numCreated := numCreated - 1.
		
! !

!GmManagedObjectInfo methodsFor: 'printing' stamp: 'cr 3/5/2005 22:26'!
printOn: aStream
	super printOn: aStream.
	aStream 	nextPut: $(;
				nextPutAll: itemClass printString;
				nextPut: $,;
				nextPutAll: numCreated printString;
				nextPut: $).
! !


!GmManagedObjectInfo class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 21:02'!
for: objClass
	^self new 
		initializeOn: objClass;
		yourself.
! !


!GmMap methodsFor: 'initialization' stamp: 'cr 3/10/2005 04:08'!
game: theGame
	game := theGame
! !

!GmMap methodsFor: 'initialization' stamp: 'cr 3/12/2005 13:26'!
initializeToExtent: extent
	items := self itemsWithExtent: extent.
	changedPoints := Set new.
	creatureCache := IdentitySet new.
! !

!GmMap methodsFor: 'initialization' stamp: 'cr 3/12/2005 13:24'!
itemsWithExtent: extent
	| initValue |
	initValue := (1 to: extent displacementRectArea)
		collect: [ :xxx | GmMapEntry new feature: GmUnusedSpace new; yourself].

	^Array2D new extent: extent fromArray: initValue.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 2/25/2005 01:07'!
addPortal: aPortal
	| point |
	point := self randomCoordMatching: [ :pt | (self featureAt: pt) canReplaceWithPortal]
					onFailure: [self error: 'invalid level'].
	self at: point putFeature: aPortal.
	aPortal map: self.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 2/25/2005 01:19'!
adjacentMaps
	| result |
	result := (self portals collect: [ :portal | portal endPointMap]) asIdentitySet.
	result remove: self ifAbsent: [].
	^result.

	! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/10/2005 03:00'!
allCreatures
	self purgeMissingCreatures.
	^creatureCache
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:56'!
at: point addThing: thing
	(self entryAt: point) addThing: thing! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/10/2005 02:56'!
at: point putCreature: creature
	(self entryAt: point) creature: creature.
	creature setMap: self andCoords: point.
	creatureCache add: creature.		"Every method that adds creatures must do this!!"
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:55'!
at: point putFeature: feature
	(self entryAt: point) feature: feature.
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/5/2005 22:50'!
at: point putObject: aGmObject
	^self perform: ('at:put', aGmObject rootTypeName, ':') asSymbol withArguments: {point. aGmObject}.
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/20/2004 01:40'!
bounds
	^1@1 extent: self extent - 1.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 2/26/2005 01:38'!
coordinatesOf: aGmObject
	self entriesWithPointsDo: [ :entry :coord | (entry contains: aGmObject) ifTrue: [^coord]].
	self error: 'Object not in map.'! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/3/2005 14:51'!
creationState
	^creationState! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/3/2005 14:51'!
creationState: newValue
	creationState := newValue! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:57'!
creatureAt: point
	^(self entryAt: point) creature.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/9/2005 23:48'!
entryAt: point
	self changedAt: point.		"Yes, this is overkill.  Some entryAt: calls are for reading."
	^items at: point x at: point y.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:26'!
extent
	^items extent.
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:57'!
featureAt: point
	^(self entryAt: point) feature.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/10/2005 04:08'!
game
	^game
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 2/25/2005 01:03'!
lowerLevels
	^self portals select: [ :portal | portal isDownStairway] thenCollect: [ :portal | portal endPointMap].! !

!GmMap methodsFor: 'accessing' stamp: 'cr 2/25/2005 00:49'!
portals
	^(self entriesSelect: [ :entry | entry feature isPortal]) collect: [ :entry | entry feature]! !

!GmMap methodsFor: 'accessing' stamp: 'cr 3/10/2005 03:04'!
shuffledNonPlayerCreatures
	^self allCreatures asOrderedCollection shuffled.! !

!GmMap methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:58'!
thingsAt: point
	^(self entryAt: point) pileOfStuff.
! !

!GmMap methodsFor: 'accessing' stamp: 'cr 2/25/2005 01:03'!
upperLevels
	^self portals select: [ :portal | portal isUpStairway] thenCollect: [ :portal | portal endPointMap].! !

!GmMap methodsFor: 'removing' stamp: 'cr 3/18/2005 21:41'!
removeCreature: aCreature
	self removeCreatureAt: aCreature coordinates.
! !

!GmMap methodsFor: 'removing' stamp: 'cr 3/18/2005 21:43'!
removeCreatureAt: coords
	| entry |
	entry := self entryAt: coords.
	entry creature setMap: nil andCoords: nil.
	entry removeCreature.
! !

!GmMap methodsFor: 'random placement' stamp: 'cr 2/27/2005 01:42'!
placeCreature: aCreature
	| creatureCoord |
	creatureCoord := self randomCoordMatching: [ :pt | self canPutCreature: aCreature at: pt]
							onFailure: [GmNoRoom signal].
	self at: creatureCoord putCreature: aCreature.
! !

!GmMap methodsFor: 'random placement' stamp: 'cr 4/3/2005 16:56'!
placeThing: aThing or: errorBlock
	| point |
	point := self randomSpotFor: aThing or: [^errorBlock value].
	self at: point putObject: aThing.

! !

!GmMap methodsFor: 'display' stamp: 'cr 3/3/2005 03:00'!
asciiTileAt: point
	^(self entryAt: point) asciiTile.
! !

!GmMap methodsFor: 'display' stamp: 'cr 4/3/2005 19:56'!
nonCreatureAsciiTileAt: point
	^(self entryAt: point) nonCreatureAsciiTile
! !

!GmMap methodsFor: 'geometry' stamp: 'cr 1/3/2004 19:56'!
center
	^(self extent / 2) rounded max: 1@1.
! !

!GmMap methodsFor: 'geometry' stamp: 'cr 3/10/2005 16:52'!
directionFrom: src to: dest
	| bestDist bestDir diff |

	src = dest ifTrue: [^nil].

	bestDist := 99999.
	bestDir := nil.

	"Note to self: I think this could be cleaner if I use #inject:into: but right now I'm too tired."

	self directionNames do: [ :dir | 
		diff := ((src + (self perform: dir)) - dest).
		diff r < bestDist
			ifTrue: [
				bestDist := diff r.
				bestDir := dir.
			]
	].

	^bestDir
! !

!GmMap methodsFor: 'enumeration' stamp: 'cr 1/3/2004 18:46'!
doAndSetFeatures: block
	^self entriesDo: [ :entry | entry feature: (block value: entry feature)].
! !

!GmMap methodsFor: 'enumeration' stamp: 'cr 1/3/2004 18:45'!
entriesDo: block
	items do: block.
! !

!GmMap methodsFor: 'enumeration' stamp: 'cr 2/25/2005 00:48'!
entriesSelect: block
	| result |
	result := Set new.
	self entriesDo: [ :entry | (block value: entry) ifTrue: [result add: entry]].
	^result.
! !

!GmMap methodsFor: 'enumeration' stamp: 'cr 1/3/2004 19:30'!
entriesWithPointsDo: block
	(1 to: items width) do: [ :x |
		(1 to: items height) do: [ :y |
			block value: (items at: x at: y) value: x@y.
		].
	].
! !

!GmMap methodsFor: 'enumeration' stamp: 'cr 2/25/2005 00:14'!
selectPoints: selectBlock

	| result |
	result := WriteStream on: (Array new: 20).
	self entriesWithPointsDo: [ :entry :point | (selectBlock value: point) ifTrue: [result nextPut: point]].

	^result contents.

! !

!GmMap methodsFor: 'queries' stamp: 'cr 2/27/2005 01:42'!
canPutCreature: creature at: coords
	^(self terrainAt: coords fitFor: creature)
		and: [(self creatureAt: coords) isNil].! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/11/2005 15:05'!
containsPlayer
	^self player map == self! !

!GmMap methodsFor: 'queries' stamp: 'cr 1/3/2004 22:27'!
containsPoint: aPoint
	^aPoint > (1@1) and: [aPoint <= self extent].! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/5/2005 19:55'!
descriptionString
	^creationState descriptionString
! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/5/2005 21:26'!
difficultyLevel
	^self creationState level
! !

!GmMap methodsFor: 'queries' stamp: 'cr 4/3/2005 19:37'!
hasCreatureAt: point
	^(self creatureAt: point) notNil! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/10/2005 04:13'!
player
	^game player
! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/11/2005 15:06'!
playerCoordsOr: notHereBlock
	self containsPlayer ifFalse: [^notHereBlock value].
	^self player coordinates.

		! !

!GmMap methodsFor: 'queries' stamp: 'cr 1/4/2004 15:22'!
positionOf: gameObject
	^self positionOf: gameObject ifAbsent: [self error: 'game object not found in map.'].! !

!GmMap methodsFor: 'queries' stamp: 'cr 1/4/2004 15:21'!
positionOf: gameObject ifAbsent: errorBlock
	self entriesWithPointsDo: [ :entry :point |
		(entry contains: gameObject)
			ifTrue: [^point]
	].

	^errorBlock value.

	! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/2/2005 14:10'!
quickRandomCoordMatching: aBlock onFailure: errorBlock
	"Pick a bunch of spots and see if 'aBlock' returns true on one of them.  Return nil on failure."

	| point |
	self randomPlacementAttempts timesRepeat: [
		point := self bounds randomInternalPoint.
		(aBlock value: point) ifTrue: [^point].
	].

	^errorBlock value.


	
			! !

!GmMap methodsFor: 'queries' stamp: 'cr 2/25/2005 00:08'!
randomCoordMatching: checkBlock onFailure: failBlock

	| point pointList |

	(point := self quickRandomCoordMatching: checkBlock onFailure: [nil])
		ifNotNil: [^point].

	"Okay, now we do it the hard way."
	pointList := self selectPoints: checkBlock.

	pointList isEmpty
		ifTrue: [^failBlock value].

	^pointList atRandom.! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/14/2005 19:55'!
randomSpotFor: aGmObject or: errorBlock

	[aGmObject isFeature not] assert.		"change this later."
	^self randomCoordMatching: [ :coord | self terrainAt: coord fitFor: aGmObject]
			onFailure: errorBlock.
! !

!GmMap methodsFor: 'queries' stamp: 'cr 2/25/2005 00:13'!
sectorsWithCreatures
	^self selectPoints: [ :pt | (self creatureAt: pt) notNil].! !

!GmMap methodsFor: 'queries' stamp: 'cr 3/5/2005 22:39'!
terrainAt: position fitFor: aCreatureOrThing

	(self containsPoint: position)
		ifFalse: [^false].

	^(self entryAt: position) terrainAllows: aCreatureOrThing.

! !

!GmMap methodsFor: 'changes' stamp: 'cr 3/4/2005 16:43'!
changedPoints
	^changedPoints
! !

!GmMap methodsFor: 'changes' stamp: 'cr 3/4/2005 16:43'!
clearChangedPoints
	changedPoints := Set new.
	! !

!GmMap methodsFor: 'changes' stamp: 'cr 1/8/2004 22:22'!
getAndClearChangedPoints
	| cp |
	cp := changedPoints.
	changedPoints := Set new.
	^cp.
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 3/5/2005 23:51'!
moveCreature: creature to: position
	| destination |

	[creature map = self] assert.

	(self terrainAt: position fitFor: creature)
		ifFalse: [^GmInaccessible desc: 'Ouch!!'].

	destination := self entryAt: position.
	destination hasCreature
		ifTrue: [^GmOccupied desc: 'There is already something there.'].

	(self entryAt: creature coordinates) removeCreature.
	self		changedAt: creature coordinates;
			changedAt: position.
	destination creature: creature.

	creature setMap: self andCoords: position.

	^GmYouSee recipient: creature.
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:00'!
moveEast: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (1 @ 0).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:03'!
moveNorth: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (0 @ -1).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:03'!
moveNorthEast: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (1 @ -1).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:03'!
moveNorthWest: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (-1 @ -1).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:03'!
moveSouth: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (0 @ 1).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:03'!
moveSouthEast: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (1 @ 1).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:03'!
moveSouthWest: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (-1 @ 1).
! !

!GmMap methodsFor: 'creature movement' stamp: 'cr 1/8/2004 22:04'!
moveWest: aCreature
	^self moveCreature: aCreature to: aCreature coordinates + (-1 @ 0).
! !

!GmMap methodsFor: 'constants' stamp: 'cr 3/14/2005 20:07'!
randomPlacementAttempts
	^200
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/10/2005 16:38'!
directionNames
	^#(east north northEast northWest south southEast southWest west)
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:40'!
east
	^1@0.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:41'!
north
	^0@-1.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:39'!
northEast
	^1 @ -1.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:39'!
northWest
	^-1 @ -1.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:40'!
south
	^0@1.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:40'!
southEast
	^1@1.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:40'!
southWest
	^-1@1.
! !

!GmMap methodsFor: 'constants-directions' stamp: 'cr 3/9/2005 01:40'!
west
	^-1@0.
! !

!GmMap methodsFor: 'private' stamp: 'cr 3/5/2005 22:48'!
at: point putThing: thing
	"This is here so that putObject: works correctly."
	^self at: point addThing: thing! !

!GmMap methodsFor: 'private' stamp: 'cr 1/8/2004 22:23'!
changedAt: point
	changedPoints add: point.
! !

!GmMap methodsFor: 'private' stamp: 'cr 3/11/2005 00:56'!
purgeMissingCreatures
	creatureCache := creatureCache reject: [ :creature | creature map ~~ self]! !

!GmMap methodsFor: 'debug' stamp: 'cr 3/12/2005 01:32'!
displaySoFar
	| panel |
	panel := RoguelikeMapDisplay new.
	panel setSize: self extent font: (StrikeFont familyName: 'DefaultTextStyle' size: 10).

	self entriesWithPointsDo: [ :e :p | panel at: p put: (self asciiTileAt: p) letter asString].

	panel drawOn: World canvas.
 ! !

!GmMap methodsFor: 'serialization-not used' stamp: 'cr 3/12/2005 14:01'!
itemsAsPointAndValuePairs
	| result |

	result := OrderedCollection new: 100.
	result add: {nil. self extent}.		"extent is the first element.  yes, this is gross.  Fix later."
	self entriesWithPointsDo: [ :entry :point | entry feature class = GmUnusedSpace ifFalse: [result add: {entry. point}]].

	^result.

! !

!GmMap methodsFor: 'serialization-not used' stamp: 'cr 3/12/2005 13:32'!
sixxFix

	"In order to get a smaller save file, we first replace 'items' with a list of pairs of 
	 coordinate and value (where the first is nil, extent).  This way, we don't have to
	 save all of those empty spaces.  Once reloaded though, the items field is incorrect.
	 This fixes it."

	| itemsHold itemsExtent |
	itemsHold := items.
	itemsExtent := itemsHold removeFirst second.

	items := self itemsWithExtent: itemsExtent.
	itemsHold do: [ :pair | items at: pair second x at: pair second y put: pair first].
! !


!GmMap class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 09:32'!
new
	^self shouldNotImplement.
	"use #withExtent: instead."! !

!GmMap class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 09:31'!
withExtent: extent
	^self basicNew initializeToExtent: extent.! !

!GmMap class methodsFor: 'instance creation-sixx' stamp: 'cr 3/12/2005 13:34'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| instance |
	instance := super createInstanceOf: aClass withSixxElement: sixxElement.
	instance sixxFix.
	^instance.! !


!GmMapBuilder methodsFor: 'initialization' stamp: 'cr 1/3/2004 18:07'!
initializeToExtent: extent
	initialExtent := extent.
	! !

!GmMapBuilder methodsFor: 'build parameters' stamp: 'cr 1/3/2004 18:08'!
initialExtent: newExtent
	initialExtent := newExtent.
! !

!GmMapBuilder methodsFor: 'map building' stamp: 'cr 1/14/2004 21:13'!
addDoorAt: point
	self at: point putFeature: GmDoor new.! !

!GmMapBuilder methodsFor: 'map building' stamp: 'cr 9/29/2004 22:39'!
at: point putDoorOr: aWallObject
	"We put in a wall UNLESS the spot is currently occupied by a bit of tunnel, in which case we install a door."

	| newFtr |
	newFtr := (map featureAt: point) isUnusedSpace ifTrue: [aWallObject] ifFalse: [GmDoor new].
	self at: point putFeature: newFtr.
! !

!GmMapBuilder methodsFor: 'map building' stamp: 'cr 1/14/2004 21:11'!
at: position putFeature: feature
	map at: position putFeature: feature.
! !

!GmMapBuilder methodsFor: 'map building' stamp: 'cr 1/3/2004 11:22'!
buildMap
	^self subclassResponsibility! !

!GmMapBuilder methodsFor: 'map building' stamp: 'cr 1/13/2004 22:48'!
initializeMap
	map := GmMap withExtent: initialExtent.
! !

!GmMapBuilder methodsFor: 'utilities' stamp: 'cr 1/14/2004 21:18'!
fillRegion: regionRect with: featureClass
	regionRect allInteriorPointsDo: [ :pt | self at: pt putFeature: featureClass new].! !

!GmMapBuilder methodsFor: 'utilities' stamp: 'cr 1/15/2004 22:14'!
randomInsidePoint
	^self randomPointBetween: self bounds origin and: self bounds corner.
! !

!GmMapBuilder methodsFor: 'utilities' stamp: 'cr 3/2/2005 14:10'!
randomPointBetween: origin and: corner
	^(origin corner: corner) randomInternalPoint.
! !

!GmMapBuilder methodsFor: 'accessing' stamp: 'cr 1/9/2004 20:18'!
map
	^map
! !

!GmMapBuilder methodsFor: 'accessing' stamp: 'cr 1/15/2004 23:39'!
mapBounds
	^self map bounds! !

!GmMapBuilder methodsFor: 'accessing' stamp: 'cr 1/14/2004 21:37'!
mapExtent
	^map
		ifNil: [initialExtent]
		ifNotNil: [map extent].
! !

!GmMapBuilder methodsFor: 'construction-walls' stamp: 'cr 3/4/2005 02:02'!
addCornersFor: aRect
	aRect corners
		do: [ :corner | map at: corner putFeature: GmCornerWall new].
! !

!GmMapBuilder methodsFor: 'construction-walls' stamp: 'cr 3/4/2005 02:02'!
addEWWallFrom: left to: right
	[left y = right y] assert.

	(left x to: right x) do: [ :x | self at: x @ left y putDoorOr: GmEastWestWall new].! !

!GmMapBuilder methodsFor: 'construction-walls' stamp: 'cr 3/4/2005 02:03'!
addNSWallFrom: top to: bottom
	[top x = bottom x] assert.

	(top y to: bottom y) do: [ :y | self at: top x @ y putDoorOr: GmNorthSouthWall new].! !

!GmMapBuilder methodsFor: 'construction-walls' stamp: 'cr 3/4/2005 02:01'!
addWallsFor: aRect
	self addNSWallFrom: aRect topLeft to: aRect bottomLeft.
	self addNSWallFrom: aRect topRight to: aRect bottomRight.

	self addEWWallFrom: aRect topLeft to: aRect topRight.
	self addEWWallFrom: aRect bottomLeft to: aRect bottomRight.

	self addCornersFor: aRect.


! !

!GmMapBuilder methodsFor: 'debug' stamp: 'cr 3/3/2005 03:00'!
displaySoFar

	| panel |
	panel := RoguelikeMapDisplay new.
	panel setSize: map extent font: (StrikeFont familyName: 'DefaultTextStyle' size: 10).

	map entriesWithPointsDo: [ :e :p | panel at: p put: (map asciiTileAt: p) letter asString].

	panel drawOn: World canvas.
 ! !


!GmBigRoomBuilder methodsFor: 'map building' stamp: 'cr 3/4/2005 02:10'!
buildMap
	self initializeMap.

	self fillRegion: map bounds withInsideRectPoints with: GmFloor.
	self addWallsFor: map bounds.
	
	^map! !


!GmMapBuilder class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 11:20'!
mapExtent: extent
	^self basicNew initializeToExtent: extent.
! !

!GmMapBuilder class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 18:07'!
new
	^self initializeToExtent: 10@10.
! !


!GmMapEntry methodsFor: 'initialization' stamp: 'cr 1/3/2004 09:50'!
initialize
	pileOfStuff := OrderedCollection new.
! !

!GmMapEntry methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:52'!
addThing: newThing
	pileOfStuff addLast: newThing.
! !

!GmMapEntry methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:49'!
creature
	^creature
! !

!GmMapEntry methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:49'!
creature: newCreature
	creature := newCreature.! !

!GmMapEntry methodsFor: 'accessing' stamp: 'cr 1/2/2004 13:07'!
feature
	^feature! !

!GmMapEntry methodsFor: 'accessing' stamp: 'cr 1/2/2004 13:08'!
feature: newFeature
	feature := newFeature.! !

!GmMapEntry methodsFor: 'accessing' stamp: 'cr 1/3/2004 09:50'!
pileOfStuff
	^pileOfStuff
! !

!GmMapEntry methodsFor: 'contents' stamp: 'cr 1/3/2004 20:18'!
firstThing
	^self pileOfStuff isEmpty
		ifTrue: [nil]
		ifFalse: [self pileOfStuff first].! !

!GmMapEntry methodsFor: 'contents' stamp: 'cr 4/3/2005 19:55'!
nonCreatureTopmostObject
	^ self firstThing ifNil: [self feature].

		
	! !

!GmMapEntry methodsFor: 'contents' stamp: 'cr 1/4/2004 16:15'!
removeCreature
	self creature: nil.
! !

!GmMapEntry methodsFor: 'contents' stamp: 'cr 1/3/2004 20:16'!
topmostObject
	^self creature ifNil: [
		self firstThing ifNil: [self feature]
	].

		
	! !

!GmMapEntry methodsFor: 'tests' stamp: 'cr 1/4/2004 15:19'!
contains: gameObject

	^ self creature = gameObject or: [self feature = gameObject
		or: [self pileOfStuff includes: gameObject]].! !

!GmMapEntry methodsFor: 'tests' stamp: 'cr 1/4/2004 15:43'!
hasCreature
	^self creature notNil.
! !

!GmMapEntry methodsFor: 'tests' stamp: 'cr 1/4/2004 15:44'!
hasStuff
	^self pileOfStuff isEmpty not.
! !

!GmMapEntry methodsFor: 'tests' stamp: 'cr 3/5/2005 22:41'!
terrainAllows: creatureOrThing
	^creatureOrThing isCreature
		ifTrue: [self feature allowsAccessBy: creatureOrThing]
		ifFalse: [self feature isDug]
! !

!GmMapEntry methodsFor: 'display' stamp: 'cr 3/3/2005 03:02'!
asciiTile
	^self topmostObject class asciiObjectDescription
! !

!GmMapEntry methodsFor: 'display' stamp: 'cr 4/3/2005 19:56'!
nonCreatureAsciiTile
	^self nonCreatureTopmostObject class asciiObjectDescription
! !


!GmMapEntry class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 09:50'!
new
	^self basicNew initialize.! !

!GmMapEntry class methodsFor: 'display class' stamp: 'cr 1/3/2004 20:21'!
descriptionClass
	^GmAsciiObjectDescription

! !


!GmMessage methodsFor: 'testing' stamp: 'cr 10/4/2004 01:05'!
hasUserMessage
	^messageString isEmptyOrNil not.! !

!GmMessage methodsFor: 'testing' stamp: 'cr 2/27/2005 01:55'!
isNotification
	^false
! !

!GmMessage methodsFor: 'testing' stamp: 'cr 2/27/2005 01:50'!
isResponse
	^false
! !

!GmMessage methodsFor: 'testing' stamp: 'cr 1/3/2004 10:15'!
isStatusResponse
	^false
! !

!GmMessage methodsFor: 'flow control' stamp: 'cr 3/10/2005 03:07'!
ifHasUserMessage: aBlock
	self hasUserMessage	ifTrue: [^aBlock valueMaybeWith: self]
! !

!GmMessage methodsFor: 'initialize' stamp: 'cr 1/3/2004 10:12'!
desc: descriptionString
	messageString := descriptionString.
! !

!GmMessage methodsFor: 'accessing' stamp: 'cr 1/3/2004 10:13'!
humanDesc

	"This is not guaranteed to remain a string.  The UI should know what to do with this."
	^messageString
! !


!GmMessage class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 10:10'!
desc: messageString
	^self basicNew desc: messageString.
! !

!GmMessage class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 16:15'!
new
	^self subclassResponsibility

	"Subclasses that implement #new need to set the description to something reasonable."
! !


!GmNotification methodsFor: 'testing' stamp: 'cr 2/27/2005 01:54'!
isNotification
	^true
! !

!GmNotification methodsFor: 'interpretation' stamp: 'cr 2/27/2005 01:57'!
hostilityLevel
	^0	"Really, this should be subclass responsibility, but hey!!"
! !

!GmNotification methodsFor: 'accessing' stamp: 'cr 2/27/2005 02:04'!
sender
	^sender! !

!GmNotification methodsFor: 'accessing' stamp: 'cr 2/27/2005 02:04'!
sender: newValue
	sender := newValue! !


!GmAttackNotification methodsFor: 'interpretation' stamp: 'cr 4/2/2005 21:47'!
hostilityLevel
	^1000		"This ain't no friendly gesture."
! !


!GmDisplacedAtPortal methodsFor: 'interpretation' stamp: 'cr 2/27/2005 01:58'!
hostilityLevel
	^2		"Not very hostile"! !


!GmAttackNotification class methodsFor: 'instance creation' stamp: 'cr 4/2/2005 21:50'!
desc: descString byCreature: aCreature
	^self new
		sender: aCreature;
		desc: descString
		yourself.! !

!GmAttackNotification class methodsFor: 'instance creation' stamp: 'cr 4/2/2005 21:50'!
theCreature: aCreature does: attackString
	^self basicNew
		sender: aCreature;
		desc: aCreature theDescriptionString capitalized, ' ', attackString;
		yourself.! !


!GmDisplacedAtPortal class methodsFor: 'instance creation' stamp: 'cr 2/27/2005 02:18'!
byCreature: aCreature
	^self new
		sender: aCreature;
		desc: aCreature descriptionString capitalized, 
				' bumps into you, knocking you out of the way.';
		yourself.! !


!GmObjGenManager methodsFor: 'initialization' stamp: 'cr 3/5/2005 21:07'!
addToItemInfo: class
	itemInfo add: (GmManagedObjectInfo for: class).
! !

!GmObjGenManager methodsFor: 'initialization' stamp: 'cr 3/5/2005 20:55'!
fillItemInfoFrom: classRoot
	classRoot allSubclassesDo: [ :class | class isConcrete ifTrue: [self addToItemInfo: class]]! !

!GmObjGenManager methodsFor: 'initialization' stamp: 'cr 3/5/2005 20:53'!
initialize
	itemInfo := OrderedCollection new.

! !

!GmObjGenManager methodsFor: 'initialization' stamp: 'cr 2/13/2005 20:26'!
on: aGame
	game := aGame.
! !

!GmObjGenManager methodsFor: 'map population' stamp: 'cr 3/5/2005 21:50'!
setupMap: map
	self generateItemsIn: map count: (self numRequiredIn: map)! !

!GmObjGenManager methodsFor: 'map population' stamp: 'cr 3/5/2005 21:51'!
updateMap: map
	self generateItemsIn: map count: (self numForUpdateIn: map)! !

!GmObjGenManager methodsFor: 'item generation' stamp: 'cr 3/12/2005 11:07'!
addItem: anObjectClass to: map ifUnable: aBlock
	| slot object point |

	slot := self slotForClass: anObjectClass.
	object := slot create.

	point := map randomSpotFor: object or: [slot uncreate. ^aBlock value].
	map at: point putObject: object.


! !

!GmObjGenManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 15:53'!
addRandomItemTo: map ifUnable: aBlock
	| slot object point |

	slot := self pickItemForMap: map or: [^aBlock value].
	object := slot create.
	self prepareObject: object forMap: map.

	point := map randomSpotFor: object or: [slot uncreate. ^aBlock value].
	map at: point putObject: object.


! !

!GmObjGenManager methodsFor: 'item generation' stamp: 'cr 3/25/2005 12:30'!
generateItemsIn: map count: count
	count timesRepeat: [self addRandomItemTo: map ifUnable: [^self]].! !

!GmObjGenManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 21:21'!
itemsAvailableOnMap: map
	^self itemInfo select: [ :ci | ci canCreateIn: map].
! !

!GmObjGenManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 22:04'!
pickItemForMap: level or: errorBlock
	| viableItems |

	viableItems := self itemsAvailableOnMap: level.
	viableItems isEmpty	ifTrue: [^errorBlock value].
	^viableItems atRandom





	! !

!GmObjGenManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 15:54'!
prepareObject: object forMap: map
	^self subclassResponsibility! !

!GmObjGenManager methodsFor: 'accessing' stamp: 'cr 3/5/2005 20:47'!
itemInfo
	^itemInfo
! !

!GmObjGenManager methodsFor: 'accessing' stamp: 'cr 3/12/2005 10:54'!
slotForClass: objectClass
	^itemInfo detect: [ :classInfo | classInfo itemClass == objectClass]
! !

!GmObjGenManager methodsFor: 'calculations' stamp: 'cr 3/5/2005 21:48'!
numForUpdateIn: map

	"Given a map, figure out how many items are to be created here initially."

	^self subclassResponsibility
! !

!GmObjGenManager methodsFor: 'calculations' stamp: 'cr 3/5/2005 21:48'!
numRequiredIn: map

	"Given a map, figure out how many items are to be created here initially."

	^self subclassResponsibility
! !


!GmBestiary methodsFor: 'initialization' stamp: 'cr 3/5/2005 21:08'!
initialize
	super initialize.
	self fillItemInfoFrom: GmCreature.
	! !

!GmBestiary methodsFor: 'monster generation' stamp: 'cr 4/2/2005 13:24'!
createPlayer
	| player |
	player := NhHuman new.
	player addStats: {GmDungeonLevel -> 42}.

	#('Strength' 'Wisdom' 'Intelligence' 'Dexterity' 'Constitution' 'Charisma')
		do: [ :stat | player atStat: stat put: (5 d: 3)].

	player atStatHitPoints: (10 to: 20) atRandom.

	^player
! !

!GmBestiary methodsFor: 'calculations' stamp: 'cr 3/5/2005 21:52'!
numForUpdateIn: map
	^10		"To do: make this cleverer."

! !

!GmBestiary methodsFor: 'calculations' stamp: 'cr 3/5/2005 21:52'!
numRequiredIn: map
	"Given a map, figure out how many items are to be created here initially."
	^40! !


!GmObjGenManager class methodsFor: 'instance creation' stamp: 'cr 2/13/2005 20:29'!
new

	"should use #on: instead."
	
	^self shouldNotImplement.! !

!GmObjGenManager class methodsFor: 'instance creation' stamp: 'cr 2/13/2005 20:28'!
on: aGame
	^self basicNew
		initialize;
		on: aGame;
		yourself.
! !


!GmObjStat methodsFor: 'initialization' stamp: 'cr 3/8/2005 16:08'!
initialize
	changed := true.		"It needs to be shown at least once."! !

!GmObjStat methodsFor: 'initialization' stamp: 'cr 2/6/2005 16:07'!
on: object value: v
	owner := object.
	value := v.
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 2/6/2005 15:55'!
basicValue
	"Do not override this.  Instead, override #value."
	^value! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 2/13/2005 23:46'!
descString
	^self name, ': ', self value printString.
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 3/12/2005 03:01'!
markChanged
	changed := true.
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 3/10/2005 00:51'!
name
	"self subclassResponsibility"
	^self className allButFirst: 2
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 3/12/2005 03:02'!
setValue: newValue

	"subclasses can override this to hook onto value changes.  Just remember to set changed as well."

	self markChanged.
	value := newValue.
	^value.
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 2/13/2005 19:20'!
showFlag
	^true.		"Return false if you don't want the user to see this stat."
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 2/13/2005 19:18'!
sortKey
	^self name
! !

!GmObjStat methodsFor: 'core protocol' stamp: 'cr 2/6/2005 15:27'!
value
	^value
! !

!GmObjStat methodsFor: 'tests' stamp: 'cr 2/6/2005 15:34'!
isSet
	^self subclassResponsibility! !

!GmObjStat methodsFor: 'tests' stamp: 'cr 2/23/2005 04:11'!
testAndClearChanged
	| c |
	c := changed.
	changed := false.
	^c.
! !

!GmObjStat methodsFor: 'printing' stamp: 'cr 2/13/2005 19:27'!
printOn: aStream
	super printOn: aStream.
	aStream 	nextPutAll: ' (';
				nextPutAll: self value printString;
				nextPut: $).
! !


!GmBoolStat methodsFor: 'initialization' stamp: 'cr 2/23/2005 16:49'!
initialize
	super initialize.
	value := false.
! !

!GmBoolStat methodsFor: 'core protocol' stamp: 'cr 2/6/2005 15:49'!
descString
	^''  "For booleans, the name shows or doesn't show, depending on whether it's set."! !

!GmBoolStat methodsFor: 'core protocol' stamp: 'cr 2/13/2005 23:58'!
name
	^self value
		ifTrue: [self valueName] ifFalse: [''].

! !

!GmBoolStat methodsFor: 'core protocol' stamp: 'cr 2/13/2005 19:19'!
sortKey
	^self valueName
! !

!GmBoolStat methodsFor: 'core protocol' stamp: 'cr 2/6/2005 15:48'!
valueName
	^self subclassResponsibility! !

!GmBoolStat methodsFor: 'testing and setting' stamp: 'cr 2/6/2005 15:30'!
clear
	self setValue: false.

! !

!GmBoolStat methodsFor: 'testing and setting' stamp: 'cr 2/6/2005 15:30'!
isSet
	^self value
! !

!GmBoolStat methodsFor: 'testing and setting' stamp: 'cr 2/6/2005 15:29'!
set
	self setValue: true! !

!GmBoolStat methodsFor: 'testing and setting' stamp: 'cr 2/6/2005 15:29'!
toggle
	self setValue: self value not.

! !

!GmBoolStat methodsFor: 'control flow' stamp: 'cr 2/6/2005 15:25'!
ifFalse: aBlock
	^self value ifFalse: aBlock! !

!GmBoolStat methodsFor: 'control flow' stamp: 'cr 2/6/2005 15:25'!
ifTrue: aBlock
	^self value ifTrue: aBlock! !

!GmBoolStat methodsFor: 'control flow' stamp: 'cr 2/6/2005 15:25'!
ifTrue: trueBlock ifFalse: falseBlock
	^self value ifTrue: trueBlock ifFalse: falseBlock.
! !

!GmBoolStat methodsFor: 'accessing' stamp: 'cr 2/6/2005 15:19'!
value
	^value! !


!GmConfused methodsFor: 'core protocol' stamp: 'cr 2/6/2005 16:08'!
valueName
	^'Confused'
! !


!GmNumStat methodsFor: 'initialization' stamp: 'cr 2/23/2005 16:49'!
initialize
	super initialize.
	value := 0.
! !

!GmNumStat methodsFor: 'arithmetic' stamp: 'cr 3/12/2005 03:16'!
add: num
	self setValue: self basicValue + num asNumber! !

!GmNumStat methodsFor: 'arithmetic' stamp: 'cr 2/6/2005 15:33'!
asNumber
	^self value.
! !

!GmNumStat methodsFor: 'arithmetic' stamp: 'cr 3/12/2005 03:16'!
subtract: num
	self setValue: self basicValue - num asNumber! !

!GmNumStat methodsFor: 'tests' stamp: 'cr 2/6/2005 15:35'!
isSet
	"this basically tests whether the Stat has any effect at all."
	^self value > 0! !

!GmNumStat methodsFor: 'core protocol' stamp: 'cr 3/8/2005 15:27'!
name
	^self class name allButFirst: 2.
! !


!GmArmorClass methodsFor: 'core protocol' stamp: 'cr 3/12/2005 04:10'!
value
	^super value + (owner applyToDeployedAndSum: #armorClassMod) max: 0
! !


!GmBoringNumStat methodsFor: 'core protocol' stamp: 'cr 3/8/2005 12:11'!
add: num
	super add: num.
	self constrainValue.
! !

!GmBoringNumStat methodsFor: 'core protocol' stamp: 'cr 3/8/2005 12:11'!
subtract: num
	super subtract: num.
	self constrainValue.
! !

!GmBoringNumStat methodsFor: 'core protocol' stamp: 'cr 3/12/2005 04:22'!
value
	^super value + (owner applyToDeployedAndSum: self modifierMessage) max: 0
! !

!GmBoringNumStat methodsFor: 'constants' stamp: 'cr 3/8/2005 12:09'!
maxValue
	^18! !

!GmBoringNumStat methodsFor: 'constants' stamp: 'cr 3/8/2005 12:08'!
minValue
	^0
! !

!GmBoringNumStat methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:22'!
modifierMessage
	^self subclassResponsibility! !

!GmBoringNumStat methodsFor: 'private-constraints' stamp: 'cr 3/8/2005 12:11'!
constrainValue
	value := value min: self minValue max: self maxValue! !


!GmCharisma methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:23'!
modifierMessage
	^#charismaMod! !


!GmConstitution methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:23'!
modifierMessage
	^#constitutionMod! !


!GmDexterity methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:24'!
modifierMessage
	^#dexterityMod! !


!GmDungeonLevel methodsFor: 'core protocol' stamp: 'cr 3/10/2005 00:52'!
descString
	^ owner map creationState descriptionString.
! !

!GmDungeonLevel methodsFor: 'core protocol' stamp: 'cr 3/10/2005 00:50'!
value
	^owner map creationState level
! !

!GmDungeonLevel methodsFor: 'tests' stamp: 'cr 3/24/2005 22:12'!
testAndClearChanged

	| hasChanged |
	hasChanged := (lastLevel == owner map) not.
	lastLevel := owner map.
	^hasChanged.
! !


!GmExperience methodsFor: 'core protocol' stamp: 'cr 3/8/2005 16:40'!
descString
	^self name, ': ', self levelValue printString, '/', self value printString! !

!GmExperience methodsFor: 'core protocol' stamp: 'cr 4/1/2005 17:52'!
setValue: newValue
	| oldLevel |

	"Once again, blech!!  Different abstraction levels in the same method!!"	

	oldLevel := self levelValue.
	super setValue: newValue.
	
	self levelValue > oldLevel
		ifTrue: [self levelValue - oldLevel timesRepeat: [owner updateForGainedLevel]].
! !

!GmExperience methodsFor: 'level values' stamp: 'cr 4/3/2005 16:27'!
levelValue
	^(self levelForExperience: self value) rounded.
! !

!GmExperience methodsFor: 'level values' stamp: 'cr 4/3/2005 16:27'!
setLevelValue: newLevel

	"This should be the inverse of levelValue.  It's not quite but it's close enough for what we need
	 it for."

	self setValue: (self expForLevel: newLevel) rounded.! !

!GmExperience methodsFor: 'private- exp to level calculation' stamp: 'cr 4/3/2005 16:38'!
expForLevel: level
	"MUST mirror levelForExperience: "
	^10 * (2 raisedTo: level)! !

!GmExperience methodsFor: 'private- exp to level calculation' stamp: 'cr 4/3/2005 16:39'!
levelForExperience: exp
	"This MUST mirror #expForLevel:  The one exception is that this will never return a negative level,
	 even though that's what you'll get when exp < about 20 or so."
	^((exp / 10) log: 2) max: 1.! !


!GmHitPoints methodsFor: 'maximum  value' stamp: 'cr 3/10/2005 00:15'!
clipValue
	value := value min: self maxHitpoints truncated.
! !

!GmHitPoints methodsFor: 'maximum  value' stamp: 'cr 3/10/2005 00:31'!
increaseMaxBy: newMax
	maxHitpoints := self maxHitpoints + newMax.
	changed := true.! !

!GmHitPoints methodsFor: 'maximum  value' stamp: 'cr 3/10/2005 00:16'!
maxHitpoints
	^maxHitpoints
		ifNil: [maxHitpoints := value]	
! !

!GmHitPoints methodsFor: 'core protocol' stamp: 'cr 3/10/2005 00:30'!
descString
	^self name, ': ', self value printString, ' (', self maxHitpoints printString, ')'! !

!GmHitPoints methodsFor: 'core protocol' stamp: 'cr 2/13/2005 19:24'!
name
	^'HitPoints'
! !

!GmHitPoints methodsFor: 'core protocol' stamp: 'cr 3/10/2005 00:21'!
setValue: newValue
	super setValue: newValue.
	self clipValue.
	(value <= 0) ifTrue: [owner die].
! !

!GmHitPoints methodsFor: 'core protocol' stamp: 'cr 3/10/2005 00:18'!
value
	^super value truncated.
! !

!GmHitPoints methodsFor: 'healing' stamp: 'cr 4/1/2005 18:05'!
heal
	| oldValue |

	"We access the variables directly here to get past the data laundering properties of
	 the accessors.  This may not be the best coding style."

	oldValue := value.
	value := value + (owner atStatConstitution / 54.0).	"At max const, in HP per 3 turns."
	self clipValue.

	oldValue truncated = value truncated
		ifFalse: [changed := true].

! !

!GmHitPoints methodsFor: 'healing' stamp: 'cr 3/11/2005 14:03'!
healToMax
	self setValue: maxHitpoints! !


!GmIntelligence methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:24'!
modifierMessage
	^#intelligenceMod! !


!GmObjStat class methodsFor: 'instance creation' stamp: 'cr 2/6/2005 16:07'!
new
	^self basicNew initialize
! !

!GmObjStat class methodsFor: 'instance creation' stamp: 'cr 2/6/2005 16:08'!
on: object value: v
	^self new on: object value: v.
! !


!GmObject methodsFor: 'initialization' stamp: 'cr 1/3/2004 19:06'!
initialize

	"this is here so that new doesn't break."
! !

!GmObject methodsFor: 'type tests' stamp: 'cr 1/3/2004 23:09'!
isCreature
	^false
! !

!GmObject methodsFor: 'type tests' stamp: 'cr 1/2/2004 19:57'!
isFeature
	^false
! !

!GmObject methodsFor: 'type tests' stamp: 'cr 1/2/2004 19:58'!
isThing
	^false
! !

!GmObject methodsFor: 'description' stamp: 'cr 3/4/2005 18:04'!
descriptionString
	^(self className allButFirst: 2) studlyCapsToWords withIndefiniteArticle! !

!GmObject methodsFor: 'description' stamp: 'cr 4/3/2005 19:03'!
theDescriptionString
	^ (self className allButFirst: 2) studlyCapsToWords withDefiniteArticle! !

!GmObject methodsFor: 'type properties' stamp: 'cr 3/26/2005 13:24'!
isUnique
	^self class maxAllowed = 1.
! !


!GmCreature methodsFor: 'initialization' stamp: 'cr 3/8/2005 15:24'!
addDefaultStats
	self addStats: self class initialStatValues.! !

!GmCreature methodsFor: 'initialization' stamp: 'cr 3/6/2005 19:39'!
addSlots
	slots := GmDeployments new.! !

!GmCreature methodsFor: 'initialization' stamp: 'cr 2/13/2005 18:47'!
addStat: statClass initializedTo: initVal
	| stat |
	stat := statClass on: self value: initVal.
	stats at: stat name put: stat.



! !

!GmCreature methodsFor: 'initialization' stamp: 'cr 3/8/2005 15:24'!
addStats: statList
	statList do: [ :assoc |	self addStat: assoc key initializedTo: assoc value].
! !

!GmCreature methodsFor: 'initialization' stamp: 'cr 3/6/2005 19:39'!
initialize
	super initialize.
	
	stats := Dictionary new.
	brain := self brainClass for: self.
	viewRegion := GmViewRegion viewer: self.
	inventory := GmInventory new.

	self addDefaultStats.
	self addSlots.

! !

!GmCreature methodsFor: 'accessing' stamp: 'cr 3/10/2005 03:16'!
brain
	^brain
! !

!GmCreature methodsFor: 'accessing' stamp: 'cr 3/3/2005 15:16'!
brain: aBrain
	brain := aBrain! !

!GmCreature methodsFor: 'accessing' stamp: 'cr 3/6/2005 20:00'!
slots
	^slots! !

!GmCreature methodsFor: 'type tests' stamp: 'cr 1/3/2004 23:10'!
isCreature
	^true
! !

!GmCreature methodsFor: 'type tests' stamp: 'cr 4/3/2005 21:23'!
isHumanoid
	^false
! !

!GmCreature methodsFor: 'type info' stamp: 'cr 3/5/2005 20:41'!
rootTypeName
	^#Creature! !

!GmCreature methodsFor: 'stats' stamp: 'cr 2/13/2005 18:59'!
atStat: statName
	^(stats at: statName) value.
! !

!GmCreature methodsFor: 'stats' stamp: 'cr 2/13/2005 18:59'!
atStat: statName put: statValue
	^(stats at: statName) setValue: statValue.
! !

!GmCreature methodsFor: 'stats' stamp: 'cr 3/12/2005 03:02'!
markStatsChanged
	stats do: [ :stat | stat markChanged].
! !

!GmCreature methodsFor: 'stats' stamp: 'cr 2/13/2005 23:59'!
sortedStatList
	^stats values asSortedCollection: [ :l :r | l sortKey <= r sortKey]! !

!GmCreature methodsFor: 'stats' stamp: 'cr 2/13/2005 19:51'!
statNamed: name
	^stats at: name
! !

!GmCreature methodsFor: 'stats-dnu' stamp: 'cr 2/13/2005 20:09'!
commentReadMe
	self error: 'Don''t call this method--just read the comment.'.

	"
	About #doesNotUnderstand: and Stats
	==========================================

	For flexibility, creature statistics are are implemented as a dictionary of objects, one for
	each stat.  This lets you add new stats without modifying the class heirarchy but makes
	it difficult to write accessors to get at them.

	It's easier to write
		someMonster hitPoints + 1
	than
		(someMonster atStat: 'HitPoints') + 1

	Fortunately, through the magic of Smalltalk messages, we can get the best of both worlds.
	This class's #doesNotUnderstand: responds to certain message patterns by doing stat lookups.
	Specifically:

		1) atStat<stat-name> reads the value of the stat.  (e.g. someMonster atStatHitPoints).
		2) atStat<stat-name>: value sets the value of the stat.  (e.g. someMonster atStatHitPoints: 42).
		3) stat<stat-name> returns the stat object with that name (e.g. someMonster statHitPoints value).

	"


! !

!GmCreature methodsFor: 'stats-dnu' stamp: 'cr 2/13/2005 19:53'!
doesNotUnderstand: aMessage

	"This is here so that we can access stats as though they were instance variables.  Some rules:

		1) Stat accessors must begin with 'stat' and a capital letter (e.g. 'statStrength:').
		2) Stat accessors can be set or read, depending on the presence of the trailing colon.
	
	Missing stats fall through as invalid message sends.
	"

	| selector |

	selector := aMessage selector.
	
	selector = selector asStatName
		ifTrue: [^super doesNotUnderstand: aMessage].

	(selector beginsWith: 'atStat')
		ifTrue: [^self statAccessMsg: aMessage]
		ifFalse: [^self statObjAccessMsg: aMessage]
! !

!GmCreature methodsFor: 'stats-dnu' stamp: 'cr 2/13/2005 19:34'!
statAccessMsg: aMessage
	aMessage arguments size = 0
		ifTrue: [^self atStat: aMessage selector asStatName]
		ifFalse: [^self atStat: aMessage selector asStatName put: aMessage argument]

! !

!GmCreature methodsFor: 'stats-dnu' stamp: 'cr 2/13/2005 19:54'!
statObjAccessMsg: aMessage

	aMessage arguments isEmpty
		ifFalse: [^super doesNotUnderstand: aMessage].

	^self statNamed: aMessage selector asStatName.
! !

!GmCreature methodsFor: 'tests--capabilites' stamp: 'cr 1/3/2004 22:44'!
flies
	^false
! !

!GmCreature methodsFor: 'tests--capabilites' stamp: 'cr 1/3/2004 22:44'!
swims
	^false
! !

!GmCreature methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 21:24'!
usesTools
	^false! !

!GmCreature methodsFor: 'tests--capabilites' stamp: 'cr 3/12/2005 01:44'!
walks
	^true! !

!GmCreature methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 22:50'!
wearsArmor
	^false.

	"More specifically: can it wear humanoid armor.  I'm not going to bother with non-humanoid armor."! !

!GmCreature methodsFor: 'tests--circumstances' stamp: 'cr 2/26/2005 01:30'!
standingOnPortal
	^self featureHere isPortal! !

!GmCreature methodsFor: 'tests--stats' stamp: 'cr 3/9/2005 23:33'!
isDead
	^self atStatHitPoints <= 0.
! !

!GmCreature methodsFor: 'tests' stamp: 'cr 3/10/2005 03:02'!
isPlayer
	^brain isPlayerBrain! !

!GmCreature methodsFor: 'tests' stamp: 'cr 3/12/2005 11:25'!
isWearingPants
	slots allInSlots detect: [ :item | item isPantsOfYendor] ifNone: [^false].
	^true.
! !

!GmCreature methodsFor: 'attributes' stamp: 'cr 3/12/2005 00:29'!
bareIntrinsicAttackClasses
	^{GmUnarmedAttack}.		"Every creature gets one by default."

! !

!GmCreature methodsFor: 'attributes' stamp: 'cr 4/3/2005 16:11'!
computedExperienceValue
	^self statExperience levelValue * self experienceValue.
! !

!GmCreature methodsFor: 'attributes' stamp: 'cr 3/11/2005 22:02'!
damageRating
	"This is the number of dice in rolling the damage rating."
	^1
! !

!GmCreature methodsFor: 'attributes' stamp: 'cr 3/10/2005 00:01'!
experienceValue
	^1.
! !

!GmCreature methodsFor: 'attributes' stamp: 'cr 4/3/2005 00:21'!
toHitRating
	"This is the number of dice in rolling the 'to-hit'."
	^2
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goEast
	^self goInDirection: #East.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goNorth
	^self goInDirection: #North.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goNorthEast
	^self goInDirection: #NorthEast.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goNorthWest
	^self goInDirection: #NorthWest.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goSouth
	^self goInDirection: #South.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goSouthEast
	^self goInDirection: #SouthEast.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goSouthWest
	^self goInDirection: #SouthWest.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 1/8/2004 21:36'!
goWest
	^self goInDirection: #West.
! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 3/12/2005 11:20'!
invokePortal
	
	| otherPortal |
	self standingOnPortal
		ifFalse: [^GmYouSeeNoNounHere noun: 'exit'].

	"BLECH!! This should all be done in the portal code.  Ick!!"
	self featureHere isDungeonExit
		ifTrue: [^self tryToLeaveDungeon].

	otherPortal := self featureHere endPoint.
	otherPortal displaceOccupant.

	^self moveToEndpoint: otherPortal.
	

	
	! !

!GmCreature methodsFor: 'creature capabilities' stamp: 'cr 2/26/2005 01:17'!
wait
	^GmSilentSuccess new.
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 4/4/2005 03:55'!
interactiveDrop
	"Just like #drop: except it pops up a menu to let the user select which item to drop."
	| item |
	item := inventory allContentsOrdered 
				pickOneOr: [^GmCancelled new] withCaption: 'Drop what?' 
				ifMatches: [ :i | slots isDeploying: i] addLabel: ' (in use)'.
	^self drop: item.! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 4/4/2005 03:53'!
interactiveInventory
	| contents |
	contents := inventory allContentsOrdered.
	contents isEmpty ifTrue: [^GmNoInventory new].

	contents pickOneOr: [] withCaption: 'Your inventory:' 
		ifMatches: [ :item | slots isDeploying: item] addLabel: ' (in use)'.
	^GmSilentSuccess new.
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/7/2005 23:54'!
interactivePutOn
	| item allPutOn |
	allPutOn := slots allPutOn asIdentitySet.

	item := inventory allPutOnables
			pickOneOr: [^GmCancelled new] withCaption: 'Put on what?'
				ifMatches: [ :i | allPutOn includes: i] addLabel: ' (being worn)'.

	^self deploy: item.
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/12/2005 12:37'!
interactiveSaveAndQuit

	self isPlayer ifFalse: [^GmImpossible new].		"Probably can't happen."

	(self confirm: 'Really save and quit?')
		ifTrue: [brain game saveAndQuit].

	^GmSilentSuccess new.! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/5/2005 23:08'!
interactiveTake
	"Just like #take: except it pops up a menu to let the user select which item to take."
	^self take: (self stuffHere ifChoicePickOneOr: [^GmCancelled new] withCaption: 'Pick up what?').
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/7/2005 23:29'!
interactiveTakeOff
	| item |

	item := slots allPutOn pickOneOr: [^GmCancelled new] withCaption: 'Remove what?'.
	^self undeploy: item.
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/7/2005 17:49'!
interactiveUnWear
	| item |

	"Which I name 'unwear' because I always get 'remove' and 'take off' confused."

	item := slots allWorn pickOneOr: [^GmCancelled new] withCaption: 'Take off what armor?'.
	^self undeploy: item.
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/7/2005 18:12'!
interactiveWear
	| item allWorn |
	allWorn := slots allWorn asIdentitySet.

	item := inventory allClothing
			pickOneOr: [^GmCancelled new] withCaption: 'Wear what armor?'
				ifMatches: [ :i | allWorn includes: i] addLabel: ' (being worn)'.

	^self deploy: item.
! !

!GmCreature methodsFor: 'creature capabilities -- player' stamp: 'cr 3/7/2005 14:33'!
interactiveWield
	| weapon |
	weapon := inventory allWeapons
		pickWeaponWhileHolding: slots allWielded
			withCaption: 'Wield what?'
			or: [^GmCancelled new].

	^self wield: weapon.
! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 4/3/2005 16:11'!
attackInDirection: dirName
	| target resp |

	"To do: come up with some way of returning multiple responses (or maybe a composite response?)
	 informing the player of all of the attacks, not just the last one."

	target := map creatureAt: (self pointToThe: dirName).
	resp := GmFailure desc: 'You seem to be incapable of attacking anything.'.

	self attacks do: [ :attack |
		(resp := attack applyTo: target)
			 ifKilledTarget: [
				self statExperience add: target computedExperienceValue.
				^resp
			.]
	].
	^resp.! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 3/12/2005 03:28'!
deploy: aThing
	slots deploy: aThing or: [ :rsp | ^rsp].
	self markStatsChanged.
	^GmSilentSuccess new.
! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 3/14/2005 15:58'!
drop: aThing
	| response |
	response := inventory remove: aThing or: [ :rsp | ^rsp].

	self addToStuffHere: aThing.
	self slots undeploy: aThing or: [].

	^response.
! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 3/10/2005 23:28'!
goInDirection: dirName
	^(self map perform: ('move', dirName capitalized, ':') asSymbol with: self)
		ifSpaceOccupied: [^self attackInDirection: dirName unCapitalized asSymbol]! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 3/5/2005 23:09'!
take: aThing
	(self stuffHere includes: aThing)
		ifFalse: [^GmYouSeeNoNounHere noun: aThing descriptionString].

	self stuffHere remove: aThing.
	^inventory insert: aThing or: [ :rsp | self stuffHere add: aThing. ^rsp].
! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 3/12/2005 03:02'!
undeploy: aThing
	slots undeploy: aThing or: [:rsp | ^rsp].
	self markStatsChanged.
	^GmSilentSuccess new.
! !

!GmCreature methodsFor: 'creature capabilities -- non-interactive' stamp: 'cr 4/4/2005 00:08'!
wield: weaponOrNil

	"Wield whatever weapon is given, unless it's nil in which case we go to bare hands.  Note
	 that this whole system suffers from confusion over whether or not you can wield more than
	 one weapon at a time.  Right now, the answer is no but some of the components are written to
	 allow more."

	slots allWielded do: [ :weapon | self undeploy: weapon].
	^weaponOrNil
		ifNotNil: [self deploy: weaponOrNil].
! !

!GmCreature methodsFor: 'creature communication' stamp: 'cr 3/11/2005 14:48'!
inform: aGmMessage
	self isPlayer
		ifTrue: [brain game playerMessage: aGmMessage]

	"To do: this could also go to the creature brain but the code isn't there to do anything smart with it."! !

!GmCreature methodsFor: 'creature actions' stamp: 'cr 3/11/2005 00:40'!
attacks
	^self intrinsicAttacks
! !

!GmCreature methodsFor: 'creature actions' stamp: 'cr 3/9/2005 23:59'!
intrinsicAttacks
	"These are the attacks that a creature has if it has no weapons.  If an artifact grants new attacks, they
	 would be included here."
	^self bareIntrinsicAttackClasses collect: [ :attack | attack doer: self].! !

!GmCreature methodsFor: 'creature status changes' stamp: 'cr 3/11/2005 15:19'!
die
	"to do: work in life-saving here."

	self isPlayer
		ifTrue: [
			(brain game debugMode and: [(self confirm: 'Really die?') not])
				ifTrue: [self statHitPoints healToMax. ^self].

			brain game gameOverPlayerDied.
		].

	self map removeCreature: self.

		! !

!GmCreature methodsFor: 'creature status changes' stamp: 'cr 3/10/2005 00:35'!
heal
	self statHitPoints heal.
! !

!GmCreature methodsFor: 'creature status changes' stamp: 'cr 3/10/2005 00:46'!
updateForGainedLevel
	self statHitPoints
		increaseMaxBy: (3 d: 4);
		add: self atStatHitPoints // 5.
! !

!GmCreature methodsFor: 'current square accessing' stamp: 'cr 3/5/2005 19:08'!
addToStuffHere: aThing
	self map at: self coordinates addThing: aThing.
! !

!GmCreature methodsFor: 'current square accessing' stamp: 'cr 2/26/2005 01:29'!
featureHere
	^self map featureAt: self coordinates
! !

!GmCreature methodsFor: 'current square accessing' stamp: 'cr 2/26/2005 01:31'!
stuffHere
	^self map thingsAt: self coordinates! !

!GmCreature methodsFor: 'game cycle' stamp: 'cr 3/10/2005 03:11'!
endOfTurnUpdate
	self heal.

	"Other stuff probably goes here."! !

!GmCreature methodsFor: 'position' stamp: 'cr 1/8/2004 21:36'!
coordinates
	^coordinates
! !

!GmCreature methodsFor: 'position' stamp: 'cr 1/8/2004 21:20'!
map
	^map
! !

!GmCreature methodsFor: 'position' stamp: 'cr 3/10/2005 23:27'!
pointToThe: direction
	^self coordinates + (map perform: direction asSymbol).
! !

!GmCreature methodsFor: 'position' stamp: 'cr 3/2/2005 23:26'!
yourFloor
	^map featureAt: coordinates
! !

!GmCreature methodsFor: 'position cache' stamp: 'cr 3/11/2005 14:50'!
setMap: newMap andCoords: newCoords
	"This holds the location of self in map.  This should ONLY EVER be called by a map
	 when this object is moved onto it."
	map := newMap.
	coordinates := newCoords.
! !

!GmCreature methodsFor: 'vision' stamp: 'cr 3/3/2005 23:13'!
viewRegion
	^viewRegion
! !

!GmCreature methodsFor: 'inventory' stamp: 'cr 4/3/2005 22:36'!
insertAndDeploy: aThing or: errorBlock
	(self map notNil and: [self stuffHere includes: aThing])
		ifTrue: [self stuffHere remove: aThing].

	inventory insert: aThing or: [^errorBlock value].
	(self deploy: aThing)
		ifFailure: [^errorBlock value].

	! !

!GmCreature methodsFor: 'inventory' stamp: 'cr 3/6/2005 00:41'!
inventory
	^inventory
! !

!GmCreature methodsFor: 'inventory' stamp: 'cr 3/11/2005 14:33'!
totalPointValue
	^inventory allContentsOrdered inject: 0 into: [ :sum :item | sum + item pointValue]! !

!GmCreature methodsFor: 'wielding, wearing' stamp: 'cr 3/12/2005 03:16'!
applyToDeployedAndSum: message
	^slots allInSlots inject: 0 into: [ :sum :item | sum + (item perform: message)]
! !

!GmCreature methodsFor: 'printing' stamp: 'cr 1/9/2004 21:28'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: ' (at ';
		nextPutAll: self coordinates printString;
		nextPut: $).

! !

!GmCreature methodsFor: 'class attributes' stamp: 'cr 3/5/2005 19:58'!
brainClass
	^self class brainClass
! !

!GmCreature methodsFor: 'private-movement' stamp: 'cr 3/18/2005 21:44'!
moveToEndpoint: aPortal
	self map removeCreature: self.
	aPortal map at: aPortal coordinates putCreature: self.

	^GmSilentSuccess new.
! !

!GmCreature methodsFor: 'private-movement' stamp: 'cr 3/12/2005 12:19'!
tryToLeaveDungeon

	"To do: this should really be in the Portal code, but I don't have time right now."

	| msg |
	self isPlayer ifFalse: [^GmImpossible new].		"This should never happen."

	self isWearingPants
		ifFalse: [
			msg :=	'The stairway is blocked by a barred door.  Behind the door, a\',
					'guard says, "You heard the judge.  You''re not leaving until\',
					'you put on some pants!!"'.		
			^GmInaccessible desc: msg withCRs.
		].

	msg :=	'The guard says, "I see you finally decided to join decent society."  The door\',
			'swings open.  You are free.'.

	self inform: (GmSuccess desc: msg withCRs).
	self brain game gameOverPlayerWins.

	"This is probably never reached, but just in case..."
	^GmSilentSuccess new.
! !


!GmFeature methodsFor: 'access tests--overrides' stamp: 'cr 1/3/2004 23:01'!
allowsFlyers
	^self subclassResponsibility! !

!GmFeature methodsFor: 'access tests--overrides' stamp: 'cr 1/3/2004 10:30'!
allowsSwimmers
	^self subclassResponsibility! !

!GmFeature methodsFor: 'access tests--overrides' stamp: 'cr 1/3/2004 23:01'!
allowsWalkers
	^self subclassResponsibility! !

!GmFeature methodsFor: 'access tests--convenience' stamp: 'cr 1/3/2004 23:00'!
allowsAllAccess
	^self allowsFlyers & self allowsSwimmers & self allowsWalkers! !

!GmFeature methodsFor: 'access tests--convenience' stamp: 'cr 1/3/2004 23:01'!
allowsSomeAccess
	^self allowsFlyers | self allowsWalkers | self allowsSwimmers.! !

!GmFeature methodsFor: 'access tests--creatures' stamp: 'cr 1/3/2004 23:07'!
allowsAccessBy: aCreature
	^(self allowsSwimmers & aCreature swims) or: [self allowsFlyers & aCreature flies
			or: [self allowsWalkers & aCreature walks]]
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 1/24/2004 18:08'!
isDiggable
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 2/24/2004 01:11'!
isDoor
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 2/25/2005 00:52'!
isDownStairway
	^false! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 1/24/2004 18:08'!
isDug
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 3/12/2005 11:19'!
isDungeonExit
	^false.
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 1/16/2004 00:11'!
isFloor
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 3/3/2005 23:29'!
isLit
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 2/25/2005 00:50'!
isPortal
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 3/2/2005 23:27'!
isTunnelFloor
	^false
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 9/28/2004 23:44'!
isUnusedSpace
	^false.
! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 2/25/2005 00:52'!
isUpStairway
	^false! !

!GmFeature methodsFor: 'type tests' stamp: 'cr 2/24/2005 03:23'!
isWall
	^false.
! !

!GmFeature methodsFor: 'type info' stamp: 'cr 3/5/2005 20:42'!
rootTypeName
	^#Feature! !

!GmFeature methodsFor: 'construction tests' stamp: 'cr 10/3/2004 18:36'!
canReplaceWithDoor
	^true
! !

!GmFeature methodsFor: 'construction tests' stamp: 'cr 2/23/2005 16:27'!
canReplaceWithPortal
	^false.

	"Only floor can be replaced with a portal."! !

!GmFeature methodsFor: 'construction' stamp: 'cr 1/24/2004 18:29'!
constrDigYields
	^GmTunnelFloor.
! !

!GmFeature methodsFor: 'creature management' stamp: 'cr 3/10/2005 02:40'!
displaceOccupantOf: coord in: map

	"This is an ugly hack, but it probably won't happen so no big deal.  Basically,
	 the problem is that if a creature takes a portal and there's another creature at the
	 endpoint, it needs to be moved.  Instead of doing something reasonable like shoving
	 it out of the way, I'm just going to teleport it somewhere else in the level or, if that
	 fails, kill it."
	
	| creature |
	creature := map creatureAt: coord.
	map moveCreature: creature to: (map randomSpotFor: creature or: [creature die]).

! !

!GmFeature methodsFor: 'creature management' stamp: 'cr 3/18/2005 21:24'!
ifRoomDisplaceOccupantOf: coord in: map by: creature
	| occupant |
	occupant := map creatureAt: coord.
	coord eightNeighbors do: [ :pt |
		(map canPutCreature: occupant at: pt)
			ifTrue: [^ self displaceCreature: occupant to: pt in: map by: creature].
	].

	^GmOccupied new.
! !

!GmFeature methodsFor: 'private' stamp: 'cr 3/18/2005 21:24'!
displaceCreature: occupant to: newPos in: map by: creature
	(map moveCreature: occupant to: newPos)
		ifFailure: [self error: 'Can''t displace occupant.'].
	occupant inform: (GmDisplacedAtPortal byCreature: creature).
	^GmSilentSuccess new.
! !


!GmDoor methodsFor: 'initialization' stamp: 'cr 1/14/2004 20:53'!
initialize
	isOpen := true.
! !

!GmDoor methodsFor: 'accessing' stamp: 'cr 1/14/2004 20:54'!
isOpen
	^isOpen! !

!GmDoor methodsFor: 'access tests' stamp: 'cr 1/14/2004 20:53'!
allowsFlyers
	^self isOpen
! !

!GmDoor methodsFor: 'access tests' stamp: 'cr 1/14/2004 20:55'!
allowsSwimmers
	^false
! !

!GmDoor methodsFor: 'access tests' stamp: 'cr 1/14/2004 20:54'!
allowsWalkers
	^self isOpen
! !

!GmDoor methodsFor: 'construction tests' stamp: 'cr 1/24/2004 18:11'!
isDug
	^true! !

!GmDoor methodsFor: 'type tests' stamp: 'cr 2/24/2004 01:13'!
isDoor
	^true! !


!GmFloor methodsFor: 'construction tests' stamp: 'cr 2/23/2005 16:28'!
canReplaceWithPortal
	^true.
! !

!GmFloor methodsFor: 'construction tests' stamp: 'cr 1/24/2004 18:08'!
isDug
	^true
! !

!GmFloor methodsFor: 'tests' stamp: 'cr 1/8/2004 22:01'!
allowsFlyers
	^true
! !

!GmFloor methodsFor: 'tests' stamp: 'cr 1/8/2004 22:01'!
allowsSwimmers
	^false
! !

!GmFloor methodsFor: 'tests' stamp: 'cr 1/8/2004 22:01'!
allowsWalkers
	^true
! !

!GmFloor methodsFor: 'type tests' stamp: 'cr 1/16/2004 00:11'!
isFloor
	^true
! !

!GmFloor methodsFor: 'type tests' stamp: 'cr 3/3/2005 23:29'!
isLit
	^true
! !


!GmObject class methodsFor: 'instance creation' stamp: 'cr 1/2/2004 19:52'!
new
	^self basicNew initialize.
! !

!GmObject class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:26'!
canCreateIn: aMap
	^true		"more sophisticated tests go here."
! !

!GmObject class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:23'!
isConcrete
	^false.		"Must set to true to allow instance creation."
! !

!GmObject class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:25'!
maxAllowed
	^nil			"unlimited."
! !


!GmCreature class methodsFor: 'stat defaults' stamp: 'cr 4/3/2005 16:12'!
initialStatValues
	"You can override any of these by overriding the method and appending the new association
	 to the result.  That is, the results are read front to back with the last definition winning."
	^{
		GmStrength		-> 1.
		GmWisdom		-> 1.
		GmIntelligence	-> 1.
		GmDexterity		-> 1.
		GmConstitution	-> 1.
		GmCharisma		-> 1.
		GmExperience	-> 1.
		GmArmorClass	-> 3.

		GmHitPoints		-> (10 + 10 atRandom).
		NhHungover	-> false.
		GmConfused		-> false.
	}.! !

!GmCreature class methodsFor: 'class attributes' stamp: 'cr 3/5/2005 19:58'!
brainClass
	^GmGenericBrain
! !

!GmCreature class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 01:10'!
canCreateIn: aMap
	^aMap creationState level >= self minCreationLevel

! !

!GmCreature class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 01:01'!
minCreationLevel
	^0
! !


!GmDoor class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $+ color: Color black name: 'door'
! !

!GmDoor class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:29'!
isConcrete
	^true
! !


!GmFloor class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $. color: Color black name: 'floor tile'
! !

!GmFloor class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:29'!
isConcrete
	^true
! !


!GmObjectDescription methodsFor: 'initialization' stamp: 'cr 1/3/2004 20:08'!
initializeFor: mapEntry
	^self subclassResponsibility! !


!GmAsciiObjectDescription methodsFor: 'initialization' stamp: 'cr 1/3/2004 10:48'!
letter: ltr color: clr name: nm
	letter := ltr.
	color := clr.
	name := nm.

! !

!GmAsciiObjectDescription methodsFor: 'accessing' stamp: 'cr 1/3/2004 21:53'!
color
	^color
! !

!GmAsciiObjectDescription methodsFor: 'accessing' stamp: 'cr 1/2/2004 19:46'!
letter
	^letter
! !

!GmAsciiObjectDescription methodsFor: 'accessing' stamp: 'cr 1/2/2004 19:46'!
name
	^name
! !

!GmAsciiObjectDescription methodsFor: 'junk' stamp: 'cr 3/3/2005 03:06'!
flort
        ^self class name, ' letter: ', letter printString, ' color: Color black name: ', name printString.! !


!GmObjectDescription class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 20:09'!
for: mapEntry
	^self basicNew initializeFor: mapEntry
! !

!GmObjectDescription class methodsFor: 'instance creation' stamp: 'cr 1/2/2004 19:49'!
new
	^self shouldNotImplement
! !


!GmAsciiObjectDescription class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 10:47'!
letter: char color: clr name: nameString
	^self basicNew letter: char color: clr name: nameString.! !


!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
message
	^message! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
message: newValue
	message := newValue! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
messageArgs
	^messageArgs! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
messageArgs: newValue
	messageArgs := newValue! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
morph
	^morph! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
morph: newValue
	morph := newValue! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
object
	^object! !

!GmPanelEntry methodsFor: 'accessing' stamp: 'cr 1/31/2005 11:37'!
object: newValue
	object := newValue! !

!GmPanelEntry methodsFor: 'updating' stamp: 'cr 1/31/2005 11:40'!
update
	| value |
	value := object perform: message withArguments: messageArgs.
	morph text: value asString.
! !


!GmPanelEntry class methodsFor: 'instance creation' stamp: 'cr 1/31/2005 11:38'!
on: aMorph and: gameObject sending: message withArgs: argList
	^self new
		morph: aMorph;
		object: gameObject;
		message: message;
		messageArgs: argList;
		yourself.
! !


!GmPlayerBrain methodsFor: 'accessing' stamp: 'cr 3/3/2005 14:59'!
game
	^game! !

!GmPlayerBrain methodsFor: 'accessing' stamp: 'cr 3/3/2005 14:59'!
game: newValue
	game := newValue! !

!GmPlayerBrain methodsFor: 'stimulus' stamp: 'cr 3/11/2005 14:39'!
notify: aNotification
	game playerMessage: aNotification.
! !

!GmPlayerBrain methodsFor: 'response' stamp: 'cr 3/10/2005 02:36'!
makeMove
	"no-op. The actual move gets done from the GUI."
! !

!GmPlayerBrain methodsFor: 'tests' stamp: 'cr 3/10/2005 03:02'!
isPlayerBrain
	^true
! !


!GmPortal methodsFor: 'accessing' stamp: 'cr 2/26/2005 01:39'!
coordinates
	^self map coordinatesOf: self.	"not fast"
! !

!GmPortal methodsFor: 'accessing' stamp: 'cr 2/23/2005 05:18'!
endPoint
	"Answer the value of endPoint"

	^ endPoint! !

!GmPortal methodsFor: 'accessing' stamp: 'cr 2/25/2005 01:02'!
endPoint: otherPortal
	"Set the value of endPoint.  Note that endpoints need to be two-way."

	endPoint := otherPortal.

	otherPortal endPoint == self
		ifFalse: [otherPortal endPoint: self].
! !

!GmPortal methodsFor: 'accessing' stamp: 'cr 2/25/2005 00:59'!
endPointMap
	^self endPoint map.
! !

!GmPortal methodsFor: 'accessing' stamp: 'cr 2/23/2005 16:29'!
map
	^map! !

!GmPortal methodsFor: 'accessing' stamp: 'cr 2/23/2005 16:29'!
map: newValue
	map := newValue! !

!GmPortal methodsFor: 'maps' stamp: 'cr 2/23/2005 05:23'!
destinationMap
	^endPoint
		ifNil: [nil]
		ifNotNil: [endPoint map]
! !

!GmPortal methodsFor: 'invoking' stamp: 'cr 2/27/2005 01:36'!
displaceOccupant
	| coord occupant |
	coord := self coordinates.
	occupant := map creatureAt: coord.

	occupant ifNil: [^self].

	self displaceOccupantOf: coord in: map
! !

!GmPortal methodsFor: 'type tests' stamp: 'cr 2/25/2005 00:50'!
isPortal
	^true! !

!GmPortal methodsFor: 'construction' stamp: 'cr 2/23/2005 16:17'!
endpointClass
	^self class! !

!GmPortal methodsFor: 'construction tests' stamp: 'cr 2/23/2005 16:28'!
canReplaceWithPortal
	^false

	"Replacing a portal with another portal is a Bad Idea."
! !


!GmPortal class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:29'!
isConcrete
	^false! !


!GmResponse methodsFor: 'flow control' stamp: 'cr 2/27/2005 01:52'!
ifFailure: block
	^self subclassResponsibility
! !

!GmResponse methodsFor: 'flow control' stamp: 'cr 3/9/2005 18:48'!
ifKilledTarget: aBlock
! !

!GmResponse methodsFor: 'flow control' stamp: 'cr 3/9/2005 01:32'!
ifSpaceOccupied: aBlock
! !

!GmResponse methodsFor: 'flow control' stamp: 'cr 2/27/2005 01:52'!
ifSuccess: block
	^self subclassResponsibility
! !

!GmResponse methodsFor: 'flow control' stamp: 'cr 2/27/2005 01:53'!
ifSuccess: sBlock ifFailure: fBlock
	^self subclassResponsibility
! !

!GmResponse methodsFor: 'testing' stamp: 'cr 2/27/2005 01:50'!
isResponse
	^true! !


!GmFailure methodsFor: 'flow control' stamp: 'cr 3/6/2005 16:23'!
ifFailure: failureBlock
	^failureBlock valueMaybeWith: self.

! !

!GmFailure methodsFor: 'flow control' stamp: 'cr 1/3/2004 10:24'!
ifSuccess: successBlock
! !

!GmFailure methodsFor: 'flow control' stamp: 'cr 3/6/2005 16:23'!
ifSuccess: successBlock ifFailure: failureBlock
	^failureBlock valueMaybeWith: self
! !

!GmFailure methodsFor: 'testing' stamp: 'cr 1/3/2004 10:22'!
isStatusResponse
	^true
! !


!GmOccupied methodsFor: 'flow control' stamp: 'cr 3/9/2005 01:32'!
ifSpaceOccupied: aBlock
	^aBlock valueMaybeWith: self.
! !


!GmAlreadyUsed class methodsFor: 'instance creation' stamp: 'cr 3/7/2005 17:53'!
new
	^super desc: 'You''re already using it.'
! !


!GmCancelled class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 18:15'!
new
	^self desc: 'Never mind.'
! !


!GmDontHave class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:15'!
desc: aString
	^self shouldNotImplement
! !

!GmDontHave class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:17'!
item: aThing
	^super desc: 'You do not possess ', aThing descriptionString, '.'.! !


!GmImpossible class methodsFor: 'as yet unclassified' stamp: 'cr 3/6/2005 14:40'!
new
	^self desc: 'That''s impossible.'
! !


!GmKnapsackFull class methodsFor: 'as yet unclassified' stamp: 'cr 3/5/2005 16:13'!
new
	^self desc: 'There is no room in your knapsack.'
! !


!GmMissed class methodsFor: 'instance creation' stamp: 'cr 3/9/2005 18:34'!
creature: aCreature
	^super desc: 'You fail to hit ', aCreature theDescriptionString, '.'! !


!GmNoInventory class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 22:57'!
new
	^self desc: 'Your knapsack is empty.'
! !


!GmNoSlotsLeft class methodsFor: 'as yet unclassified' stamp: 'cr 3/6/2005 17:35'!
new
	^self desc: 'You have nowhere to put it.'.! !


!GmRoguelikeMapBuilder methodsFor: 'initialization' stamp: 'cr 2/24/2005 23:16'!
initializeToExtent: extent
	super initializeToExtent: extent.

	rooms := Set new.
! !

!GmRoguelikeMapBuilder methodsFor: 'map building' stamp: 'cr 2/24/2005 23:15'!
buildMap
	self initializeMap.
	self addRoomsAndTunnels.

! !

!GmRoguelikeMapBuilder methodsFor: 'creature placement' stamp: 'cr 3/2/2005 14:11'!
randomCandidatePoint
	^(rooms atRandom insetBy: 1) randomInternalPoint! !

!GmRoguelikeMapBuilder methodsFor: 'construction' stamp: 'cr 2/24/2005 23:15'!
addRoomsAndTunnels
	| attempts |
	self addRandomRoom.

	attempts := 0.
	[attempts < self maxRoomAttempts]
		whileTrue: [
			[	self newCorridorFrom: rooms atRandom.
				attempts := 0.		"Reset the counter on success."
			] on: GmAttemptsExceeded do: [
				attempts := attempts + 1
			].
		].

! !

!GmRoguelikeMapBuilder methodsFor: 'construction' stamp: 'cr 1/19/2004 23:06'!
randomDirection
	^{-1@0. 1@0. 0@-1. 0@1} atRandom! !

!GmRoguelikeMapBuilder methodsFor: 'construction-rooms' stamp: 'cr 3/2/2005 14:10'!
addRandomRoom
	self addRoomAround: (map bounds insetBy: self minRoomExtent * 3) randomInternalPoint



! !

!GmRoguelikeMapBuilder methodsFor: 'construction-rooms' stamp: 'cr 2/24/2005 23:10'!
addRoomAround: aPoint
	self addRoomWithBounds: (self validRoomBoundsAround: aPoint).
! !

!GmRoguelikeMapBuilder methodsFor: 'construction-rooms' stamp: 'cr 3/2/2005 14:25'!
addRoomWithBounds: aRect
	self addWallsFor: aRect.
	self fillRegion: aRect withInsideRectPoints with: GmFloor.
	rooms add: aRect.

! !

!GmRoguelikeMapBuilder methodsFor: 'construction-corridors' stamp: 'cr 3/2/2005 14:11'!
newCorridorFrom: startRoomRect
	| endPoint |

	endPoint := self tunnelFrom: (startRoomRect insideRect) randomInternalPoint.
	self addRoomAround: endPoint.

! !

!GmRoguelikeMapBuilder methodsFor: 'construction-corridors' stamp: 'cr 2/24/2005 22:33'!
tunnelFrom: startingPoint
	^GmTunneller digFrom: startingPoint in: map.
! !

!GmRoguelikeMapBuilder methodsFor: 'tests' stamp: 'cr 1/15/2004 23:39'!
canContainRect: aRect
	^self mapBounds containsRect: aRect
! !

!GmRoguelikeMapBuilder methodsFor: 'randomness constraints' stamp: 'cr 3/2/2005 14:33'!
maxRoomAttempts
	^30 max: (300 - (rooms size * 30))
! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 10/2/2004 20:47'!
adjacentPathOn: side inRect: aRect

	| adjDoorCount |

	adjDoorCount := 0.

	aRect perform: (side, 'InsideDo:') asSymbol with: [ :pt |
		(map featureAt: pt) isFloor
			ifFalse: [adjDoorCount := 0]
			ifTrue: [
				adjDoorCount := adjDoorCount + 1.
				adjDoorCount > self maxAdjacentDoors
					ifTrue: [^true].
			].
	].

	"This is here so that things like 'senders of' can find this method."
	[nil topInsideDo: nil; bottomInsideDo: nil; leftInsideDo: nil; rightInsideDo: nil].

	^false.

! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 3/2/2005 15:10'!
canMakeRoomShapedBy: aRect

	(self canContainRect: aRect)
		ifFalse: [^false].

	(self hasRoomIntersecting: aRect)
		ifTrue: [^false].

	(self needWackyDoorsFor: aRect)
		ifTrue: [^false].

	^true! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 1/27/2004 23:40'!
hasRoomIntersecting: aRect

	rooms do: [ :roomRect | (roomRect expanded intersects: aRect) ifTrue: [^true]].
	^false.
	! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 3/2/2005 13:51'!
needWackyDoorsFor: aRect

	"By 'wacky', I mean a wall made up of doors."

	"Because the tunnels are either horizontal or vertical (and NOT diagonal), we can prevent most
	 (all?) cases of door wackiness by returning true if any of the room's corners happen to occupy
	 an existing tunnel."

	aRect corners do: [ :cornerPt |
		(self map featureAt: cornerPt) isDug
			ifTrue: [^true].
	].

	^false! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 1/15/2004 22:40'!
roomRectAround: aPoint
	| rect |
	rect := 1@1 extent: (self randomPointBetween: self minRoomExtent and: self maxRoomExtent).
	^ rect translateBy: (self transFactorFor: rect toBeAround: aPoint).
! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 3/2/2005 14:11'!
transFactorFor: aRect toBeAround: aPoint
	| rangeRect |
	rangeRect := (aPoint - aRect origin) rect: (aPoint - aRect corner).

	^rangeRect randomInternalPoint max: 0@0.
! !

!GmRoguelikeMapBuilder methodsFor: 'room rectangles' stamp: 'cr 2/24/2005 23:09'!
validRoomBoundsAround: aPoint

	| rect |
	self maxSingleRoomAttempts timesRepeat: [
		(self canMakeRoomShapedBy: (rect := self roomRectAround: aPoint))
			ifTrue: [^rect].
	].

	GmAttemptsExceeded signal.
! !

!GmRoguelikeMapBuilder methodsFor: 'constants' stamp: 'cr 1/28/2004 01:32'!
maxAdjacentDoors
	^2
! !

!GmRoguelikeMapBuilder methodsFor: 'constants' stamp: 'cr 1/14/2004 21:43'!
maxRoomExtent
	^15@15.
! !

!GmRoguelikeMapBuilder methodsFor: 'constants' stamp: 'cr 2/24/2005 22:54'!
maxSingleRoomAttempts
	^30! !

!GmRoguelikeMapBuilder methodsFor: 'constants' stamp: 'cr 3/2/2005 15:09'!
minRoomDistance
	^10! !

!GmRoguelikeMapBuilder methodsFor: 'constants' stamp: 'cr 1/14/2004 21:44'!
minRoomExtent
	^4@4.
! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 3/2/2005 15:05'!
isTooCloseToOtherRoom: aRect
	rooms do: [ :room | (room within: self minRoomDistance of: aRect) ifTrue: [^true]].

	^false
! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 2/24/2005 23:16'!
nilOrValidRoomBoundsAround: aPoint

	| rect |
	self maxSingleRoomAttempts timesRepeat: [
"		failedRoomAttempts := failedRoomAttempts + 1."
		(self canMakeRoomShapedBy: (rect := self roomRectAround: aPoint))
			ifTrue: [
"				failedRoomAttempts := 0."
				^rect
			].
	].

	^nil
! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 1/24/2004 18:01'!
randomDirectionNot: direction
	^( {-1@0. 1@0. 0@-1. 0@1}  without: direction) atRandom! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 3/2/2005 14:11'!
randomRoomCornerPointFor: originPoint
	
	| rangeOrigin rangeCorner |
	rangeOrigin := originPoint + self minRoomExtent.
	rangeCorner := (originPoint + self maxRoomExtent) min: self mapExtent.
	^(rangeOrigin corner: rangeCorner) randomInternalPoint.
! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 3/2/2005 14:11'!
randomRoomOriginPoint
	^(1@1 extent: self mapExtent - self minRoomExtent) randomInternalPoint.
! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 1/15/2004 21:55'!
randomRoomRect
	| origin |

	origin := self randomRoomOriginPoint.
	^origin corner: (self randomRoomCornerPointFor: origin).
! !

!GmRoguelikeMapBuilder methodsFor: 'junk' stamp: 'cr 1/15/2004 23:01'!
rectIsSuitable: rect

	(self bounds containsRect: rect)
		ifFalse: [^false].

	rooms do: [ :roomRect | 
		(roomRect intersects: rect)
			ifTrue: [^false].
	].

	^true.
! !


!GmDownStairway methodsFor: 'type tests' stamp: 'cr 2/25/2005 00:52'!
isDownStairway
	^true
! !

!GmDownStairway methodsFor: 'construction' stamp: 'cr 2/23/2005 16:17'!
endpointClass
	^GmUpStairway! !


!GmDownStairway class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $> color: Color black name: 'stairs down'
! !

!GmDownStairway class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:30'!
isConcrete
	^true
! !


!GmStrength methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:24'!
modifierMessage
	^#strengthMod! !


!GmStuffManager methodsFor: 'initialization' stamp: 'cr 3/5/2005 21:31'!
initialize
	super initialize.
	self fillItemInfoFrom: GmThing.	! !

!GmStuffManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 22:13'!
armorForMap: aMap
	^(self itemsAvailableOnMap: aMap) select: [ :ci | ci itemClass isClothing]! !

!GmStuffManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 15:54'!
prepareObject: object forMap: map
	"nothing needs to be done for now."! !

!GmStuffManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 22:34'!
someArmorForMonsterIn: map
	^(self armorForMap: map) atRandom itemClass new.! !

!GmStuffManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 22:34'!
someWeaponForMonsterIn: map
	^(self weaponsForMap: map) atRandom itemClass new.! !

!GmStuffManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 22:13'!
weaponsForMap: aMap
	^(self itemsAvailableOnMap: aMap) select: [ :ci | ci itemClass isWeapon]! !


!GmSuccess methodsFor: 'control flow' stamp: 'cr 1/3/2004 10:19'!
ifFailure: failureBlock
! !

!GmSuccess methodsFor: 'control flow' stamp: 'cr 3/6/2005 16:23'!
ifSuccess: aBlock
	^aBlock valueMaybeWith: self.

! !

!GmSuccess methodsFor: 'control flow' stamp: 'cr 3/6/2005 16:24'!
ifSuccess: aBlock ifFailure: failureBlock
	^aBlock valueMaybeWith: self
! !

!GmSuccess methodsFor: 'testing' stamp: 'cr 1/3/2004 10:25'!
isStatusResponse
	^true
! !


!GmHitTarget methodsFor: 'accessing' stamp: 'cr 3/9/2005 18:41'!
target
	^target! !

!GmHitTarget methodsFor: 'accessing' stamp: 'cr 3/9/2005 18:41'!
target: newValue
	target := newValue! !


!GmHitTarget class methodsFor: 'instance creation' stamp: 'cr 3/9/2005 23:53'!
creature: aCreature

	| verb |
	verb := (self = GmHitTarget ifTrue: ['hit '] ifFalse: ['kill ']).
	^(super desc: 'You ', verb, aCreature theDescriptionString)
 		target: aCreature;
		yourself.
! !


!GmItemDropped class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:14'!
desc: aString
	^self shouldNotImplement! !

!GmItemDropped class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:14'!
item: obj
	^ super desc: 'You drop ', obj descriptionString, '.'.
! !


!GmKilledTarget methodsFor: 'flow control' stamp: 'cr 3/9/2005 18:47'!
ifKilledTarget: aBlock
	^aBlock valueMaybeWith: self
! !


!GmSilentSuccess methodsFor: 'testing' stamp: 'cr 3/18/2005 21:43'!
hasUserMessage
	^false
! !


!GmSilentSuccess class methodsFor: 'instance creation' stamp: 'cr 1/4/2004 15:27'!
new
	^self desc: ''.
! !


!GmSuccessfullyStoredItem class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:14'!
desc: aString
	^self shouldNotImplement
! !

!GmSuccessfullyStoredItem class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:16'!
item: obj
	^ super desc: 'You store ', obj descriptionString, ' in your knapsack.'
! !


!GmThing methodsFor: 'type tests' stamp: 'cr 4/3/2005 22:11'!
isClothing
	^self class isClothing! !

!GmThing methodsFor: 'type tests' stamp: 'cr 3/4/2005 17:43'!
isGem
	^false
! !

!GmThing methodsFor: 'type tests' stamp: 'cr 3/6/2005 17:12'!
isJewelry
	^false
! !

!GmThing methodsFor: 'type tests' stamp: 'cr 3/12/2005 05:41'!
isPantsOfYendor
	^false
! !

!GmThing methodsFor: 'type tests' stamp: 'cr 1/3/2004 23:10'!
isThing
	^true! !

!GmThing methodsFor: 'type tests' stamp: 'cr 4/3/2005 22:09'!
isWeapon
	^self class isWeapon
! !

!GmThing methodsFor: 'type info' stamp: 'cr 3/11/2005 14:30'!
pointValue
	"The number of points possessing one adds to your final score."
	^50! !

!GmThing methodsFor: 'type info' stamp: 'cr 3/5/2005 20:42'!
rootTypeName
	^#Thing
! !

!GmThing methodsFor: 'slot tests' stamp: 'cr 3/6/2005 17:44'!
fitsInSlot: aSlot
	^aSlot type = self slotType.! !

!GmThing methodsFor: 'slot tests' stamp: 'cr 3/6/2005 19:48'!
isPutOnAble

	"I.e. it's jewelry, which is 'put on' instead of 'worn'.  Yes, I know this is a tortured
	 distinction.  Blame the NetHack dev team."

	^GmDeployments putOnSlotTypeNames includes: self slotType! !

!GmThing methodsFor: 'slot tests' stamp: 'cr 3/6/2005 19:46'!
isWearable
	^GmDeployments wearSlotTypeNames includes: self slotType! !

!GmThing methodsFor: 'slot tests' stamp: 'cr 3/6/2005 19:46'!
isWieldable
	^GmDeployments wieldSlotTypeNames includes: self slotType! !

!GmThing methodsFor: 'slot info' stamp: 'cr 3/6/2005 17:39'!
slotType
	^#none		"Needs to match the names in slot 'type' field."! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:09'!
armorClassMod
	^0
! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
charismaMod
	^0
! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
constitutionMod
	^0
! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
dexterityMod
	^0
! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
intelligenceMod
	^0
! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
strengthMod
	^0
! !

!GmThing methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
wisdomMod
	^0
! !


!GmClothing methodsFor: 'type tests' stamp: 'cr 4/3/2005 19:05'!
isPair
	^false! !

!GmClothing methodsFor: 'utility' stamp: 'cr 4/3/2005 18:58'!
descriptionAsPair
	^'pair of ', (self className allButFirst: 2) studlyCapsToWords! !

!GmClothing methodsFor: 'description' stamp: 'cr 4/3/2005 19:07'!
descriptionString
	self isPair ifFalse: [^super descriptionString].
	^self descriptionAsPair withIndefiniteArticle
! !

!GmClothing methodsFor: 'description' stamp: 'cr 4/3/2005 19:07'!
theDescriptionString
	self isPair ifFalse: [^super descriptionString].
	^self descriptionAsPair withDefiniteArticle
! !


!GmBoots methodsFor: 'slot info' stamp: 'cr 3/12/2005 04:49'!
slotType
	^#feet! !

!GmBoots methodsFor: 'type tests' stamp: 'cr 4/3/2005 19:06'!
isPair
	^true! !


!GmGem methodsFor: 'type info' stamp: 'cr 3/11/2005 14:30'!
pointValue
	^1000
! !

!GmGem methodsFor: 'type tests' stamp: 'cr 3/4/2005 17:44'!
isGem
	^true
! !


!GmGloves methodsFor: 'type tests' stamp: 'cr 4/3/2005 19:06'!
isPair
	^true! !

!GmGloves methodsFor: 'slot info' stamp: 'cr 3/12/2005 04:49'!
slotType
	^#hands! !


!GmHelmet methodsFor: 'slot info' stamp: 'cr 3/7/2005 17:28'!
slotType
	^#head
! !


!GmAssHat methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:29'!
armorClassMod
	^1
! !


!GmJewelry methodsFor: 'type tests' stamp: 'cr 3/8/2005 03:30'!
isJewelry
	^true
! !


!GmPants methodsFor: 'slot info' stamp: 'cr 3/12/2005 05:31'!
slotType
	^#lowerBody
! !

!GmPants methodsFor: 'type tests' stamp: 'cr 4/3/2005 19:06'!
isPair
	^true! !


!GmRing methodsFor: 'slot info' stamp: 'cr 3/8/2005 03:31'!
slotType
	^#finger
! !


!GmSuit methodsFor: 'slot info' stamp: 'cr 3/12/2005 04:47'!
slotType
	^#upperBody! !


!GmThing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:00'!
canCreateIn: aMap
	^aMap creationState level >= self minCreationLevel.
! !

!GmThing class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 22:11'!
isClothing
	"I.e. is it armor?  For our purposes, Clothing == Armor."
	^false
! !

!GmThing class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 22:10'!
isWeapon
	^false! !

!GmThing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:00'!
minCreationLevel
	^0
! !


!GmClothing class methodsFor: 'ascii tiles' stamp: 'cr 3/7/2005 17:33'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'armor'! !

!GmClothing class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 22:12'!
isClothing
	^true
! !


!GmAssHat class methodsFor: 'object management stats' stamp: 'cr 3/7/2005 17:34'!
isConcrete
	^true
! !


!GmRing class methodsFor: 'ascii tiles' stamp: 'cr 3/8/2005 03:32'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring'! !


!GmRingOfNothing class methodsFor: 'object management stats' stamp: 'cr 3/8/2005 03:34'!
isConcrete
	^true
! !


!GmToolUser methodsFor: 'creature actions' stamp: 'cr 3/9/2005 02:30'!
attacks
	| attacks |
	attacks := slots allWielded
				inject: OrderedCollection new
					into: [ :list :weapon | list addAll: (weapon attacksFrom: self); yourself].

	^attacks isEmpty
		ifTrue: [self intrinsicAttacks]
		ifFalse: [attacks]
! !

!GmToolUser methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 21:24'!
usesTools
	^true
! !

!GmToolUser methodsFor: 'tests--capabilites' stamp: 'cr 3/12/2005 01:44'!
walks
	^true! !


!GmHumanoid methodsFor: 'initialization' stamp: 'cr 3/6/2005 19:40'!
addSlots
	slots := GmDeployments newForHumanoid.
! !

!GmHumanoid methodsFor: 'tests--capabilites' stamp: 'cr 1/9/2004 19:14'!
flies
	^false
! !

!GmHumanoid methodsFor: 'tests--capabilites' stamp: 'cr 1/9/2004 19:14'!
swims
	^false
! !

!GmHumanoid methodsFor: 'tests--capabilites' stamp: 'cr 1/9/2004 19:14'!
walks
	^true
! !

!GmHumanoid methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 22:51'!
wearsArmor
	^true! !

!GmHumanoid methodsFor: 'type tests' stamp: 'cr 4/3/2005 21:23'!
isHumanoid
	^true! !


!GmTunnelFloor methodsFor: 'construction tests' stamp: 'cr 3/20/2005 16:30'!
canReplaceWithPortal
	^false		"No portals in the tunnels, please."! !

!GmTunnelFloor methodsFor: 'type tests' stamp: 'cr 3/3/2005 23:29'!
isLit
	^false
! !

!GmTunnelFloor methodsFor: 'type tests' stamp: 'cr 3/2/2005 23:27'!
isTunnelFloor
	^true
! !


!GmTunnelFloor class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $# color: Color black name: 'tunnel floor'
! !


!GmTunneller methodsFor: 'initialization' stamp: 'cr 2/24/2005 22:41'!
map: newMap position: pos
	map := newMap.
	position := pos.

	hitDoor := false.
	direction := self randomDirection.
! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 2/24/2005 22:34'!
digAt: coord or: quitBlock
	self eval: quitBlock unlessDiggableAt: coord.
	map at: coord putFeature: (map featureAt: coord) constrDigYields new.

! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 3/2/2005 14:45'!
digStraightOr: quitBlock
	direction := self randomNewDirection.

	self segmentLength timesRepeat: [
		self digAt: position + direction or: quitBlock.
		position := position + direction.
		self evalIfAtSecondDoor: quitBlock.
	].

	^position
		
	! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 3/2/2005 14:47'!
digTunnel
	(self minZigZags to: self maxZigZags) atRandom
		timesRepeat: [self digStraightOr: [^self]].
! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 2/24/2005 22:34'!
eval: doneBlock unlessDiggableAt: coord
	| feature |

	(map containsPoint: coord)
		ifFalse: [^doneBlock value].

	feature := map featureAt: coord.
	(feature isDug or: [feature canReplaceWithDoor not])
		ifTrue: [^doneBlock value].


! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 2/24/2004 01:26'!
evalIfAtSecondDoor: quitBlock
	"Evaluate 'quitBlock' if the current position contains a door and this is the second time
	 we've found one.

	 This makes a lot more sense if you realize that 
		1) evaluating quitBlock has the effect of ending the entire tunnelling operation and
		2) finding a second door means we've tunnelled from one room to another, an exit
		   condition.  (The first door comes from getting out of the starting room.)

	"

	(map featureAt: position) isDoor
		ifTrue: [
			hitDoor ifTrue: [^quitBlock value].
			hitDoor := true.
		].

! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 2/24/2005 22:41'!
randomDirection
	^{-1@0. 1@0. 0@-1. 0@1} atRandom
! !

!GmTunneller methodsFor: 'digging' stamp: 'cr 2/24/2005 23:22'!
randomNewDirection
	direction ifNil: [^self randomDirection].
	^({-1@0. 1@0. 0@-1. 0@1} select: [ :d | d ~= direction]) atRandom
! !

!GmTunneller methodsFor: 'accessing' stamp: 'cr 2/24/2004 01:27'!
position
	^position
! !

!GmTunneller methodsFor: 'random numbers' stamp: 'cr 2/24/2004 00:53'!
segmentLength
	^(self straightSegmentMinLen to: self straightSegmentMaxLen) atRandom! !

!GmTunneller methodsFor: 'constants' stamp: 'cr 2/24/2004 00:47'!
maxZigZags
	^10.
! !

!GmTunneller methodsFor: 'constants' stamp: 'cr 3/2/2005 14:48'!
minZigZags
	^2! !

!GmTunneller methodsFor: 'constants' stamp: 'cr 3/2/2005 14:45'!
straightSegmentMaxLen
	^10! !

!GmTunneller methodsFor: 'constants' stamp: 'cr 3/2/2005 15:29'!
straightSegmentMinLen
	^8! !


!GmTunneller class methodsFor: 'digging' stamp: 'cr 2/24/2004 01:29'!
digFrom: startPoint in: map
	^self new
		map: map position: startPoint;
		digTunnel;
		position.! !


!GmUnarmedAttack methodsFor: 'rolls' stamp: 'cr 3/11/2005 21:50'!
damageAmount
	^1 d: doer atStatStrength! !

!GmUnarmedAttack methodsFor: 'rolls' stamp: 'cr 4/2/2005 13:12'!
doerDamageRating
	^doer damageRating! !


!GmAttemptsExceeded methodsFor: 'armor' stamp: 'cr 3/12/2005 04:51'!
armorEntries
^{
"base class   description           cost  AC"
{GmSuit. 'leather jacket'.             10. 1}.
{GmSuit. 'leather armor'.               5. 2}.
{GmSuit. 'orcish ring mail'.           80. 2}.
{GmSuit. 'studded leather armor'.      15. 3}.
{GmSuit. 'ring mail'.                 100. 3}.
{GmSuit. 'scale mail'.                 45. 4}.
{GmSuit. 'orcish chain mail'.          75. 4}.
{GmSuit. 'chain mail'.                 75. 5}.
{GmSuit. 'elven mithril coat'.        240. 5}.
{GmSuit. 'splint mail'.                80. 6}.
{GmSuit. 'banded mail'.                90. 6}.
{GmSuit. 'dwarvish mithril coat'.     240. 6}.
{GmSuit. 'bronze plate mail'.         400. 6}.
{GmSuit. 'plate mail'.                600. 7}.
{GmSuit. 'crystal plate mail'.        820. 7}.
{GmDragonSuit. 'red dragon scales'.         500. 3}.
{GmDragonSuit. 'white dragon scales'.       500. 3}.
{GmDragonSuit. 'orange dragon scales'.      500. 3}.
{GmDragonSuit. 'blue dragon scales'.        500. 3}.
{GmDragonSuit. 'green dragon scales'.       500. 3}.
{GmDragonSuit. 'yellow dragon scales'.      500. 3}.
{GmDragonSuit. 'black dragon scales'.       700. 3}.
{GmDragonSuit. 'silver dragon scales'.      700. 3}.
{GmDragonSuit. 'gray dragon scales'.        700. 3}.
{GmDragonSuit. 'red dragon scale mail'.     900. 9}.
{GmDragonSuit. 'white dragon scale mail'.   900. 9}.
{GmDragonSuit. 'orange dragon scale mail'.  900. 9}.
{GmDragonSuit. 'blue dragon scale mail'.    900. 9}.
{GmDragonSuit. 'green dragon scale mail'.   900. 9}.
{GmDragonSuit. 'yellow dragon scale mail'.  900. 9}.
{GmDragonSuit. 'black dragon scale mail'.  1200. 9}.
{GmDragonSuit. 'silver dragon scale mail'. 1200. 9}.
{GmDragonSuit. 'gray dragon scale mail'.   1200. 9}.
{GmHelmet. 'fedora'.                      1. 0}.
{GmHelmet. 'dunce cap'.                   1. 0}.
{GmHelmet. 'cornuthaum'.                 80. 0}.
{GmHelmet. 'dented pot'.                  8. 1}.
{GmHelmet. 'elven leather helm'.          8. 1}.
{GmHelmet. 'helmet'. 10. 1}.
{GmHelmet. 'orcish helm'.                10. 1}.
{GmHelmet. 'helm of brilliance'.         50. 1}.
{GmHelmet. 'hm of opposite alignment'.   50. 1}.
{GmHelmet. 'helm of telepathy'.          50. 1}.
{GmHelmet. 'dwarvish iron helm'.         20. 2}.
{GmGloves. 'leather gloves'.              8. 1}.
{GmBoots. 'low boots'.                   8. 1}.
{GmBoots. 'high boots'.                 12. 2}.
{GmBoots. 'iron shoes'.                 16. 2}
}.
! !


!GmUnusedSpace methodsFor: 'tests' stamp: 'cr 1/15/2004 23:57'!
allowsFlyers
	^false
! !

!GmUnusedSpace methodsFor: 'tests' stamp: 'cr 1/15/2004 23:58'!
allowsSwimmers
	^false
! !

!GmUnusedSpace methodsFor: 'tests' stamp: 'cr 1/15/2004 23:58'!
allowsWalkers
	^false
! !

!GmUnusedSpace methodsFor: 'construction tests' stamp: 'cr 1/24/2004 18:10'!
isDiggable
	^true
! !

!GmUnusedSpace methodsFor: 'type tests' stamp: 'cr 9/28/2004 23:44'!
isUnusedSpace
	^true.
! !


!GmUnusedSpace class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $  color: Color black name: 'solid rock'
! !

!GmUnusedSpace class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 20:30'!
isConcrete
	^true
! !


!GmUpStairway methodsFor: 'construction' stamp: 'cr 2/23/2005 16:17'!
endpointClass
	^GmDownStairway
! !

!GmUpStairway methodsFor: 'type tests' stamp: 'cr 2/25/2005 00:52'!
isUpStairway
	^true! !


!GmDungeonExit methodsFor: 'type tests' stamp: 'cr 3/12/2005 11:19'!
isDungeonExit
	^true.
! !


!GmUpStairway class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $< color: Color black name: 'stairs up'
! !

!GmUpStairway class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:30'!
isConcrete
	^true
! !


!GmViewRegion methodsFor: 'initialization' stamp: 'cr 3/3/2005 23:44'!
initialize: v
	viewer := v.

	self clearCache.
! !

!GmViewRegion methodsFor: 'updating' stamp: 'cr 3/4/2005 00:14'!
analyzePosition
	viewer yourFloor isLit
		ifTrue: [self createLitRoomViewable]
		ifFalse: [self createDarkRoomViewable].
! !

!GmViewRegion methodsFor: 'updating' stamp: 'cr 3/5/2005 19:49'!
clearCache

	"In this case, there's not really a cache.  This just sets the internal state to force a full recalculation
	 next time."
	
	viewableRect := 0@0 corner: -1@-1.		"null rectangle"
	enteredRoom := true.
! !

!GmViewRegion methodsFor: 'updating' stamp: 'cr 3/8/2005 16:17'!
createDarkRoomViewable
	| vc |
	vc := viewer coordinates.
	viewableRect := (vc - self darkRoomLightRadius corner: vc + self darkRoomLightRadius) 
						intersect: viewer map bounds.
! !

!GmViewRegion methodsFor: 'updating' stamp: 'cr 3/4/2005 16:47'!
createLitRoomViewable

	"This makes the somewhat limiting assumption that any lit room is rectangular."

	self stillInSameRoom
		ifTrue: [^self clearEnteredFlag].

	self setEnteredFlag.
	self calculateRoomRectangle.
! !

!GmViewRegion methodsFor: 'visibility' stamp: 'cr 3/4/2005 00:52'!
calculateRoomRectangle
	| top bottom left right |

	top		:= (self findEdge: 0@-1)	y.
	bottom 	:= (self findEdge: 0@1)	y.
	left		:= (self findEdge: -1@0)	x.
	right	:= (self findEdge: 1@0)	x.

	viewableRect := left@top corner: right@bottom.
! !

!GmViewRegion methodsFor: 'visibility' stamp: 'cr 4/3/2005 19:47'!
changedVisiblePointsDo: aBlock
	(viewer map changedPoints select: [ :pt | self canSeePoint: pt]) do: aBlock.
! !

!GmViewRegion methodsFor: 'visibility' stamp: 'cr 3/2/2005 23:35'!
containsPoint: aPoint
	^viewableRect containsPoint: aPoint
! !

!GmViewRegion methodsFor: 'visibility' stamp: 'cr 3/4/2005 17:15'!
fastVisiblePointsDo: aBlock
	^self canOptimize
		ifTrue: [self changedVisiblePointsDo: aBlock]
		ifFalse: [self visiblePointsDo: aBlock]
! !

!GmViewRegion methodsFor: 'visibility' stamp: 'cr 3/2/2005 23:39'!
ifIncludes: aPoint do: aBlock
	(self containsPoint: aPoint)
		ifTrue: [^aBlock value]
		ifFalse: [^nil]

! !

!GmViewRegion methodsFor: 'visibility' stamp: 'cr 3/4/2005 00:53'!
visiblePointsDo: aBlock
	viewableRect plusWalls allInteriorPointsDo: aBlock.
! !

!GmViewRegion methodsFor: 'whole-room updates' stamp: 'cr 3/3/2005 23:46'!
clearEnteredFlag
	enteredRoom := false.
! !

!GmViewRegion methodsFor: 'whole-room updates' stamp: 'cr 3/3/2005 23:46'!
setEnteredFlag
	enteredRoom := true.
! !

!GmViewRegion methodsFor: 'tests' stamp: 'cr 3/8/2005 16:25'!
canOptimize
	^self enteredRoom not and: [self lightRadiusSmall not]! !

!GmViewRegion methodsFor: 'tests' stamp: 'cr 4/3/2005 19:46'!
canSeePoint: point
	^viewableRect plusWalls containsPoint: point.! !

!GmViewRegion methodsFor: 'tests' stamp: 'cr 3/3/2005 23:47'!
enteredRoom
	^enteredRoom
! !

!GmViewRegion methodsFor: 'tests' stamp: 'cr 3/8/2005 16:25'!
lightRadiusSmall
	^viewableRect extent <= ((self darkRoomLightRadius * 2) + 1)! !

!GmViewRegion methodsFor: 'tests' stamp: 'cr 3/8/2005 16:24'!
stillInSameRoom
	"There's a bit of a kludge here: if the current viewableRect is small (the size used by unlit regions), we
	 assume that the player just entered the room.  This isn't *always* true but it's adequate for our purposes.
	 Modify this if that changes."

	^(viewableRect containsPoint: viewer coordinates) and: [self lightRadiusSmall not]
! !

!GmViewRegion methodsFor: 'printing' stamp: 'cr 3/4/2005 00:02'!
printOn: aStream
	super printOn: aStream.

	aStream nextPut: $(.
	viewableRect printOn: aStream.
	aStream nextPut: $).

! !

!GmViewRegion methodsFor: 'constants' stamp: 'cr 3/4/2005 17:28'!
darkRoomLightRadius
	^1@1! !

!GmViewRegion methodsFor: 'private-calculation' stamp: 'cr 3/4/2005 00:04'!
findEdge: direction
	| point map |
	point := viewer coordinates.
	map := viewer map.

	[(map featureAt: point) isLit] assert.

	[(map containsPoint: point) and: [(map featureAt: point) isLit]]
		whileTrue: [point := point + direction].

	^point.
! !


!GmViewRegion class methodsFor: 'instance creation' stamp: 'cr 3/2/2005 23:41'!
viewer: aCreature
	^self basicNew initialize: aCreature
! !


!GmWall methodsFor: 'tests' stamp: 'cr 1/14/2004 20:48'!
allowsFlyers
	^false! !

!GmWall methodsFor: 'tests' stamp: 'cr 1/14/2004 20:48'!
allowsSwimmers
	^false! !

!GmWall methodsFor: 'tests' stamp: 'cr 1/14/2004 20:48'!
allowsWalkers
	^false! !

!GmWall methodsFor: 'wall tests' stamp: 'cr 1/21/2004 01:12'!
isCornerWall
	^false
! !

!GmWall methodsFor: 'wall tests' stamp: 'cr 1/24/2004 18:11'!
isDiggable
	^true! !

!GmWall methodsFor: 'wall tests' stamp: 'cr 2/24/2005 03:23'!
isWall
	^true! !

!GmWall methodsFor: 'construction' stamp: 'cr 1/24/2004 18:30'!
constrDigYields
	^GmDoor.
! !


!GmCornerWall methodsFor: 'wall tests' stamp: 'cr 1/21/2004 01:12'!
isCornerWall
	^true.
! !

!GmCornerWall methodsFor: 'wall tests' stamp: 'cr 10/3/2004 18:31'!
isDiggable
	^false! !

!GmCornerWall methodsFor: 'construction tests' stamp: 'cr 10/3/2004 18:34'!
canReplaceWithDoor
	^false
! !


!GmCornerWall class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'wall'
! !

!GmCornerWall class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:31'!
isConcrete
	^true
! !


!GmEastWestWall class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'wall'
! !

!GmEastWestWall class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:31'!
isConcrete
	^true
! !


!GmNorthSouthWall class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:31'!
isConcrete
	^true
! !

!GmNorthSouthWall class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $| color: Color black name: 'wall'
! !


!GmWeapon methodsFor: 'type tests' stamp: 'cr 4/3/2005 21:46'!
isSword
	^false
! !

!GmWeapon methodsFor: 'slot info' stamp: 'cr 3/6/2005 19:07'!
slotType
	^#wield
! !

!GmWeapon methodsFor: 'attacks' stamp: 'cr 3/9/2005 23:25'!
attacksFrom: wielder
	^{GmWeaponAttack doer: wielder withWeapon: self}.! !

!GmWeapon methodsFor: 'attributes' stamp: 'cr 3/9/2005 19:00'!
damageRating
	^0! !


!GmAluminumBaseballBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 10:09'!
damageRating
	^25! !


!GmBattleSpork methodsFor: 'attributes' stamp: 'cr 4/3/2005 18:34'!
damageRating
	^7! !


!GmCrudeDagger methodsFor: 'attributes' stamp: 'cr 4/3/2005 21:07'!
damageRating
	^5! !


!GmSword methodsFor: 'type tests' stamp: 'cr 4/3/2005 21:46'!
isSword
	^true! !


!GmLongSword methodsFor: 'attributes' stamp: 'cr 3/12/2005 10:08'!
damageRating
	^20! !


!GmShortSword methodsFor: 'attributes' stamp: 'cr 3/12/2005 10:08'!
damageRating
	^10! !


!GmWeapon class methodsFor: 'ascii tiles' stamp: 'cr 3/5/2005 23:39'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $) color: Color red name: 'weapon'! !

!GmWeapon class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 22:09'!
isWeapon
	^true! !


!GmAluminumBaseballBat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:09'!
isConcrete
	^true
! !

!GmAluminumBaseballBat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:09'!
minCreationLevel
	^15
! !

!GmAluminumBaseballBat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 10:09'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $) color: Color red name: 'short sword'! !


!GmBattleSpork class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 21:04'!
isConcrete
	^true
! !

!GmBattleSpork class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 21:05'!
minCreationLevel
	^0! !

!GmBattleSpork class methodsFor: 'ascii tiles' stamp: 'cr 4/3/2005 21:05'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $) color: Color black name: 'battle spork'! !


!GmCrudeDagger class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 21:06'!
isConcrete
	^true
! !

!GmCrudeDagger class methodsFor: 'object management stats' stamp: 'cr 4/3/2005 21:06'!
minCreationLevel
	^0
! !

!GmCrudeDagger class methodsFor: 'ascii tiles' stamp: 'cr 4/3/2005 21:07'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $) color: Color black name: 'crude dagger'! !


!GmLongSword class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:07'!
isConcrete
	^true
! !

!GmLongSword class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:08'!
minCreationLevel
	^7
! !

!GmLongSword class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 10:07'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $) color: Color red name: 'short sword'! !


!GmShortSword class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 23:29'!
isConcrete
	^true
! !

!GmShortSword class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:07'!
minCreationLevel
	^0
! !

!GmShortSword class methodsFor: 'ascii tiles' stamp: 'cr 3/5/2005 23:39'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $) color: Color red name: 'short sword'! !


!GmWeaponAttack methodsFor: 'notifications' stamp: 'cr 4/2/2005 23:13'!
rcptHitNotification
	^GmAttacked theCreature: self doer does: self attacksMessage.
! !

!GmWeaponAttack methodsFor: 'rolls' stamp: 'cr 3/9/2005 19:02'!
damageAmount
	^doer atStatStrength d: self weapon damageRating! !

!GmWeaponAttack methodsFor: 'rolls' stamp: 'cr 4/2/2005 13:11'!
doerDamageRating
	^self weapon damageRating.
! !

!GmWeaponAttack methodsFor: 'accessing' stamp: 'cr 3/9/2005 23:31'!
weapon
	^weapon! !

!GmWeaponAttack methodsFor: 'accessing' stamp: 'cr 3/9/2005 23:31'!
weapon: newValue
	weapon := newValue! !


!GmWeaponAttack class methodsFor: 'instance creation' stamp: 'cr 3/9/2005 18:21'!
doer: aCreature
	self shouldNotImplement.
! !

!GmWeaponAttack class methodsFor: 'instance creation' stamp: 'cr 3/9/2005 23:33'!
doer: aCreature withWeapon: aWeapon
	^(super doer: aCreature) 
		weapon: aWeapon;
		yourself.
! !


!GmWisdom methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:25'!
modifierMessage
	^#wisdomMod! !


!GmYouSee class methodsFor: 'description string creation' stamp: 'cr 4/3/2005 20:14'!
fixtureDescriptionFor: aCreature
	^aCreature featureHere isPortal
		ifTrue: ['There is ', aCreature featureHere descriptionString, ' here.']
		ifFalse: [''].	! !

!GmYouSee class methodsFor: 'description string creation' stamp: 'cr 4/3/2005 20:16'!
stuffPileDescriptionFor: aCreature

	aCreature stuffHere isEmpty ifTrue: [^''].

	aCreature stuffHere size > 6
		ifTrue: [^'There are many items here.  '].

	^'You see here: ', aCreature stuffHere objDescriptionListString, '.  '
! !

!GmYouSee class methodsFor: 'instance creation' stamp: 'cr 3/5/2005 23:42'!
desc: string
	^self shouldNotImplement.
! !

!GmYouSee class methodsFor: 'instance creation' stamp: 'cr 4/3/2005 20:08'!
recipient: aCreature
	^super desc: (self stuffPileDescriptionFor: aCreature), (self fixtureDescriptionFor: aCreature)! !


!GmYouSeeNoNounHere class methodsFor: 'instance creation' stamp: 'cr 2/26/2005 01:20'!
noun: aString
	^super desc: 'You see no ', aString, ' here.'.
! !


!Integer methodsFor: '*ObjHack-Dice' stamp: 'cr 4/2/2005 22:16'!
d: sides
	^((1 to: self) collect: [ :x | (1 to: sides) atRandom]) sum

	"This will make a whole lot more sense if you're familiar with the XdY notation
	 used by some games to describe dice rolling.  X is the number of dice and Y is the
	 number of size.

	 For example, rolling 5 6-sided dice is notated as 5d6 or, in Smalltalk, 5 d: 6."! !


!Morph methodsFor: 'halos and balloon help' stamp: 'cr 3/13/2005 22:03'!
addHalo: evt
	| halo prospectiveHaloClass |

	Preferences allHalosDisabled ifTrue: [^self].

	prospectiveHaloClass _ Smalltalk at: self haloClass ifAbsent: [HaloMorph].
	halo _ prospectiveHaloClass new bounds: self worldBoundsForHalo.
	halo popUpFor: self event: evt.
	^halo! !


!GmPrefabFullScreenManager methodsFor: 'initialization' stamp: 'cr 3/24/2005 19:16'!
initialize
	super initialize.
	self stopStepping.
	! !

!GmPrefabFullScreenManager methodsFor: 'screen filling' stamp: 'cr 3/24/2005 19:21'!
step

	| wsm |

	 "It seems that we get steps even when we don't want them."
	self owner = World ifFalse: [^self stopStepping]. 

	self extent = World extent
		ifFalse: [self bounds: World bounds].

	wsm := World submorphs.
	(wsm isEmpty not and: [wsm last == self])	"If wsm is empty, that assumes we haven't been restored yet."
		ifFalse: [World addMorphBack: self].
! !

!GmPrefabFullScreenManager methodsFor: 'screen filling' stamp: 'cr 3/13/2005 22:21'!
stepTime
	^500		"Twice a second."! !

!GmPrefabFullScreenManager methodsFor: 'events' stamp: 'cr 3/27/2005 16:20'!
handlesMouseDown: evt
	^true! !


!NhAmber methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^1000
! !


!NhAmber class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'amber'

! !

!NhAmber class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhAmethyst methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^600
! !


!NhAmethyst class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'amethyst'

! !

!NhAmethyst class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhAquamarine methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^1500
! !


!NhAquamarine class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'aquamarine'

! !

!NhAquamarine class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhBandedMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^6
! !


!NhBandedMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'banded mail'

! !

!NhBandedMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhBandedMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhBestiary methodsFor: 'calculations' stamp: 'cr 4/3/2005 21:09'!
numRequiredIn: map
	"Given a map, figure out how many items are to be created here initially."
	^ map creationState isBottom
		ifTrue: [10 d: 8]
		ifFalse: [(10 to: 30) atRandom].
! !

!NhBestiary methodsFor: 'map population' stamp: 'cr 4/3/2005 21:09'!
addExtraDevilBunniesTo: map
	(10 d: 4) timesRepeat: [self addItem: NhDevilBunny to: map ifUnable: []].
! !

!NhBestiary methodsFor: 'map population' stamp: 'cr 4/3/2005 22:02'!
prepareObject: creature forMap: map

	| stuffMgr |
	stuffMgr := game stuffManager.

	"We need to level each monster up to a difficult level corresponding to its depth."
	creature statExperience setLevelValue: map creationState level.

	"And we need to arm the creature with appropriate weapons and armor."
	creature usesTools
		ifTrue: [creature insertAndDeploy: (stuffMgr someWeaponForMonsterIn: map) or: []].

	creature isHumanoid
		ifTrue: [
			self armorTries atRandom 
				timesRepeat: [creature insertAndDeploy: (stuffMgr someArmorForMonsterIn: map) or: []].
		].! !

!NhBestiary methodsFor: 'map population' stamp: 'cr 4/3/2005 21:09'!
setupMap: aMap
	super setupMap: aMap.

	aMap creationState isBottom 		"note: add more checks if more than one branch"
		ifTrue: [self addExtraDevilBunniesTo: aMap].
! !

!NhBestiary methodsFor: 'constants' stamp: 'cr 4/3/2005 21:59'!
armorTries
	^5! !


!NhBlackDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhBlackDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'black dragon scale mail'

! !

!NhBlackDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhBlackDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^12
! !


!NhBlackDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhBlackDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'black dragon scales'

! !

!NhBlackDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhBlackDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^7
! !


!NhBlackNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhBlackNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhBlackNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhBlackNagaHatchling class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $N color: Color black name: 'black naga hatchling'

! !

!NhBlackNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBlackNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhBlackNagaHatchling class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhBlueDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhBlueDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'blue dragon scale mail'

! !

!NhBlueDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhBlueDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^9
! !


!NhBlueDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhBlueDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'blue dragon scales'

! !

!NhBlueDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhBlueDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^5
! !


!NhBronzePlateMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^6
! !


!NhBronzePlateMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'bronze plate mail'

! !

!NhBronzePlateMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhBronzePlateMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^4
! !


!NhBugbear methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBugbear methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhBugbear methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhBugbear class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $h color: Color black name: 'bugbear'

! !

!NhBugbear class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBugbear class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhBugbear class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 6.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhChainMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^5
! !


!NhChainMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'chain mail'

! !

!NhChainMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhChainMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhCommonHelmet methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhCommonHelmet class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'helmet'

! !

!NhCommonHelmet class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhCommonHelmet class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhCornuthaum methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^0
! !

!NhCornuthaum methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:28'!
intelligenceMod
	^4
! !


!NhCornuthaum class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'cornuthaum'

! !

!NhCornuthaum class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhCornuthaum class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhCrystalPlateMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^7
! !


!NhCrystalPlateMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'crystal plate mail'

! !

!NhCrystalPlateMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhCrystalPlateMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^8
! !


!NhDentedPot methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhDentedPot class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'dented pot'

! !

!NhDentedPot class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhDentedPot class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhDiamond methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^4000
! !


!NhDiamond class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'diamond'

! !

!NhDiamond class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhDilithiumCrystal methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^4500
! !


!NhDilithiumCrystal class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'dilithium crystal'

! !

!NhDilithiumCrystal class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhBabyBlackDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyBlackDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyBlackDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyBlueDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyBlueDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyBlueDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyGrayDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyGrayDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyGrayDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyGreenDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyGreenDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyGreenDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyOrangeDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyOrangeDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyOrangeDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyRedDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyRedDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyRedDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabySilverDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabySilverDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabySilverDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyWhiteDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyWhiteDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyWhiteDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhBabyYellowDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhBabyYellowDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhBabyYellowDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 10:39'!
initialStatValues
	^super initialStatValues,
	{
		GmArmorClass	-> 6.
	}! !


!NhBabyBlackDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby black dragon'

! !

!NhBabyBlackDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyBlackDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyBlackDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyBlueDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby blue dragon'

! !

!NhBabyBlueDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyBlueDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyBlueDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyGrayDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby gray dragon'

! !

!NhBabyGrayDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyGrayDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyGrayDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyGreenDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby green dragon'

! !

!NhBabyGreenDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyGreenDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyGreenDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyOrangeDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby orange dragon'

! !

!NhBabyOrangeDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyOrangeDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyOrangeDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyRedDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby red dragon'

! !

!NhBabyRedDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyRedDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyRedDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabySilverDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby silver dragon'

! !

!NhBabySilverDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabySilverDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabySilverDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyWhiteDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby white dragon'

! !

!NhBabyWhiteDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyWhiteDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyWhiteDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhBabyYellowDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'baby yellow dragon'

! !

!NhBabyYellowDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBabyYellowDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhBabyYellowDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhDunceCap methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^0
! !


!NhDunceCap class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'dunce cap'

! !

!NhDunceCap class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhDunceCap class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhDungeonBuilderState methodsFor: 'initialization' stamp: 'cr 3/5/2005 19:44'!
initialize
	super initialize.
	branchName = #main.
! !

!NhDungeonBuilderState methodsFor: 'constants' stamp: 'cr 3/5/2005 19:29'!
defaultMapExtent
	^160@50
! !

!NhDungeonBuilderState methodsFor: 'constants' stamp: 'cr 3/14/2005 19:59'!
maxLevelsPerBranch
	^20! !

!NhDungeonBuilderState methodsFor: 'copying' stamp: 'cr 3/5/2005 19:44'!
nextLevelOnBranch: branch

	"Insert cleverness here.  Specifically, we can use branchnum and index to figure whether
	 this is a sidebranch and if so how to deal with it.  For now, we ignore the branch number."

	^self copy
		level: level + 1;
		branch: branch;
		yourself.! !

!NhDungeonBuilderState methodsFor: 'copying-private' stamp: 'cr 3/5/2005 19:44'!
branch: branch
	branchNum := branch.
! !

!NhDungeonBuilderState methodsFor: 'map information' stamp: 'cr 3/5/2005 19:46'!
descriptionString
	^'Town Dungeon, level ', self level printString.

	"To do: return something different based on the value of branch.  This is to support side dungeons."! !

!NhDungeonBuilderState methodsFor: 'level information' stamp: 'cr 3/12/2005 11:12'!
mapGenerator
	^self isBottom
		ifTrue: [GmBigRoomBuilder]
		ifFalse: [GmRoguelikeMapBuilder]
! !

!NhDungeonBuilderState methodsFor: 'level information' stamp: 'cr 3/5/2005 20:07'!
outPortalsHere
	"Return the portal objects leading out of here (to new levels)."
	| result |

	self isBottom ifTrue: [^#()].

[
	result := OrderedCollection with: GmDownStairway new.

	"There are branches at levels 2 and 4."
	(level = 2 or: [level = 4])
		ifTrue: [result add: GmDownStairway new].
].

	result := {GmDownStairway new}.
	^result.
! !

!NhDungeonBuilderState methodsFor: 'level information' stamp: 'cr 3/12/2005 10:13'!
totalMapsToBeGenerated

	"This needs to be calculated in advance, since it's used for showing a progress bar."
	
	^self maxLevelsPerBranch.
! !

!NhDungeonBuilderState methodsFor: 'level customization' stamp: 'cr 3/12/2005 11:57'!
finalChangesTo: aMap

	aMap creationState isTop
		ifTrue: [aMap addPortal: GmDungeonExit new].
! !


!NhDwarf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhDwarf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhDwarf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhDwarf class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $h color: Color black name: 'dwarf'

! !

!NhDwarf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDwarf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhDwarf class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhDwarfKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhDwarfKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhDwarfKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhDwarfKing class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $h color: Color black name: 'dwarf king'

! !

!NhDwarfKing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDwarfKing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhDwarfKing class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhDwarfLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhDwarfLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhDwarfLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhDwarfLord class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $h color: Color black name: 'dwarf lord'

! !

!NhDwarfLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDwarfLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhDwarfLord class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 7.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhDwarvishIronHelm methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^2
! !


!NhDwarvishIronHelm class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'dwarvish iron helm'

! !

!NhDwarvishIronHelm class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhDwarvishIronHelm class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhDwarvishMithrilCoat methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^6
! !


!NhDwarvishMithrilCoat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'dwarvish mithril coat'

! !

!NhDwarvishMithrilCoat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhDwarvishMithrilCoat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^2
! !


!NhElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^440
! !

!NhElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhElf class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $@ color: Color black name: 'elf'

! !

!NhElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^10
! !

!NhElf class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 15.
		GmConstitution	-> 12.
		GmExperience	-> 11.
		GmDexterity		-> 17.
	}.
! !


!NhElfLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhElfLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^360
! !

!NhElfLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhElfLord class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $@ color: Color black name: 'elf-lord'

! !

!NhElfLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhElfLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^8
! !

!NhElfLord class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 13.
		GmConstitution	-> 11.
		GmExperience	-> 9.
		GmDexterity		-> 15.
	}.
! !


!NhElvenLeatherHelm methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhElvenLeatherHelm class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'elven leather helm'

! !

!NhElvenLeatherHelm class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhElvenLeatherHelm class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhElvenMithrilCoat methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^5
! !


!NhElvenMithrilCoat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'elven mithril coat'

! !

!NhElvenMithrilCoat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhElvenMithrilCoat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^2
! !


!NhEmerald methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^2500
! !


!NhEmerald class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'emerald'

! !

!NhEmerald class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhFedora methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^0
! !


!NhFedora class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'fedora'

! !

!NhFedora class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhFedora class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhFluorite methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^400
! !


!NhFluorite class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'fluorite'

! !

!NhFluorite class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhFlyingThing methodsFor: 'tests-capabilities' stamp: 'cr 3/12/2005 01:43'!
flies
	^true
! !

!NhFlyingThing methodsFor: 'tests-capabilities' stamp: 'cr 3/12/2005 01:43'!
swims
	^false! !

!NhFlyingThing methodsFor: 'tests-capabilities' stamp: 'cr 3/12/2005 01:43'!
walks
	^true! !


!NhBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhBat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $B color: Color black name: 'bat'

! !

!NhBat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhBat class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhCrow methodsFor: 'attributes' stamp: 'cr 3/10/2005 03:35'!
bareIntrinsicAttackClasses
	^{GmUnarmedAttack. GmUnarmedAttack}
! !

!NhCrow methodsFor: 'attributes' stamp: 'cr 3/12/2005 02:09'!
damageRating
	^1! !

!NhCrow methodsFor: 'attributes' stamp: 'cr 3/10/2005 00:04'!
experienceValue
	^10
! !

!NhCrow methodsFor: 'attributes' stamp: 'cr 3/12/2005 00:10'!
toHitRating
	^1! !


!NhCrow class methodsFor: 'ascii tiles' stamp: 'cr 3/10/2005 03:35'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $B color: Color black name: 'crow'
! !

!NhCrow class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:28'!
isConcrete
	^true
! !

!NhCrow class methodsFor: 'stat defaults' stamp: 'cr 3/11/2005 15:18'!
initialStatValues
	^super initialStatValues, 
	{
		GmStrength 		-> 3.
		GmWisdom		-> 1.
		GmIntelligence	-> 5.
		GmDexterity		-> 6.
		GmConstitution	-> 13.
		GmCharisma		-> 7.
		GmExperience	-> 3.
		GmArmorClass	-> 1.
	}.! !


!NhFogCloud methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhFogCloud methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhFogCloud methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhFogCloud class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $v color: Color black name: 'fog cloud'

! !

!NhFogCloud class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhFogCloud class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhFogCloud class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhForestCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhForestCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhForestCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhForestCentaur class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $C color: Color black name: 'forest centaur'

! !

!NhForestCentaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhForestCentaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhForestCentaur class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 7.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhGame methodsFor: 'initialization' stamp: 'cr 3/11/2005 13:56'!
initialize

	self initializeStateManagers.
	self initializePlayer.
	self initializeMap.
	self initializeView.

	debugMode := false.! !

!NhGame methodsFor: 'init-overridable' stamp: 'cr 4/3/2005 18:37'!
initializeMap

	| builder |
	builder := GmDungeonBuilder 
				inGame: self withState: NhDungeonBuilderState new 
					genManagers: {creatureManager. stuffManager}.

	dungeon := 	builder	buildDungeon;
					dungeon.

	dungeon placeCreature: self player.
	
	self player addToStuffHere: GmBattleSpork new.! !

!NhGame methodsFor: 'init-overridable' stamp: 'cr 3/5/2005 22:22'!
initializePlayer
	| brain |
	player := creatureManager createPlayer.
	brain := GmPlayerBrain for: player.
	player brain: brain.
	brain game: self.! !

!NhGame methodsFor: 'init-overridable' stamp: 'cr 4/3/2005 21:09'!
initializeStateManagers
	creatureManager := NhBestiary on: self.
	stuffManager := NhStuffManager on: self.
! !

!NhGame methodsFor: 'init-overridable' stamp: 'cr 1/21/2005 19:42'!
initializeView
	view := SimpleGUI on: self.
! !

!NhGame methodsFor: 'starting' stamp: 'cr 4/3/2005 18:48'!
go
	view openInWorld.
	view manager owner 
		extent: World extent // 2;
		position: World extent // 3.
	self displayWelcomeMessage.
	self showPlayerSquareContents.! !

!NhGame methodsFor: 'starting' stamp: 'cr 4/3/2005 18:48'!
showPlayerSquareContents
	
	"This only ever needs to be called when the game starts up.  Usually, the
	 GmYouSee gets returned as part of a move."

	self player inform: (GmYouSee recipient: self player).! !

!NhGame methodsFor: 'starting' stamp: 'cr 4/3/2005 18:48'!
startFullScreen
	view openInWholeWorld.
	World color: view manager color.
	self displayWelcomeMessage.
	self showPlayerSquareContents.
	view updateView.
! !

!NhGame methodsFor: 'accessing' stamp: 'cr 3/11/2005 13:57'!
debugMode
	^debugMode
! !

!NhGame methodsFor: 'accessing' stamp: 'cr 3/11/2005 13:57'!
debugMode: aBoolean
	debugMode := aBoolean.
! !

!NhGame methodsFor: 'accessing' stamp: 'cr 3/20/2005 18:45'!
dungeon
	^dungeon! !

!NhGame methodsFor: 'accessing' stamp: 'cr 3/20/2005 18:45'!
map
	^player map
! !

!NhGame methodsFor: 'accessing' stamp: 'cr 1/9/2004 19:27'!
player
	^player
! !

!NhGame methodsFor: 'accessing' stamp: 'cr 4/3/2005 21:34'!
stuffManager
	^stuffManager! !

!NhGame methodsFor: 'accessing' stamp: 'cr 1/8/2004 22:46'!
view
	^view
! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/11/2005 14:59'!
creaturesMove
	mapThisTurn shuffledNonPlayerCreatures
		do: [ :creature | creature isDead ifFalse: [creature brain makeMove]]
! !

!NhGame methodsFor: 'player action' stamp: 'cr 4/3/2005 18:46'!
displayWelcomeMessage

	| msg |
	msg :=	'Welcome to Quest For Pants, version ', self versionString, '\',
			'Copyright (C) 1996-2005 Chris Reuter and others.\',
			'(See the file Copyright.txt for details).\',
			'This program is distributed in the hope that it will be useful,\',
			'but WITHOUT ANY WARRANTY; without even the implied warranty\',
			'of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.'.

	view message: msg withCRs.

! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/3/2005 15:07'!
playerMessage: aNotification
	aNotification hasUserMessage
		ifTrue: [view message: aNotification humanDesc].
! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/10/2005 03:08'!
playerMove: eventSymbol
	(self player perform: eventSymbol)
		ifHasUserMessage: [ :response | view message: response humanDesc].


! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/11/2005 15:00'!
updateCreatures
	mapThisTurn allCreatures do: [ :creature | creature endOfTurnUpdate].
! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/11/2005 15:11'!
updateMapThisTurn
	mapThisTurn := player map.

	"If the player dies as a result of its first move, this will still be nil, so we set it to the top
	 of the dungeon so that the rest of the turn plays out correctly."
	mapThisTurn ifNil: [mapThisTurn := dungeon].! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/11/2005 15:00'!
updateVisuals
	self view updateView.
	mapThisTurn clearChangedPoints.! !

!NhGame methodsFor: 'player action' stamp: 'cr 3/24/2005 22:12'!
userEvent: eventSymbol
	self playerMove: eventSymbol.
	self updateMapThisTurn.
	self creaturesMove.

	player isDead ifTrue: [^self].

	self updateCreatures.
	self updateVisuals.
! !

!NhGame methodsFor: 'end of game' stamp: 'cr 4/3/2005 23:36'!
gameOverPlayerDied

	self updateVisuals.

	(self finalMessage findTokens: String cr) do: [ :line | view message: line].
	self inform: 'You have ', player totalPointValue printString, ' points.'.

	self quitGame.! !

!NhGame methodsFor: 'end of game' stamp: 'cr 3/24/2005 22:43'!
gameOverPlayerWins
	self
		inform: ('Congratulations.  You left the dungeon with ', player totalPointValue printString, 
				' points.\(That''s enough to fund a pretty impressive pub crawl.)') withCRs.
	self quitGame.
! !

!NhGame methodsFor: 'end of game' stamp: 'cr 3/12/2005 12:33'!
quitGame
	view close.
	self class quitUnlessDevelopment.
! !

!NhGame methodsFor: 'debug utils' stamp: 'cr 3/12/2005 12:16'!
createPants
	player addToStuffHere: (NhPantsOfYendor new).		"Yes, this creates duplicate pants."
! !

!NhGame methodsFor: 'debug utils' stamp: 'cr 4/4/2005 23:04'!
debugIfRequested
	"If the image name has been changed to the sooper sekret magic word, pop open
	 an inspector on the game."

	(Smalltalk imageName endsWith: 'wizardmode.image')
		ifTrue: [self inspect].
! !

!NhGame methodsFor: 'debug utils' stamp: 'cr 3/3/2005 15:29'!
magicMap
	view updateAllPoints.
! !

!NhGame methodsFor: 'debug utils' stamp: 'cr 4/2/2005 21:55'!
wizardMode
	| bb |

	"Put the game in debug mode and make the player really buff."

	debugMode := true.
	player statHitPoints increaseMaxBy: 200; add: 200.
	#('Strength' 'Dexterity' 'Constitution') do: [:stat | player atStat: stat put: 18].

	100 timesRepeat: [player statExperience add: 40].
	10000 timesRepeat: [player statExperience add: 800].

	player statExperience add: 100000000.

	bb := GmAluminumBaseballBat new.
	player inventory insert: bb.
	player deploy: bb.

	player markStatsChanged.

! !

!NhGame methodsFor: 'constants' stamp: 'cr 3/25/2005 08:58'!
finalMessage
	^
'Death appears.  He says, "AS THOU ART A DEMIGOD, THOU ART IMMORTAL.
BUT I''M GETTING SICK AND TIRED OF THY ALCOHOL-RELATED DEATHS SO THIS
TIME, I''M SENDING YOU OFF FOR REINCARNATION.  HAVE FUN TOILET
TRAINING AGAIN."'.! !

!NhGame methodsFor: 'constants' stamp: 'cr 3/12/2005 12:48'!
saveFileName
	^self class saveFileName.
! !

!NhGame methodsFor: 'constants' stamp: 'cr 3/25/2005 08:37'!
versionString
	^'1.0.1'.! !

!NhGame methodsFor: 'saving' stamp: 'cr 4/4/2005 23:02'!
saveAndQuit
	"To do: code some object-serialization code here."

	(self class isDevelopmentImage)
		ifTrue: [(nil confirm: 'Really save and quit?') or: [^self]].

	Smalltalk snapshot: true andQuit: true.

	self displayWelcomeMessage.
	self debugIfRequested.! !


!NhGame class methodsFor: 'instance creation' stamp: 'cr 3/26/2005 13:38'!
new
	^self basicNew initialize.! !

!NhGame class methodsFor: 'instance creation' stamp: 'cr 3/13/2005 14:11'!
newFromSaveFile
	| stream instance |

	self halt: 'serialization is not yet supported.  Don''t call this method.'.

	[
		stream := FileStream oldFileNamed: self saveFileName
	] on: FileDoesNotExistException do: [
		nil inform: 'No saved file found.  Creating new game'.
		^self new.
	].

	instance := self readSixxFrom: stream.
	stream close.
	^instance.! !

!NhGame class methodsFor: 'utilities' stamp: 'cr 3/11/2005 14:11'!
isDevelopmentImage
	"I use the presence of sources files to test if this is a development image or not.  The handy thing is that
	 I can then continue to hack on a production image just by dropping the source and changes files into
	 the working directory."
	^(SourceFiles first isNil and: [SourceFiles second isNil]) not
	! !

!NhGame class methodsFor: 'utilities' stamp: 'cr 3/11/2005 14:15'!
quitUnlessDevelopment
	self isDevelopmentImage
		ifTrue: [Transcript nextPutAll: 'Refusing to quit.'; cr; endEntry]
		ifFalse: [Smalltalk snapshot: false andQuit: true].! !

!NhGame class methodsFor: 'constants' stamp: 'cr 3/13/2005 21:10'!
backgroundImageName
	^'qfp-background.jpg'! !

!NhGame class methodsFor: 'constants' stamp: 'cr 3/12/2005 12:47'!
saveFileName
	^'qfp-saved-game.gam'! !

!NhGame class methodsFor: 'deliverables' stamp: 'cr 3/13/2005 20:59'!
deleteAllWindows
	World submorphs do: [ :sm | sm delete].
! !

!NhGame class methodsFor: 'deliverables' stamp: 'cr 3/13/2005 21:33'!
getAndHideAllWindows
	| list |
	list := World submorphs copy.
	list do: [ :sm | sm delete].
	^list.
! !

!NhGame class methodsFor: 'deliverables' stamp: 'cr 3/27/2005 16:35'!
makeDeliverable

	"First, save a copy of the image and let the user move it elsewhere.  We use the absence
	 of sources to identify which is which."
	| bg |
	Smalltalk snapshot: true andQuit: false.
	self isDevelopmentImage
		ifTrue: [
			nil inform: 'Copy the image elsewhere and run it with the VM.'.
			^self
		].


	"Now, we do cleanup and let the user resize the main screen, select a background
	 image and do whatever else needs to be done."	

	self rigImageForDeliverable.
	self deleteAllWindows.
	
	bg := Form fromFileNamed: self backgroundImageName.
	(bg magnifyBy: 2) setAsBackground.		"to aid in resizing the outer window."

	nil inform: 'Resize the main window as required',
					'\Click OK to continue saving.' withCRs.

	"And free up the big form."
	World color: Color black.

	"Do a thorough GC and save."
	5 timesRepeat: [Smalltalk garbageCollect].
	Smalltalk snapshot: true andQuit: true.

	"And start the game (unless something either went wrong or I'm trying to hack on
	 a deliverable image)."
	self isDevelopmentImage
		ifFalse: [

			"Keep from getting the same dungeon each time."
			Collection randomForPicking initialize.
		
			(bg magnifyBy: 2) displayAt: 0@0.
			self new startFullScreen.
		].
! !

!NhGame class methodsFor: 'deliverables' stamp: 'cr 3/27/2005 15:41'!
rigImageForDeliverable

	Preferences
		disable: #cmdDotEnabled;
		disable: #warnIfNoChangesFile;
		disable: #warnIfNoSourcesFile;
		disable: #debugHaloHandle;
		disable: #honorDesktopCmdKeys;
		disable: #preserveTrash;
		
		enable: #allHalosDisabled;		"This is a hackjob, added for this project."

		yourself.

	"to do--disable halos somehow."! !


!NhGarnet methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^700
! !


!NhGarnet class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'garnet'

! !

!NhGarnet class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhGiantBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGiantBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhGiantBat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhGiantBat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $B color: Color black name: 'giant bat'

! !

!NhGiantBat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGiantBat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhGiantBat class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhGnome methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGnome methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhGnome methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhGnome class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $G color: Color black name: 'gnome'

! !

!NhGnome class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGnome class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhGnome class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhGnomeKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhGnomeKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhGnomeKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhGnomeKing class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $G color: Color black name: 'gnome king'

! !

!NhGnomeKing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGnomeKing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhGnomeKing class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 8.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhGnomeLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGnomeLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhGnomeLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhGnomeLord class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $G color: Color black name: 'gnome lord'

! !

!NhGnomeLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGnomeLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhGnomeLord class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhGoblin methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGoblin methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhGoblin methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGoblin class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'goblin'

! !

!NhGoblin class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGoblin class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhGoblin class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhGoldenNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGoldenNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhGoldenNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGoldenNagaHatchling class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $N color: Color black name: 'golden naga hatchling'

! !

!NhGoldenNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGoldenNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhGoldenNagaHatchling class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhGlassGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhGlassGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^680
! !

!NhGlassGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhGlassGolem class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $' color: Color black name: 'glass golem'

! !

!NhGlassGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGlassGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^16
! !

!NhGlassGolem class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 17.
		GmDexterity		-> 18.
	}.
! !


!NhGrayDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhGrayDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'gray dragon scale mail'

! !

!NhGrayDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhGrayDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^12
! !


!NhGrayDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhGrayDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'gray dragon scales'

! !

!NhGrayDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhGrayDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^7
! !


!NhGreenDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhGreenDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'green dragon scale mail'

! !

!NhGreenDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhGreenDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^9
! !


!NhGreenDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhGreenDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'green dragon scales'

! !

!NhGreenDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhGreenDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^5
! !


!NhGreenElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhGreenElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhGreenElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGreenElf class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $@ color: Color black name: 'Green-elf'

! !

!NhGreenElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGreenElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhGreenElf class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 8.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhGreyElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhGreyElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhGreyElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGreyElf class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $@ color: Color black name: 'Grey-elf'

! !

!NhGreyElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGreyElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhGreyElf class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhGuardianNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGuardianNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhGuardianNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGuardianNagaHatchling class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $N color: Color black name: 'guardian naga hatchling'

! !

!NhGuardianNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGuardianNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhGuardianNagaHatchling class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhHighBoots methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^2
! !


!NhHighBoots class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'high boots'

! !

!NhHighBoots class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhHighBoots class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhHillOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhHillOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhHillOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhHillOrc class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'hill orc'

! !

!NhHillOrc class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHillOrc class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhHillOrc class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhHobbit methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhHobbit methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhHobbit methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhHobbit class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $h color: Color black name: 'hobbit'

! !

!NhHobbit class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHobbit class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhHobbit class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhHobgoblin methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhHobgoblin methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhHobgoblin methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhHobgoblin class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'hobgoblin'

! !

!NhHobgoblin class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHobgoblin class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhHobgoblin class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhHuman methodsFor: 'attributes' stamp: 'cr 3/10/2005 03:32'!
bareIntrinsicAttackClasses
	^{GmUnarmedAttack}.
! !

!NhHuman methodsFor: 'attributes' stamp: 'cr 3/10/2005 03:33'!
damageRating
	^5! !

!NhHuman methodsFor: 'attributes' stamp: 'cr 3/10/2005 03:33'!
experienceValue
	^20
! !


!NhHuman class methodsFor: 'ascii tiles' stamp: 'cr 3/3/2005 03:06'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $@ color: Color black name: 'human'
! !

!NhHuman class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 23:34'!
canCreateIn: aMap
	^false.		"Humans aren't randomly generated."
! !

!NhHuman class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:32'!
isConcrete
	^true
! !


!NhHungover methodsFor: 'core protocol' stamp: 'cr 3/8/2005 12:04'!
valueName
	^'Hungover'
! !


!NhCaveSpider methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhCaveSpider methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhCaveSpider methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^2
! !


!NhCaveSpider class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $s color: Color black name: 'cave spider'

! !

!NhCaveSpider class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhCaveSpider class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhCaveSpider class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhGiantAnt methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGiantAnt methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhGiantAnt methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGiantAnt class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $a color: Color black name: 'giant ant'

! !

!NhGiantAnt class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGiantAnt class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhGiantAnt class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhGiantBeetle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhGiantBeetle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhGiantBeetle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhGiantBeetle class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $a color: Color black name: 'giant beetle'

! !

!NhGiantBeetle class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGiantBeetle class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhGiantBeetle class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 9.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhIronGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^4
! !

!NhIronGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^760
! !

!NhIronGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhIronGolem class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $' color: Color black name: 'iron golem'

! !

!NhIronGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhIronGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^18
! !

!NhIronGolem class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 19.
		GmDexterity		-> 18.
	}.
! !


!NhIronShoes methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^2
! !


!NhIronShoes class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'iron shoes'

! !

!NhIronShoes class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhIronShoes class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhJade methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^300
! !


!NhJade class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'jade'

! !

!NhJade class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhJasper methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^500
! !


!NhJasper class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'jasper'

! !

!NhJasper class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhKobold methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhKobold methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhKobold methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhKobold class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $k color: Color black name: 'kobold'

! !

!NhKobold class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhKobold class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhKobold class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhKoboldLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhKoboldLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhKoboldLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhKoboldLord class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $k color: Color black name: 'kobold lord'

! !

!NhKoboldLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhKoboldLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhKoboldLord class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 5.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhLargeKobold methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhLargeKobold methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhLargeKobold methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhLargeKobold class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $k color: Color black name: 'large kobold'

! !

!NhLargeKobold class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhLargeKobold class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhLargeKobold class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhLeatherArmor methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^2
! !


!NhLeatherArmor class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'leather armor'

! !

!NhLeatherArmor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhLeatherArmor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhLeatherGloves methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhLeatherGloves class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'leather gloves'

! !

!NhLeatherGloves class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhLeatherGloves class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhLeatherJacket methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhLeatherJacket class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'leather jacket'

! !

!NhLeatherJacket class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhLeatherJacket class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhLemure methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhLemure methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhLemure methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^3
! !


!NhLemure class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $i color: Color black name: 'lemure'

! !

!NhLemure class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhLemure class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhLemure class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhLowBoots methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhLowBoots class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'low boots'

! !

!NhLowBoots class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhLowBoots class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhManes methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhManes methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhManes methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhManes class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $i color: Color black name: 'manes'

! !

!NhManes class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhManes class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhManes class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhMauveDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^8
! !

!NhMauveDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^640
! !

!NhMauveDragon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhMauveDragon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $D color: Color black name: 'mauve dragon'

! !

!NhMauveDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhMauveDragon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^15
! !

!NhMauveDragon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 10:39'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 16.
		GmDexterity		-> 18.

		GmArmorClass	-> 9.
	}.
! !


!NhMinotaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhMinotaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^640
! !

!NhMinotaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhMinotaur class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $H color: Color black name: 'minotaur'

! !

!NhMinotaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhMinotaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^15
! !

!NhMinotaur class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 16.
		GmDexterity		-> 18.
	}.
! !


!NhApe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhApe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhApe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhApe class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Y color: Color black name: 'ape'

! !

!NhApe class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhApe class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhApe class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhCarnivorousApe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhCarnivorousApe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhCarnivorousApe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhCarnivorousApe class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Y color: Color black name: 'carnivorous ape'

! !

!NhCarnivorousApe class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhCarnivorousApe class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhCarnivorousApe class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 8.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhGargoyle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhGargoyle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhGargoyle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGargoyle class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $g color: Color black name: 'gargoyle'

! !

!NhGargoyle class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGargoyle class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhGargoyle class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhGhost methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGhost methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^440
! !

!NhGhost methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^1
! !


!NhGhost class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $  color: Color black name: 'ghost'

! !

!NhGhost class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGhost class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^10
! !

!NhGhost class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 15.
		GmConstitution	-> 12.
		GmExperience	-> 11.
		GmDexterity		-> 17.
	}.
! !


!NhGlassPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^4
! !

!NhGlassPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhGlassPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhGlassPiercer class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $p color: Color black name: 'glass piercer'

! !

!NhGlassPiercer class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGlassPiercer class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhGlassPiercer class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 12.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhIronPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhIronPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhIronPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhIronPiercer class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $p color: Color black name: 'iron piercer'

! !

!NhIronPiercer class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhIronPiercer class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhIronPiercer class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 9.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhMordorOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhMordorOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhMordorOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhMordorOrc class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'Mordor orc'

! !

!NhMordorOrc class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhMordorOrc class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhMordorOrc class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhMountainCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhMountainCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhMountainCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhMountainCentaur class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $C color: Color black name: 'mountain centaur'

! !

!NhMountainCentaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhMountainCentaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhMountainCentaur class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 8.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhMummy methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 22:46'!
usesTools
	^false
! !

!NhMummy methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 22:53'!
wearsArmor
	^false.! !


!NhDwarfMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhDwarfMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhDwarfMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhDwarfMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'dwarf mummy'

! !

!NhDwarfMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDwarfMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhDwarfMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 7.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhElfMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhElfMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhElfMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhElfMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'elf mummy'

! !

!NhElfMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhElfMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhElfMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhEttinMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhEttinMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhEttinMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhEttinMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'ettin mummy'

! !

!NhEttinMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhEttinMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhEttinMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 10.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhGiantMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhGiantMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^360
! !

!NhGiantMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhGiantMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'giant mummy'

! !

!NhGiantMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGiantMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^8
! !

!NhGiantMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 13.
		GmConstitution	-> 12.
		GmExperience	-> 9.
		GmDexterity		-> 15.
	}.
! !


!NhGnomeMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGnomeMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhGnomeMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhGnomeMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'gnome mummy'

! !

!NhGnomeMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGnomeMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhGnomeMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhHumanMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhHumanMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhHumanMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhHumanMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'human mummy'

! !

!NhHumanMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHumanMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhHumanMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhKoboldMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhKoboldMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhKoboldMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhKoboldMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'kobold mummy'

! !

!NhKoboldMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhKoboldMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhKoboldMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhOgre methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhOgre methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhOgre methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^5
! !


!NhOgre class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $O color: Color black name: 'ogre'

! !

!NhOgre class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOgre class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhOgre class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 8.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhOgreKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhOgreKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^400
! !

!NhOgreKing methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^5
! !


!NhOgreKing class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $O color: Color black name: 'ogre king'

! !

!NhOgreKing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOgreKing class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^9
! !

!NhOgreKing class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 14.
		GmConstitution	-> 13.
		GmExperience	-> 10.
		GmDexterity		-> 16.
	}.
! !


!NhOgreLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhOgreLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhOgreLord methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhOgreLord class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $O color: Color black name: 'ogre lord'

! !

!NhOgreLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOgreLord class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhOgreLord class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 10.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhOpal methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^800
! !


!NhOpal class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'opal'

! !

!NhOpal class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhOrangeDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhOrangeDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'orange dragon scale mail'

! !

!NhOrangeDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhOrangeDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^9
! !


!NhOrangeDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhOrangeDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'orange dragon scales'

! !

!NhOrangeDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhOrangeDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^5
! !


!NhOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhOrc methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhOrc class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'orc'

! !

!NhOrc class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOrc class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhOrc class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhOrcCaptain methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhOrcCaptain methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhOrcCaptain methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhOrcCaptain class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'orc-captain'

! !

!NhOrcCaptain class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOrcCaptain class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhOrcCaptain class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 8.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhOrcMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhOrcMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhOrcMummy methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhOrcMummy class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $M color: Color black name: 'orc mummy'

! !

!NhOrcMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOrcMummy class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhOrcMummy class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 7.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhOrcishChainMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^4
! !


!NhOrcishChainMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'orcish chain mail'

! !

!NhOrcishChainMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhOrcishChainMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhOrcishHelm methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^1
! !


!NhOrcishHelm class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'orcish helm'

! !

!NhOrcishHelm class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhOrcishHelm class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhOrcishRingMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^2
! !


!NhOrcishRingMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'orcish ring mail'

! !

!NhOrcishRingMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhOrcishRingMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhPantsOfYendor methodsFor: 'type tests' stamp: 'cr 3/12/2005 05:42'!
isPantsOfYendor
	^true

! !

!NhPantsOfYendor methodsFor: 'description' stamp: 'cr 3/12/2005 05:40'!
descriptionString
	^self theDescriptionString.
! !

!NhPantsOfYendor methodsFor: 'description' stamp: 'cr 3/12/2005 05:40'!
theDescriptionString
	^'The Pants of Yendor'
! !

!NhPantsOfYendor methodsFor: 'stat modifications' stamp: 'cr 4/4/2005 03:37'!
armorClassMod
	^6! !


!NhPantsOfYendor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:39'!
canCreateIn: aMap
	^false.		"This is unique so we don't let it get generated in the usual way."
! !

!NhPantsOfYendor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 11:43'!
isConcrete
	^true
! !

!NhPantsOfYendor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:40'!
maxAllowed
	^1
! !

!NhPantsOfYendor class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 11:43'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'the Pants of Yendor'

! !


!NhPaperGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhPaperGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhPaperGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^3
! !


!NhPaperGolem class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $' color: Color black name: 'paper golem'

! !

!NhPaperGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhPaperGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhPaperGolem class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhPlainsCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhPlainsCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhPlainsCentaur methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhPlainsCentaur class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $C color: Color black name: 'plains centaur'

! !

!NhPlainsCentaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhPlainsCentaur class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhPlainsCentaur class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhPlateMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^7
! !


!NhPlateMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'plate mail'

! !

!NhPlateMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhPlateMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^6
! !


!NhCoyote methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhCoyote methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhCoyote methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhCoyote class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'coyote'

! !

!NhCoyote class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhCoyote class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhCoyote class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhDingo methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhDingo methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhDingo methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhDingo class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'dingo'

! !

!NhDingo class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDingo class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhDingo class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhDog class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'dog'

! !

!NhDog class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDog class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhDog class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhFox methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhFox methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhFox methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^3
! !


!NhFox class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'fox'

! !

!NhFox class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhFox class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhFox class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhHousecat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhHousecat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhHousecat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhHousecat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $f color: Color black name: 'housecat'

! !

!NhHousecat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHousecat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhHousecat class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhJackal methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhJackal methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhJackal methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^2
! !


!NhJackal class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'jackal'

! !

!NhJackal class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhJackal class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhJackal class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhJaguar methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhJaguar methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhJaguar methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhJaguar class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $f color: Color black name: 'jaguar'

! !

!NhJaguar class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhJaguar class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhJaguar class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhKitten methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhKitten methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhKitten methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhKitten class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $f color: Color black name: 'kitten'

! !

!NhKitten class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhKitten class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhKitten class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhLargeCat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhLargeCat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhLargeCat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhLargeCat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $f color: Color black name: 'large cat'

! !

!NhLargeCat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhLargeCat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhLargeCat class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhLargeDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhLargeDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhLargeDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhLargeDog class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'large dog'

! !

!NhLargeDog class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhLargeDog class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhLargeDog class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhBaluchitherium methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^5
! !

!NhBaluchitherium methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^600
! !

!NhBaluchitherium methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhBaluchitherium class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'baluchitherium'

! !

!NhBaluchitherium class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhBaluchitherium class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^14
! !

!NhBaluchitherium class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 15.
		GmDexterity		-> 18.
	}.
! !


!NhHorse methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhHorse methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhHorse methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^3
! !


!NhHorse class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $u color: Color black name: 'horse'

! !

!NhHorse class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHorse class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhHorse class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 7.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhLeocrotta methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhLeocrotta methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhLeocrotta methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhLeocrotta class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'leocrotta'

! !

!NhLeocrotta class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhLeocrotta class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhLeocrotta class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 9.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhLittleDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhLittleDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhLittleDog methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhLittleDog class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'little dog'

! !

!NhLittleDog class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhLittleDog class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhLittleDog class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhMastodon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^4
! !

!NhMastodon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^840
! !

!NhMastodon methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhMastodon class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'mastodon'

! !

!NhMastodon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhMastodon class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^20
! !

!NhMastodon class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 21.
		GmDexterity		-> 18.
	}.
! !


!NhMumak methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhMumak methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhMumak methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhMumak class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'mumak'

! !

!NhMumak class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhMumak class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhMumak class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 8.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhPony methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhPony methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhPony methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^2
! !


!NhPony class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $u color: Color black name: 'pony'

! !

!NhPony class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhPony class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhPony class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhQueenBee methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhQueenBee methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^400
! !

!NhQueenBee methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhQueenBee class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $a color: Color black name: 'queen bee'

! !

!NhQueenBee class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhQueenBee class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^9
! !

!NhQueenBee class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 14.
		GmConstitution	-> 11.
		GmExperience	-> 10.
		GmDexterity		-> 16.
	}.
! !


!NhRaven methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhRaven methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhRaven methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhRaven class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $B color: Color black name: 'raven'

! !

!NhRaven class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhRaven class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhRaven class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhRedDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhRedDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'red dragon scale mail'

! !

!NhRedDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhRedDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^9
! !


!NhRedDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhRedDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'red dragon scales'

! !

!NhRedDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhRedDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^5
! !


!NhRedNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhRedNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhRedNagaHatchling methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhRedNagaHatchling class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $N color: Color black name: 'red naga hatchling'

! !

!NhRedNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhRedNagaHatchling class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhRedNagaHatchling class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhRingMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhRingMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'ring mail'

! !

!NhRingMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhRingMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^1
! !


!NhRingOfCharisma methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
charismaMod
	^3
! !


!NhRingOfCharisma class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 04:18'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of charisma'

! !

!NhRingOfCharisma class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 04:18'!
isConcrete
	^true
! !


!NhRingOfConstitution methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
constitutionMod
	^3
! !


!NhRingOfConstitution class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 04:18'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of constitution'

! !

!NhRingOfConstitution class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 04:18'!
isConcrete
	^true
! !


!NhRingOfDexterity methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
dexterityMod
	^3
! !


!NhRingOfDexterity class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 04:18'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of dexterity'

! !

!NhRingOfDexterity class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 04:18'!
isConcrete
	^true
! !


!NhRingOfIntelligence methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
intelligenceMod
	^3
! !


!NhRingOfIntelligence class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 04:18'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of intelligence'

! !

!NhRingOfIntelligence class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 04:18'!
isConcrete
	^true
! !


!NhRingOfStrength methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
strengthMod
	^3
! !


!NhRingOfStrength class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 04:18'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of strength'

! !

!NhRingOfStrength class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 04:18'!
isConcrete
	^true
! !


!NhRingOfStudliness methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:19'!
armorClassMod
	^4
! !

!NhRingOfStudliness methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:19'!
dexterityMod
	^5
! !

!NhRingOfStudliness methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:19'!
strengthMod
	^5
! !


!NhRingOfStudliness class methodsFor: 'ascii tiles' stamp: 'cr 4/4/2005 00:16'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of wisdom'

! !

!NhRingOfStudliness class methodsFor: 'object management stats' stamp: 'cr 4/4/2005 00:17'!
isConcrete
	^true! !

!NhRingOfStudliness class methodsFor: 'object management stats' stamp: 'cr 4/4/2005 03:46'!
minCreationLevel
	^15! !


!NhRingOfWisdom methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 04:18'!
wisdomMod
	^3
! !


!NhRingOfWisdom class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 04:18'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $= color: Color black name: 'ring of wisdom'

! !

!NhRingOfWisdom class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 04:18'!
isConcrete
	^true
! !


!NhRockPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhRockPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhRockPiercer methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhRockPiercer class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $p color: Color black name: 'rock piercer'

! !

!NhRockPiercer class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhRockPiercer class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhRockPiercer class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 6.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhDevilBunny methodsFor: 'attributes' stamp: 'cr 3/12/2005 10:34'!
damageRating
	^20
! !

!NhDevilBunny methodsFor: 'attributes' stamp: 'cr 3/12/2005 10:41'!
experienceValue
	^640
! !

!NhDevilBunny methodsFor: 'attributes' stamp: 'cr 3/12/2005 10:16'!
toHitValue
	^3
! !


!NhDevilBunny class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 10:16'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $r color: Color black name: 'giant rat'

! !

!NhDevilBunny class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:16'!
isConcrete
	^true
! !

!NhDevilBunny class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 10:41'!
minCreationLevel
	^20
! !

!NhDevilBunny class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 10:36'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 6.
		GmExperience	-> 2.
		GmDexterity		-> 14.
	}.
! !


!NhGiantRat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGiantRat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhGiantRat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^3
! !


!NhGiantRat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $r color: Color black name: 'giant rat'

! !

!NhGiantRat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGiantRat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhGiantRat class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhRockMole methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhRockMole methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhRockMole methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhRockMole class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $r color: Color black name: 'rock mole'

! !

!NhRockMole class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhRockMole class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhRockMole class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhRopeGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^6
! !

!NhRopeGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhRopeGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^1
! !


!NhRopeGolem class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $' color: Color black name: 'rope golem'

! !

!NhRopeGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhRopeGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhRopeGolem class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 11.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhRothe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhRothe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhRothe methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhRothe class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'rothe'

! !

!NhRothe class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhRothe class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhRothe class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhRuby methodsFor: 'type info' stamp: 'cr 3/11/2005 14:30'!
pointValue
	^5000! !


!NhRuby class methodsFor: 'object management stats' stamp: 'cr 3/5/2005 20:32'!
isConcrete
	^true
! !

!NhRuby class methodsFor: 'ascii tiles' stamp: 'cr 3/5/2005 21:32'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color red name: 'ruby'! !


!NhSapphire methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^3000
! !


!NhSapphire class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'sapphire'

! !

!NhSapphire class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhSasquatch methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhSasquatch methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhSasquatch methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhSasquatch class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Y color: Color black name: 'sasquatch'

! !

!NhSasquatch class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhSasquatch class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhSasquatch class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 9.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^4
! !


!NhScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'scale mail'

! !

!NhScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhSewerRat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhSewerRat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhSewerRat methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^3
! !


!NhSewerRat class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $r color: Color black name: 'sewer rat'

! !

!NhSewerRat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhSewerRat class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhSewerRat class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhShade methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhShade methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhShade methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhShade class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $  color: Color black name: 'shade'

! !

!NhShade class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhShade class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhShade class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhSilverDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhSilverDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'silver dragon scale mail'

! !

!NhSilverDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhSilverDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^12
! !


!NhSilverDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhSilverDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'silver dragon scales'

! !

!NhSilverDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhSilverDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^7
! !


!NhSoldierAnt methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhSoldierAnt methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhSoldierAnt methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhSoldierAnt class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $a color: Color black name: 'soldier ant'

! !

!NhSoldierAnt class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhSoldierAnt class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhSoldierAnt class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 7.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhSplintMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^6
! !


!NhSplintMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'splint mail'

! !

!NhSplintMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhSplintMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhStoneGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhStoneGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^600
! !

!NhStoneGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhStoneGolem class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $' color: Color black name: 'stone golem'

! !

!NhStoneGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhStoneGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^14
! !

!NhStoneGolem class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 18.
		GmExperience	-> 15.
		GmDexterity		-> 18.
	}.
! !


!NhStrawGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhStrawGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhStrawGolem methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^2
! !


!NhStrawGolem class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $' color: Color black name: 'straw golem'

! !

!NhStrawGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhStrawGolem class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhStrawGolem class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhStuddedLeatherArmor methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhStuddedLeatherArmor class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'studded leather armor'

! !

!NhStuddedLeatherArmor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhStuddedLeatherArmor class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^0
! !


!NhStuffManager methodsFor: 'calculations' stamp: 'cr 3/5/2005 21:54'!
numForUpdateIn: map
	^0		"objects don't spontaneously reappear."

! !

!NhStuffManager methodsFor: 'calculations' stamp: 'cr 3/12/2005 04:55'!
numRequiredIn: map
	^20		"make this cleverer"
! !

!NhStuffManager methodsFor: 'map population' stamp: 'cr 3/12/2005 11:40'!
setupMap: aMap
	aMap creationState isBottom
		ifTrue: [self addItem: NhPantsOfYendor to: aMap
					ifUnable: [self error: 'unable to place the Pants of Yendor.']].

	^super setupMap: aMap! !

!NhStuffManager methodsFor: 'item generation' stamp: 'cr 4/3/2005 21:51'!
weaponsForMap: map

	"This is to keep the monsters from getting generated with the cooler weapons early on.  This
	 should probably go away or be changed a lot when more weapons and monster drop get added."

	^(super weaponsForMap: map) reject: [ :w | w == GmBattleSpork or: [w == GmShortSword]].
! !


!NhTengu methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhTengu methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhTengu methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^7
! !


!NhTengu class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $i color: Color black name: 'tengu'

! !

!NhTengu class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhTengu class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhTengu class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 8.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhTiger methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1.1
! !

!NhTiger methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhTiger methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^1.1
! !


!NhTiger class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $f color: Color black name: 'tiger'

! !

!NhTiger class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhTiger class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhTiger class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 8.1.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhTitanothere methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhTitanothere methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhTitanothere methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhTitanothere class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'titanothere'

! !

!NhTitanothere class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhTitanothere class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhTitanothere class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 15.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhTopaz methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^900
! !


!NhTopaz class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'topaz'

! !

!NhTopaz class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhOlogHai methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhOlogHai methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^560
! !

!NhOlogHai methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhOlogHai class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $T color: Color black name: 'Olog-hai'

! !

!NhOlogHai class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOlogHai class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^13
! !

!NhOlogHai class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 18.
		GmConstitution	-> 16.
		GmExperience	-> 14.
		GmDexterity		-> 18.
	}.
! !


!NhTroll methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhTroll methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhTroll methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhTroll class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $T color: Color black name: 'troll'

! !

!NhTroll class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhTroll class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhTroll class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 10.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhTurquoise methodsFor: 'type info' stamp: 'cr 3/12/2005 03:53'!
pointValue
	^2000
! !


!NhTurquoise class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 03:53'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $* color: Color black name: 'turquoise'

! !

!NhTurquoise class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 03:53'!
isConcrete
	^true
! !


!NhUrukHai methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhUrukHai methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhUrukHai methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhUrukHai class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $o color: Color black name: 'Uruk-hai'

! !

!NhUrukHai class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhUrukHai class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhUrukHai class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhWarg methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhWarg methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhWarg methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhWarg class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'warg'

! !

!NhWarg class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWarg class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhWarg class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 10.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhWarhorse methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhWarhorse methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^320
! !

!NhWarhorse methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhWarhorse class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $u color: Color black name: 'warhorse'

! !

!NhWarhorse class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWarhorse class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^7
! !

!NhWarhorse class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 12.
		GmConstitution	-> 9.
		GmExperience	-> 8.
		GmDexterity		-> 14.
	}.
! !


!NhWhiteDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhWhiteDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'white dragon scale mail'

! !

!NhWhiteDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhWhiteDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^9
! !


!NhWhiteDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhWhiteDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'white dragon scales'

! !

!NhWhiteDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhWhiteDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^5
! !


!NhWingedGargoyle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhWingedGargoyle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^400
! !

!NhWingedGargoyle methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhWingedGargoyle class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $g color: Color black name: 'winged gargoyle'

! !

!NhWingedGargoyle class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWingedGargoyle class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^9
! !

!NhWingedGargoyle class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 14.
		GmConstitution	-> 13.
		GmExperience	-> 10.
		GmDexterity		-> 16.
	}.
! !


!NhWolf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhWolf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhWolf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhWolf class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $d color: Color black name: 'wolf'

! !

!NhWolf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWolf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhWolf class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 8.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhWoodchuck methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhWoodchuck methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhWoodchuck methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhWoodchuck class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $r color: Color black name: 'woodchuck'

! !

!NhWoodchuck class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWoodchuck class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhWoodchuck class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhWoodlandElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhWoodlandElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhWoodlandElf methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhWoodlandElf class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $@ color: Color black name: 'Woodland-elf'

! !

!NhWoodlandElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWoodlandElf class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhWoodlandElf class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 7.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhWumpus methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhWumpus methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^360
! !

!NhWumpus methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhWumpus class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $q color: Color black name: 'wumpus'

! !

!NhWumpus class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhWumpus class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^8
! !

!NhWumpus class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 13.
		GmConstitution	-> 12.
		GmExperience	-> 9.
		GmDexterity		-> 15.
	}.
! !


!NhXorn methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^4
! !

!NhXorn methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^360
! !

!NhXorn methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhXorn class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $X color: Color black name: 'xorn'

! !

!NhXorn class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhXorn class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^8
! !

!NhXorn class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 13.
		GmConstitution	-> 13.
		GmExperience	-> 9.
		GmDexterity		-> 15.
	}.
! !


!NhYellowDragonScaleMail methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^9
! !


!NhYellowDragonScaleMail class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'yellow dragon scale mail'

! !

!NhYellowDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhYellowDragonScaleMail class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^9
! !


!NhYellowDragonScales methodsFor: 'stat modifications' stamp: 'cr 3/12/2005 05:23'!
armorClassMod
	^3
! !


!NhYellowDragonScales class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:23'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $[ color: Color black name: 'yellow dragon scales'

! !

!NhYellowDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
isConcrete
	^true
! !

!NhYellowDragonScales class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:23'!
minCreationLevel
	^5
! !


!NhYeti methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhYeti methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^240
! !

!NhYeti methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhYeti class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Y color: Color black name: 'yeti'

! !

!NhYeti class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhYeti class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^5
! !

!NhYeti class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 10.
		GmConstitution	-> 7.
		GmExperience	-> 6.
		GmDexterity		-> 12.
	}.
! !


!NhZombie methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 22:47'!
usesTools
	^false.		"Zombies are too dumb to use tools."! !

!NhZombie methodsFor: 'tests--capabilites' stamp: 'cr 4/3/2005 22:51'!
wearsArmor
	^false! !


!NhDwarfZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhDwarfZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhDwarfZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhDwarfZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'dwarf zombie'

! !

!NhDwarfZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhDwarfZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhDwarfZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhElfZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhElfZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhElfZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^7
! !


!NhElfZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'elf zombie'

! !

!NhElfZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhElfZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhElfZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhEttinZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhEttinZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^280
! !

!NhEttinZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^10
! !


!NhEttinZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'ettin zombie'

! !

!NhEttinZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhEttinZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^6
! !

!NhEttinZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 11.
		GmConstitution	-> 8.
		GmExperience	-> 7.
		GmDexterity		-> 13.
	}.
! !


!NhGhoul methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGhoul methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^160
! !

!NhGhoul methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^2
! !


!NhGhoul class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'ghoul'

! !

!NhGhoul class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGhoul class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^3
! !

!NhGhoul class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 8.
		GmConstitution	-> 5.
		GmExperience	-> 4.
		GmDexterity		-> 10.
	}.
! !


!NhGiantZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^2
! !

!NhGiantZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^360
! !

!NhGiantZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhGiantZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'giant zombie'

! !

!NhGiantZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGiantZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^8
! !

!NhGiantZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 13.
		GmConstitution	-> 11.
		GmExperience	-> 9.
		GmDexterity		-> 15.
	}.
! !


!NhGnomeZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhGnomeZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^80
! !

!NhGnomeZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^5
! !


!NhGnomeZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'gnome zombie'

! !

!NhGnomeZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhGnomeZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^1
! !

!NhGnomeZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 6.
		GmConstitution	-> 3.
		GmExperience	-> 2.
		GmDexterity		-> 8.
	}.
! !


!NhHumanZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhHumanZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^200
! !

!NhHumanZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^8
! !


!NhHumanZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'human zombie'

! !

!NhHumanZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhHumanZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^4
! !

!NhHumanZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 9.
		GmConstitution	-> 6.
		GmExperience	-> 5.
		GmDexterity		-> 11.
	}.
! !


!NhKoboldZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhKoboldZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^40
! !

!NhKoboldZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^4
! !


!NhKoboldZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'kobold zombie'

! !

!NhKoboldZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhKoboldZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^0
! !

!NhKoboldZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 5.
		GmConstitution	-> 2.
		GmExperience	-> 1.
		GmDexterity		-> 7.
	}.
! !


!NhOrcZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhOrcZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^120
! !

!NhOrcZombie methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhOrcZombie class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'orc zombie'

! !

!NhOrcZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhOrcZombie class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^2
! !

!NhOrcZombie class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 7.
		GmConstitution	-> 4.
		GmExperience	-> 3.
		GmDexterity		-> 9.
	}.
! !


!NhSkeleton methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^1
! !

!NhSkeleton methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^520
! !

!NhSkeleton methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhSkeleton class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $Z color: Color black name: 'skeleton'

! !

!NhSkeleton class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhSkeleton class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^12
! !

!NhSkeleton class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 17.
		GmConstitution	-> 14.
		GmExperience	-> 13.
		GmDexterity		-> 18.
	}.
! !


!NhZruty methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
damageRating
	^3
! !

!NhZruty methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
experienceValue
	^400
! !

!NhZruty methodsFor: 'attributes' stamp: 'cr 3/12/2005 05:55'!
toHitValue
	^6
! !


!NhZruty class methodsFor: 'ascii tiles' stamp: 'cr 3/12/2005 05:55'!
asciiObjectDescription
	^GmAsciiObjectDescription letter: $z color: Color black name: 'zruty'

! !

!NhZruty class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
isConcrete
	^true
! !

!NhZruty class methodsFor: 'object management stats' stamp: 'cr 3/12/2005 05:55'!
minCreationLevel
	^9
! !

!NhZruty class methodsFor: 'stat defaults' stamp: 'cr 3/12/2005 05:55'!
initialStatValues
	^super initialStatValues,
	{
		GmStrength		-> 14.
		GmConstitution	-> 13.
		GmExperience	-> 10.
		GmDexterity		-> 16.
	}.
! !


!Point methodsFor: 'ObjEng-arithmetic' stamp: 'cr 1/3/2004 19:05'!
displacementRectArea
	"Return the area of the rectangle formed by this point and the origin."
	^(self x * self y) abs.
! !

!Point methodsFor: 'ObjEng-rounding' stamp: 'cr 10/2/2004 20:14'!
roundUpTo: grid
	| gridPoint |

	gridPoint := grid asPoint.
	^(x roundUpTo: gridPoint x) @ (y roundUpTo: gridPoint y).
! !


!Rectangle methodsFor: 'accessing'!
corners
	"Return an array of corner points in the order of a quadrilateral spec for WarpBlt."

	^ Array
		with: self topLeft
		with: self bottomLeft
		with: self bottomRight
		with: self topRight
! !

!Rectangle methodsFor: 'ObjHack-random' stamp: 'cr 3/2/2005 14:10'!
randomInternalPoint
	^(self origin x to: self corner x - 1) atRandom @
		(self origin y to: self corner y - 1) atRandom.! !

!Rectangle methodsFor: 'ObjHack-enumerating' stamp: 'cr 10/2/2004 20:45'!
allBorderPointsDo: block
	(self topInside to: self bottomInside) do: [ :y | 
		block value: self leftInside @ y.
		block value: self rightInside @ y.
	].

	(self leftInside to: self rightInside) do: [ :x |
		block value: x@self topInside.
		block value: x@self bottomInside.
	].
! !

!Rectangle methodsFor: 'ObjHack-enumerating' stamp: 'cr 10/2/2004 20:45'!
allInteriorPointsDo: aBlock
	(self origin x to: self corner x - 1) do: [ :x |
		(self origin y to: self corner y - 1) do: [ :y |
			aBlock value: x@y.
		].
	].
! !

!Rectangle methodsFor: 'ObjHack-enumerating' stamp: 'cr 10/2/2004 20:46'!
bottomInsideDo: aBlock
	(self leftInside to: self rightInside) do: [ :x | aBlock value: x @ self bottom].
! !

!Rectangle methodsFor: 'ObjHack-enumerating' stamp: 'cr 10/2/2004 20:46'!
leftInsideDo: aBlock
	(self topInside to: self bottomInside) do: [ :y | aBlock value: self left @ y].
! !

!Rectangle methodsFor: 'ObjHack-enumerating' stamp: 'cr 10/2/2004 20:46'!
rightInsideDo: aBlock
	(self topInside to: self bottomInside) do: [ :y | aBlock value: self right @ y].
! !

!Rectangle methodsFor: 'ObjHack-enumerating' stamp: 'cr 10/2/2004 20:47'!
topInsideDo: aBlock
	(self leftInside to: self rightInside) do: [ :x | aBlock value: x @ self top].
! !

!Rectangle methodsFor: 'ObjHack-walls' stamp: 'cr 1/27/2004 23:40'!
expanded
	^self expandBy: 1! !

!Rectangle methodsFor: 'ObjHack-walls' stamp: 'cr 2/24/2005 03:20'!
insideRect
	"Assuming that self describes a room, return a rectangle that contains the entire space within
	 the walls of that room."
	^self origin + 1 corner: self corner - 1.! !

!Rectangle methodsFor: 'ObjHack-walls' stamp: 'cr 2/24/2005 03:07'!
plusWalls
	"Self such that #containsPoint will be true for the walls as well."
	^self origin extent: self extent + 1.
! !

!Rectangle methodsFor: 'ObjHack-walls' stamp: 'cr 2/28/2005 13:57'!
wallsComment

	"Because of the geometric requirements of rectangles, the outer borders are not considered
	 to be inside the rectangle.  That is, the area of a rectangle is the points between the origin
	 and the corner - 1@1 inclusively. 

	 This isn't too great for us.  We want the rectangle to contain the all of the points occupied
	 by the room INCLUDING the ones occupied by the walls.

	 In general, we try not to make waves.  Thus, a Rectangle representing a room has the
 	 top and right walls inside its bounds and the bottom and right walls outside.  That is, the
	 origin contains the coordinates for the top-left corner wall part and the corner the 
	 coordinates of the bottom-right corner wall part.

	 In addition, the method #plusWalls returns a rectangle where all of the wall points are
	 considered within the bounds of the rectangle by the normal rectangle functions.  In addition,
	 the *Inside methods return wall coordinates for type 1) rectangles.

	"! !

!Rectangle methodsFor: 'ObjHack-walls' stamp: 'cr 3/2/2005 14:25'!
withInsideRectPoints
	"Assuming that self describes a room, return a rectangle that contains the entire space within
	 the walls of that room such that #containsPoint: et. al. will ONLY be true for ALL points that
	 make up the inside of a room."
	^self origin + 1 corner: self corner.! !

!Rectangle methodsFor: 'ObjHack-tests' stamp: 'cr 3/2/2005 15:11'!
within: distance of: otherRect
	"Determine whether self is within the the given distance from otherRect."

	"Note: this doesn't seem to work.  Must fix."
	^((self pointNearestTo: otherRect center) - (otherRect pointNearestTo: self center)) abs r <= distance
	! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/2/2004 20:44'!
bottomInside
	"Return the bottommost value that is still INSIDE the rectangle.  (The right and botton borders are not
	 considered part of the rectangle."
	^self bottom - 1.! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/3/2004 17:34'!
bottomLeftInside
	^self leftInside @ self bottomInside! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/3/2004 17:34'!
bottomRightInside
	^self rightInside @ self bottomInside
! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 2/23/2005 17:25'!
cornersInside
	"Return the coordinates of the corner pieces."
	^{	self topLeftInside. 
		self topRightInside.
		self bottomRightInside.
		self bottomLeftInside.
	}.
! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/2/2004 20:43'!
leftInside
	^self left
! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/2/2004 20:43'!
rightInside
	"Return the rightmost value that is still INSIDE the rectangle.  (The right and botton borders are not
	 considered part of the rectangle."
	^self right - 1.! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/2/2004 20:44'!
topInside
	^self top! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/3/2004 17:33'!
topLeftInside
	^self topLeft
! !

!Rectangle methodsFor: 'ObjHack-borders' stamp: 'cr 10/3/2004 17:33'!
topRightInside
	^self rightInside @ self topInside! !

!Rectangle methodsFor: 'ObjHack-GUI' stamp: 'cr 10/2/2004 20:17'!
griddedTo: grid
	"Answer a rectangle that conforms to 'grid' but can contain the receiver."

	^Rectangle origin: (origin truncateTo: grid)
				corner: (corner roundUpTo: grid)! !

!Rectangle methodsFor: 'ObjHack-GUI' stamp: 'cr 10/2/2004 14:45'!
limitedBy: aPoint
	"Return a copy that has been squashed to fit into 1@1 extent: aPoint."
	^(self origin max: 1@1) corner: (self corner min: aPoint).! !

!Rectangle methodsFor: 'ObjHack-GUI' stamp: 'cr 2/28/2005 13:11'!
shrunkByFraction: fraction
	| offset |

	[0.0 <= fraction and: [fraction <= 1.0]] assert.

	offset := (self extent * fraction * 0.5) rounded.
	^self origin + offset corner: self corner - offset.! !


!RoguelikeMapDisplay methodsFor: 'initialization' stamp: 'cr 9/29/2004 23:59'!
initialize
	super initialize.

	self color: Color white.
	self borderWidth: 0.

	self setSize: 2@2 font: (StrikeFont familyName: 'DefaultTextStyle' size: 10).
! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 10/2/2004 14:51'!
at: point

	"This is here because this method gets called from #drawOn: and errors during window updates
	 can wedge the entire system (sometimes).  So we're a bit more tolerant."
	((1@1 extent: characters extent) containsPoint: point) 
		ifFalse: [
			"Transcript nextPutAll: point printString; cr; endEntry."
			^Character space.
		].

	^characters at: point x at: point y.
! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 9/29/2004 23:33'!
at: point put: char
	characters at: point x at: point y put: char.
	self damageAt: point.

! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 9/29/2004 23:20'!
clear
	characters atAllPut: Character space.
! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 3/3/2005 14:22'!
contentsCopy
	^characters copy
! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 3/2/2005 23:04'!
highlightPoint: aPoint
	highlightPoint := aPoint.
	self damageAt: aPoint.
! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 3/3/2005 17:37'!
setContents: a2dArray

	[a2dArray extent = characters extent] assert.
	
	characters := a2dArray copy.

! !

!RoguelikeMapDisplay methodsFor: 'accessing' stamp: 'cr 9/29/2004 23:21'!
setSize: extent font: dispFont
	characters := Array2D extent: extent.
	self clear.

	font := dispFont.
	self sizeToFit.
! !

!RoguelikeMapDisplay methodsFor: 'geometry' stamp: 'cr 9/29/2004 23:11'!
extent: aPoint
	"do nothing--changing size is Not Allowed."
! !

!RoguelikeMapDisplay methodsFor: 'geometry' stamp: 'cr 10/2/2004 14:44'!
indexRectFor: screenRect
	"Given a rectangle within my bounds, return a rectangle encompasing the indexes of those tiles
	 with some part within that rectangle."
	| resultOrigin resultExtent adjustedRect |

	adjustedRect := (screenRect translateBy: self innerBounds origin negated) griddedTo: self tileSize.

	resultOrigin := (adjustedRect origin // self tileSize).
	resultExtent := (adjustedRect extent // self tileSize).

	^(resultOrigin extent: resultExtent) limitedBy: characters extent.
! !

!RoguelikeMapDisplay methodsFor: 'geometry' stamp: 'cr 9/29/2004 23:35'!
rectForTileAt: point
	^self innerBounds origin + 
		((point - 1) * self tileSize) extent: self tileSize.

	
	! !

!RoguelikeMapDisplay methodsFor: 'geometry' stamp: 'cr 9/29/2004 23:19'!
sizeToFit
	super extent: characters extent * self tileSize.! !

!RoguelikeMapDisplay methodsFor: 'geometry' stamp: 'cr 9/29/2004 23:19'!
tileSize
	^font maxWidth @ font height! !

!RoguelikeMapDisplay methodsFor: 'drawing' stamp: 'cr 10/3/2004 22:14'!
damageAt: aPoint
	self invalidRect: (self rectForTileAt: aPoint).
	

! !

!RoguelikeMapDisplay methodsFor: 'drawing' stamp: 'cr 3/2/2005 23:12'!
drawCharAt: point on: canvas

	"canvas fillRectangle: (self rectForTileAt: point) color: Color random."

	| letterColor |
	letterColor := Color black.
	point = highlightPoint
		ifTrue: [
			canvas fillRectangle: (self rectForTileAt: point) color: Color red.
			letterColor := Color white.
		].

	canvas 
		drawString: (self at: point) asString
		at: (self rectForTileAt: point) origin
		font: font
		color: letterColor.

! !

!RoguelikeMapDisplay methodsFor: 'drawing' stamp: 'cr 10/3/2004 22:20'!
drawOn: aCanvas
	super drawOn: aCanvas.

	"aCanvas fillRectangle: (aCanvas clipRect intersect: self innerBounds) color: Color random."

	((self indexRectFor: (aCanvas clipRect intersect: self innerBounds)) expandBy: 1)
		allInteriorPointsDo: [ :pt | self drawCharAt: pt on: aCanvas]    "^^^^^^^^^^^^ Kludge!!"

	"There's some bug somewhere that's causing tiles to get clipped during small updates.  After spending
	 far too much time trying to track it down, I gave up and just update the tiles around them too."

! !

!RoguelikeMapDisplay methodsFor: 'drawing' stamp: 'cr 10/2/2004 15:55'!
xxxdrawCharAt: point on: canvas
	"canvas fillRectangle: (self rectForTileAt: point) color: Color random."
	"canvas frameRectangle: (self rectForTileAt: point) color: Color random."

"
	canvas fillRectangle: canvas clipRect color: Color lightRed.
	canvas fillRectangle: (self rectForTileAt: point) color: Color lightGreen.
"
"
	((self rectForTileAt: point) containsRect: canvas clipRect)
		ifFalse: [canvas fillRectangle: canvas clipRect color: Color lightRed].
"

	((self indexRectFor: (self rectForTileAt: point)) containsPoint: point - 1)
		ifFalse: [canvas fillRectangle: canvas clipRect color: Color lightRed].


	canvas 
		drawString: (self at: point) asString
		at: (self rectForTileAt: point) origin
		font: font
		color: Color black.
! !


!SequenceableCollection methodsFor: '*ObjEng-testing' stamp: 'cr 3/6/2005 00:08'!
includesIndex: index
	^index > 0 and: [index <= self size]
! !

!SequenceableCollection methodsFor: '*ObjEng-copying' stamp: 'cr 3/8/2005 15:22'!
withUniqueKeys
	"Where self is an array of associations, return a copy such that only the last entry for
	 a particular key is in the result."
	| dict |
	dict := Dictionary new.
	self do: [ :assoc | dict add: assoc].
	^(dict keys collect: [ :key | dict associationAt: key]) asOrderedCollection.! !


!Array2D methodsFor: 'copying' stamp: 'cr 3/3/2005 14:37'!
copy
	^ super clone setContents: contents copy! !


!SimpleGUI methodsFor: 'initialization' stamp: 'cr 3/8/2005 16:06'!
initializeControlPanel
	controlPanel := PrefabManager new.
	statDict := IdentityDictionary new.

	game player sortedStatList withIndexDo: [ :stat :index | self addStatItem: stat at: index].
 	self updateControlPanel.
! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 10/4/2004 00:43'!
initializeKeyHandling
	self initializeKeyTransTbl.
	self takeAllKeystrokes.! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 10/4/2004 00:42'!
initializeKeyTransTbl
	keyTranslationTable := IdentityDictionary new.
	self class defaultKeyTable pairsDo: [ :key :message | keyTranslationTable at: key put: message].! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 3/13/2005 19:45'!
initializeManagers
	self buildMainWindow.
	self fixLayoutDistances.! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 3/20/2005 19:10'!
initializeMapCache
	self testAndClearMapReplacement.
! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 10/3/2004 22:22'!
initializeMessagePanel
	messagePanel := PrefabEditScrollableWrapper new.
	messagePanel payload
		isReadOnly: true.

! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 1/10/2004 00:45'!
initializeMovementButtons
	(controlPanel clients collect: [ :x | x tag ] thenSelect: [ :tag | tag beginsWith: 'go'])
		do: [ :tag | 
				(controlPanel clientWithTag: tag) 
					action: #keystrokeEvent:;
					target: self;
					args: {tag}.
		].
! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 3/20/2005 19:13'!
initializePanel
	self initializeMapCache.
	self createPanel.
	self updateEntireMap.

! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 4/3/2005 19:35'!
on: aGame
	game := aGame.
	maxMsgLines := 1000.
	seenLevels := IdentityDictionary new.
	monsterPoints := Set new.

	self initializePanel.
	self initializeControlPanel.
	self initializeMessagePanel.

	self initializeManagers.
	
	self initializeKeyHandling.

! !

!SimpleGUI methodsFor: 'initialization' stamp: 'cr 3/20/2005 19:11'!
takeAllKeystrokes

	"Set all submorphs to forward their keystrokes to, this object.  I'm doing this because
	 Prefab's keyboard support is currently non-existant.  This is a quick-n-dirty fix."
	
	| top |
	top := manager owner ifNil: [manager].
	top allMorphsDo: [ :m | m on: #keyStroke send: #keyPressed: to: self].

! !

!SimpleGUI methodsFor: 'construction' stamp: 'cr 3/13/2005 20:04'!
addStatItem: stat at: index
	| morph panelCoord |
	morph := PrefabLabel new
				extent: self panelColumnWidth @ self panelRowHeight;
				text: stat name;
				color: controlPanel color muchLighter;
				yourself.

	panelCoord := ((index - 1) // self panelRows) @ (index \\ self panelRows).
	controlPanel addClient: morph atRelPosition: panelCoord
											* (self panelColumnWidth @ self panelRowHeight).
	statDict at: stat put: morph.

	! !

!SimpleGUI methodsFor: 'construction' stamp: 'cr 2/23/2005 02:20'!
buildMainWindow
	| panelManager controlPanelPos |

	controlPanelPos := 0 @ (self messagePanelHeight + self mapPaneHeight).

	self createAndSizeMainManager.

	panelManager := self createAndSizePanelManager.
	controlPanel extent: (self windowWidth @ self controlPaneHeight) * self pixelMult.
	messagePanel extent: (self windowWidth @ self messagePanelHeight) * self pixelMult.

	manager
		addClient: messagePanel atRelPosition: 0@0;
		addClient: panelManager atRelPosition: (0 @ self messagePanelHeight) * self pixelMult;
		addClient: controlPanel atRelPosition: controlPanelPos * self pixelMult.


! !

!SimpleGUI methodsFor: 'construction' stamp: 'cr 3/13/2005 20:08'!
createAndSizeMainManager
	| windowDim |
	windowDim := self windowWidth @ 
					(self messagePanelHeight + self mapPaneHeight + self controlPaneHeight).
	
	manager := GmPrefabFullScreenManager new.
	manager
		minSize: 350@350;
		resizer: FixedDistanceResizer new;
		extent: windowDim * self pixelMult.
! !

!SimpleGUI methodsFor: 'construction' stamp: 'cr 2/23/2005 02:16'!
createAndSizePanelManager
	^ PrefabScrollingManager new
		color: panel color;
		addClient: panel atRelPosition: 0@0;
		extent: (self windowWidth @ self mapPaneHeight) * self pixelMult;
		yourself.
! !

!SimpleGUI methodsFor: 'construction' stamp: 'cr 9/30/2004 22:09'!
createPanel
	panel := RoguelikeMapDisplay new.
	panel setSize: self map extent font: (Prefab fontNamed: self preferredFont).
! !

!SimpleGUI methodsFor: 'construction' stamp: 'cr 2/23/2005 02:27'!
fixLayoutDistances
	manager resizer
		fixRightOf: messagePanel;
		fixRightAndBottomOf: panel owner owner;  "<--ick!! depends on layout order."
		fixAllButLeftOf: controlPanel.
! !

!SimpleGUI methodsFor: 'tests' stamp: 'cr 3/3/2005 15:42'!
levelChanged
	^(map = game player map) not
! !

!SimpleGUI methodsFor: 'map panel management' stamp: 'cr 4/3/2005 19:40'!
checkForCreatureAt: point
	(self map hasCreatureAt: point)
		ifTrue: [monsterPoints add: point]
		ifFalse: [monsterPoints remove: point ifAbsent: []].
! !

!SimpleGUI methodsFor: 'map panel management' stamp: 'cr 3/4/2005 01:02'!
resetPlayerViewRegion
	game player viewRegion clearCache.
! !

!SimpleGUI methodsFor: 'map panel management' stamp: 'cr 3/20/2005 19:07'!
testAndClearMapReplacement
	map = game player map
		ifFalse: [
			map := game player map.
			^true.
		].

	^false.
! !

!SimpleGUI methodsFor: 'map panel management' stamp: 'cr 3/4/2005 00:59'!
updateMapReference
	map := game player map.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 2/28/2005 13:37'!
centerPlayer
	| centerCoords |
	centerCoords := (panel rectForTileAt: game player coordinates) center.
	panel manager scrollToShow: centerCoords withThreshold: 0.2.! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 4/3/2005 19:59'!
clearUnseenMonsters
	| viewable newMonsterPoints |

	viewable := game player viewRegion.
	newMonsterPoints := Set new.

	monsterPoints do: [ :pt |
		(viewable canSeePoint: pt)
			ifTrue: [newMonsterPoints add: pt]
			ifFalse: [self redrawWithoutMonsterAt: pt].
	].

	monsterPoints := newMonsterPoints.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/2/2005 23:09'!
highlightPlayer
	panel highlightPoint: game player coordinates.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/27/2005 16:10'!
openInWholeWorld
	manager openInWorld; startStepping.
	manager on: #mouseDown send: #yourself to: self.  "Prevent grabs."
	self updateView.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/13/2005 19:58'!
openInWorld
	manager openInSystemWindowNamed: 'Nethack II: Quest For Pants'.
	manager stopStepping.
	self updateView.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 4/3/2005 19:42'!
redrawAt: aPoint
	| asciiDescr |
	asciiDescr := game player map asciiTileAt: aPoint.
	panel at: aPoint put: asciiDescr letter asString.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 4/3/2005 19:56'!
redrawWithoutMonsterAt: aPoint
	| asciiDescr |
	asciiDescr := game player map nonCreatureAsciiTileAt: aPoint.
	panel at: aPoint put: asciiDescr letter asString.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/5/2005 19:53'!
switchPanelToCurrentMap
	seenLevels at: map put: panel contentsCopy.

	(seenLevels includesKey: game player map)
		ifTrue: [panel setContents: (seenLevels at: game player map)]
		ifFalse: [panel clear].

	panel changed.

	self updateVisiblePoints.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/3/2005 15:30'!
updateAllPoints
	map bounds allInteriorPointsDo: [ :pt | self updateAt: pt].! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 4/3/2005 19:42'!
updateAt: aPoint
	self redrawAt: aPoint.
	self checkForCreatureAt: aPoint.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/20/2005 20:08'!
updateControlPanel
	statDict keysAndValuesDo: [ :stat :morph | 
		stat testAndClearChanged
			ifTrue: [morph text: stat descString].
	].
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/4/2005 01:01'!
updateEntireMap
	self resetPlayerViewRegion.
	self switchPanelToCurrentMap.
	self updateMapReference.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 4/3/2005 19:26'!
updateFromMap
	self levelChanged
		ifTrue: [self updateEntireMap]
		ifFalse: [
			self updateVisiblePoints.
			self clearUnseenMonsters.
		].
	
	self highlightPlayer.
	self centerPlayer.! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/20/2005 19:18'!
updateView
	self updateFromMap.
	self updateControlPanel.
! !

!SimpleGUI methodsFor: 'display' stamp: 'cr 3/4/2005 16:58'!
updateVisiblePoints
	| viewRegion |

	viewRegion := game player viewRegion.
	viewRegion analyzePosition.
	viewRegion fastVisiblePointsDo: [ :pt | self updateAt: pt].! !

!SimpleGUI methodsFor: 'accessing' stamp: 'cr 3/11/2005 14:36'!
close
	manager owner
		ifNotNil: [manager owner delete]
		ifNil: [manager delete].

! !

!SimpleGUI methodsFor: 'accessing' stamp: 'cr 1/8/2004 22:48'!
game
	^game! !

!SimpleGUI methodsFor: 'accessing' stamp: 'cr 1/9/2004 21:37'!
manager
	^manager
! !

!SimpleGUI methodsFor: 'accessing' stamp: 'cr 3/20/2005 20:09'!
map
	^map
! !

!SimpleGUI methodsFor: 'keystrokes' stamp: 'cr 10/4/2004 00:59'!
keyPressed: evt
	| messageName |

	messageName := keyTranslationTable at: evt keyCharacter ifAbsent: [^self].
	self game userEvent: messageName.! !

!SimpleGUI methodsFor: 'keystrokes' stamp: 'cr 9/28/2004 22:15'!
keystrokeEvent: messageName
	self game userEvent: messageName.! !

!SimpleGUI methodsFor: 'text messages' stamp: 'cr 3/12/2005 12:14'!
message: msgText
	(msgText findTokens: Character cr) do: [ :line | self showMessageLine: line].! !

!SimpleGUI methodsFor: 'geometry' stamp: 'cr 2/23/2005 02:15'!
pixelMult

	"The number by which to multiply all coordinates to better match the existing resolution. "

	"This is a bit of a hack in that it depends on the panel existing when really we should be getting
	 this number from somewhere else, the display for example."

	^panel tileSize.
! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 2/23/2005 02:03'!
controlPaneHeight
	^10
! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 2/23/2005 01:56'!
mapPaneHeight
	^70
! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 2/23/2005 01:56'!
messagePanelHeight
	^10
! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 3/10/2005 02:30'!
panelColumnWidth
	^((Prefab fontNamed: self preferredFont) widthOf: $X) * 30.! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 2/13/2005 23:30'!
panelColumns
	^4! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 2/13/2005 23:31'!
panelRowHeight
	^((Prefab fontNamed: self preferredFont) height * 1.5) rounded.! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 3/13/2005 20:00'!
panelRows
	^6! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 9/28/2004 22:48'!
preferredFont
	^'Atlanta-12'.! !

!SimpleGUI methodsFor: 'constants' stamp: 'cr 2/23/2005 01:55'!
windowWidth
	^160
! !

!SimpleGUI methodsFor: 'private' stamp: 'cr 3/12/2005 12:13'!
showMessageLine: aTextLine
	| text |

	text := messagePanel payload text, aTextLine, String cr.
	
	maxMsgLines > 0
		ifTrue: [maxMsgLines := maxMsgLines - 1]
		ifFalse: [text := text copyAfter: Character cr].

	messagePanel payload 	text: text;
							fractionalPosition: 1.0.
! !


!SimpleGUI class methodsFor: 'instance creation' stamp: 'cr 1/3/2004 19:42'!
on: aMap
	^self basicNew on: aMap; yourself.! !

!SimpleGUI class methodsFor: 'constants' stamp: 'cr 3/12/2005 12:37'!
defaultKeyTable

	^#(
		$h	goWest
		$j	goSouth
		$k	goNorth
		$l	goEast
		$y	goNorthWest
		$u	goNorthEast
		$b	goSouthWest
		$n	goSouthEast
		$.	wait
		$>	invokePortal
		$<	invokePortal		"for the benefit of nethack finger macros."

		$d	interactiveDrop
		$,	interactiveTake
		$i	interactiveInventory
		$w	interactiveWield
		$W	interactiveWear
		$T	interactiveUnWear
		$P	interactivePutOn
		$R	interactiveTakeOff

		$S	interactiveSaveAndQuit
	).! !


!String methodsFor: '*obj-eng' stamp: 'cr 2/13/2005 19:47'!
asStatName

	| result |

	result := self.
	(self beginsWith: 'stat')
		ifTrue: [result := self allButFirst: 4].

	(self beginsWith: 'atStat')
		ifTrue: [result := self allButFirst: 6].

	^self last = $:
		ifTrue: [result allButLast]
		ifFalse: [result].

				! !

!String methodsFor: '*obj-eng' stamp: 'cr 3/4/2005 18:03'!
studlyCapsToWords

	"Example: converts 'SmallTalk' to 'small talk'."

	^(self inject: '' into: [ :str :char | char isUppercase 
									ifTrue: [str, ' ', char asLowercase asString]
									ifFalse: [str, char asString]])
		withBlanksTrimmed.! !

!String methodsFor: '*obj-eng' stamp: 'cr 3/9/2005 23:08'!
unCapitalized
	(self isEmpty or: [self first isUppercase not]) ifTrue: [^self].
	^self first asLowercase asString, self allButFirst.! !

!String methodsFor: '*obj-eng' stamp: 'cr 4/3/2005 19:03'!
withDefiniteArticle
	^'the ', self
! !

!String methodsFor: '*obj-eng' stamp: 'cr 3/4/2005 17:59'!
withIndefiniteArticle
	self first isLetter ifFalse: [^self].

	^self first isVowel
		ifTrue: ['an ', self]
		ifFalse: ['a ', self]! !

!String methodsFor: '*obj-eng' stamp: 'cr 3/11/2005 21:08'!
wordsToStudlyCaps
	| result capitalizeNext |

	capitalizeNext := true.
	result := WriteStream on: (String new: self size).
	self do: [ :c | 
		c isSeparator 
			ifTrue: [capitalizeNext := true]
			ifFalse: [
				capitalizeNext ifTrue: [c := c asUppercase].
				result nextPut: c.
				capitalizeNext := false
			]
	].

	^result contents.

				! !


!SimpleGUI class reorganize!
('instance creation' on:)
('constants' defaultKeyTable)
!


!SimpleGUI reorganize!
('initialization' initializeControlPanel initializeKeyHandling initializeKeyTransTbl initializeManagers initializeMapCache initializeMessagePanel initializeMovementButtons initializePanel on: takeAllKeystrokes)
('construction' addStatItem:at: buildMainWindow createAndSizeMainManager createAndSizePanelManager createPanel fixLayoutDistances)
('tests' levelChanged)
('map panel management' checkForCreatureAt: resetPlayerViewRegion testAndClearMapReplacement updateMapReference)
('display' centerPlayer clearUnseenMonsters highlightPlayer openInWholeWorld openInWorld redrawAt: redrawWithoutMonsterAt: switchPanelToCurrentMap updateAllPoints updateAt: updateControlPanel updateEntireMap updateFromMap updateView updateVisiblePoints)
('accessing' close game manager map)
('keystrokes' keyPressed: keystrokeEvent:)
('text messages' message:)
('geometry' pixelMult)
('constants' controlPaneHeight mapPaneHeight messagePanelHeight panelColumnWidth panelColumns panelRowHeight panelRows preferredFont windowWidth)
('private' showMessageLine:)
!


!RoguelikeMapDisplay reorganize!
('initialization' initialize)
('accessing' at: at:put: clear contentsCopy highlightPoint: setContents: setSize:font:)
('geometry' extent: indexRectFor: rectForTileAt: sizeToFit tileSize)
('drawing' damageAt: drawCharAt:on: drawOn: xxxdrawCharAt:on:)
!


!Rectangle reorganize!
('accessing' aboveCenter area bottom bottom: bottomCenter bottomLeft bottomRight boundingBox center corner corners extent height innerCorners left left: leftCenter origin right right: rightCenter top top: topCenter topLeft topRight width)
('comparing' = hash hashMappedBy:)
('rectangle functions' adjustTo:along: allAreasOutsideList:do: allAreasOutsideList:startingAt:do: amountToTranslateWithin: areasOutside: bordersOn:along: encompass: expandBy: extendBy: forPoint:closestSideDistLen: insetBy: insetOriginBy:cornerBy: intersect: merge: outsetBy: pointNearestTo: quickMerge: rectanglesAt:height: sideNearestTo: translatedToBeWithin: withBottom: withHeight: withLeft: withRight: withSide:setTo: withSideOrCorner:setToPoint: withSideOrCorner:setToPoint:minExtent: withSideOrCorner:setToPoint:minExtent:limit: withTop: withWidth:)
('testing' containsPoint: containsRect: hasPositiveExtent intersects: isTall isWide isZero)
('truncation and round off' rounded truncateTo: truncated)
('transforming' align:with: centeredBeneath: flipBy:centerAt: newRectButtonPressedDo: newRectFrom: rotateBy:centerAt: scaleBy: scaleFrom:to: squishedWithin: translateBy:)
('printing' encodeForRemoteCanvas encodeForRemoteCanvasB encodePostscriptOn: printOn: propertyListOn: storeOn:)
('private' setOrigin:corner:)
('FMP' deltaToEnsureInOrCentered:extra:)
('Prefab-rectangle functions' bestFitIn: heightKeepingShape: tallness widthKeepingShape:)
('ObjHack-random' randomInternalPoint)
('ObjHack-enumerating' allBorderPointsDo: allInteriorPointsDo: bottomInsideDo: leftInsideDo: rightInsideDo: topInsideDo:)
('ObjHack-walls' expanded insideRect plusWalls wallsComment withInsideRectPoints)
('ObjHack-tests' within:of:)
('ObjHack-borders' bottomInside bottomLeftInside bottomRightInside cornersInside leftInside rightInside topInside topLeftInside topRightInside)
('ObjHack-GUI' griddedTo: limitedBy: shrunkByFraction:)
!


!NhZombie reorganize!
('tests--capabilites' usesTools wearsArmor)
!

GmWeaponAttack removeSelector: #recipientNotification!

!GmShortSword reorganize!
('attributes' damageRating)
!

GmWeapon removeSelector: #isWeapon!

!GmWeapon reorganize!
('type tests' isSword)
('slot info' slotType)
('attacks' attacksFrom:)
('attributes' damageRating)
!


!GmWall reorganize!
('tests' allowsFlyers allowsSwimmers allowsWalkers)
('wall tests' isCornerWall isDiggable isWall)
('construction tests')
('construction' constrDigYields)
!


!GmViewRegion reorganize!
('initialization' initialize:)
('updating' analyzePosition clearCache createDarkRoomViewable createLitRoomViewable)
('visibility' calculateRoomRectangle changedVisiblePointsDo: containsPoint: fastVisiblePointsDo: ifIncludes:do: visiblePointsDo:)
('whole-room updates' clearEnteredFlag setEnteredFlag)
('tests' canOptimize canSeePoint: enteredRoom lightRadiusSmall stillInSameRoom)
('printing' printOn:)
('constants' darkRoomLightRadius)
('private-calculation' findEdge:)
!


!GmUnusedSpace reorganize!
('tests' allowsFlyers allowsSwimmers allowsWalkers)
('construction tests' isDiggable)
('type tests' isUnusedSpace)
!

GmUnarmedAttack removeSelector: #recipientNotification!
GmPants removeSelector: #theDescriptionString!
GmGloves removeSelector: #descriptionString!
GmGloves removeSelector: #theDescriptionString!
GmBoots removeSelector: #descriptionString!
GmBoots removeSelector: #theDescriptionString!
GmClothing removeSelector: #isClothing!

!GmThing reorganize!
('type tests' isClothing isGem isJewelry isPantsOfYendor isThing isWeapon)
('type info' pointValue rootTypeName)
('slot tests' fitsInSlot: isPutOnAble isWearable isWieldable)
('slot info' slotType)
('stat modifications' armorClassMod charismaMod constitutionMod dexterityMod intelligenceMod strengthMod wisdomMod)
!


!GmSilentSuccess class reorganize!
('instance creation' new)
!


!GmSilentSuccess reorganize!
('testing' hasUserMessage)
!


!GmSuccess reorganize!
('control flow' ifFailure: ifSuccess: ifSuccess:ifFailure:)
('testing' isStatusResponse)
!

GmStuffManager removeSelector: #weaponForMap:!

!GmRoguelikeMapBuilder reorganize!
('initialization' initializeToExtent:)
('map building' buildMap)
('creature placement' randomCandidatePoint)
('construction' addRoomsAndTunnels randomDirection)
('construction-rooms' addRandomRoom addRoomAround: addRoomWithBounds:)
('construction-corridors' newCorridorFrom: tunnelFrom:)
('tests' canContainRect:)
('randomness constraints' maxRoomAttempts)
('room rectangles' adjacentPathOn:inRect: canMakeRoomShapedBy: hasRoomIntersecting: needWackyDoorsFor: roomRectAround: transFactorFor:toBeAround: validRoomBoundsAround:)
('constants' maxAdjacentDoors maxRoomExtent maxSingleRoomAttempts minRoomDistance minRoomExtent)
('junk' isTooCloseToOtherRoom: nilOrValidRoomBoundsAround: randomDirectionNot: randomRoomCornerPointFor: randomRoomOriginPoint randomRoomRect rectIsSuitable:)
!


!GmResponse class reorganize!
('as yet unclassified')
!


!GmFailure reorganize!
('flow control' ifFailure: ifSuccess: ifSuccess:ifFailure:)
('testing' isStatusResponse)
!


!GmResponse reorganize!
('flow control' ifFailure: ifKilledTarget: ifSpaceOccupied: ifSuccess: ifSuccess:ifFailure:)
('testing' isResponse)
!


!GmPortal reorganize!
('accessing' coordinates endPoint endPoint: endPointMap map map:)
('maps' destinationMap)
('invoking' displaceOccupant)
('type tests' isPortal)
('construction' endpointClass)
('construction tests' canReplaceWithPortal)
!


!GmPanelEntry reorganize!
('accessing' message message: messageArgs messageArgs: morph morph: object object:)
('updating' update)
!


!GmAsciiObjectDescription class reorganize!
('instance creation' letter:color:name:)
!


!GmObjectDescription class reorganize!
('instance creation' for: new)
!


!GmAsciiObjectDescription reorganize!
('initialization' letter:color:name:)
('accessing' color letter name)
('junk' flort)
!

GmObject class removeSelector: #isWeapon!

!GmObject class reorganize!
('instance creation' new)
('object management stats' canCreateIn: isConcrete maxAllowed)
!


!GmFloor reorganize!
('construction tests' canReplaceWithPortal isDug)
('tests' allowsFlyers allowsSwimmers allowsWalkers)
('type tests' isFloor isLit)
!


!GmDoor reorganize!
('initialization' initialize)
('accessing' isOpen)
('access tests' allowsFlyers allowsSwimmers allowsWalkers)
('construction tests' isDug)
('type tests' isDoor)
!


!GmFeature reorganize!
('access tests--overrides' allowsFlyers allowsSwimmers allowsWalkers)
('access tests--convenience' allowsAllAccess allowsSomeAccess)
('access tests--creatures' allowsAccessBy:)
('type tests' isDiggable isDoor isDownStairway isDug isDungeonExit isFloor isLit isPortal isTunnelFloor isUnusedSpace isUpStairway isWall)
('type info' rootTypeName)
('construction tests' canReplaceWithDoor canReplaceWithPortal)
('construction' constrDigYields)
('creature management' displaceOccupantOf:in: ifRoomDisplaceOccupantOf:in:by:)
('private' displaceCreature:to:in:by:)
!

GmCreature removeSelector: #insertAndDeploy:!

!GmCreature reorganize!
('initialization' addDefaultStats addSlots addStat:initializedTo: addStats: initialize)
('accessing' brain brain: slots)
('type tests' isCreature isHumanoid)
('type info' rootTypeName)
('stats' atStat: atStat:put: markStatsChanged sortedStatList statNamed:)
('stats-dnu' commentReadMe doesNotUnderstand: statAccessMsg: statObjAccessMsg:)
('tests--capabilites' flies swims usesTools walks wearsArmor)
('tests--circumstances' standingOnPortal)
('tests--stats' isDead)
('tests' isPlayer isWearingPants)
('attributes' bareIntrinsicAttackClasses computedExperienceValue damageRating experienceValue toHitRating)
('creature capabilities' goEast goNorth goNorthEast goNorthWest goSouth goSouthEast goSouthWest goWest invokePortal wait)
('creature capabilities -- player' interactiveDrop interactiveInventory interactivePutOn interactiveSaveAndQuit interactiveTake interactiveTakeOff interactiveUnWear interactiveWear interactiveWield)
('creature capabilities -- non-interactive' attackInDirection: deploy: drop: goInDirection: take: undeploy: wield:)
('creature communication' inform:)
('creature perception')
('creature actions' attacks intrinsicAttacks)
('creature status changes' die heal updateForGainedLevel)
('current square accessing' addToStuffHere: featureHere stuffHere)
('game cycle' endOfTurnUpdate)
('position' coordinates map pointToThe: yourFloor)
('position cache' setMap:andCoords:)
('vision' viewRegion)
('inventory' insertAndDeploy:or: inventory totalPointValue)
('wielding, wearing' applyToDeployedAndSum:)
('printing' printOn:)
('class attributes' brainClass)
('private-movement' moveToEndpoint: tryToLeaveDungeon)
!


!GmObject reorganize!
('initialization' initialize)
('type tests' isCreature isFeature isThing)
('description' descriptionString theDescriptionString)
('user interface')
('type properties' isUnique)
!


!GmObjStat class reorganize!
('instance creation' new on:value:)
!


!GmHitPoints reorganize!
('maximum  value' clipValue increaseMaxBy: maxHitpoints)
('core protocol' descString name setValue: value)
('healing' heal healToMax)
!


!GmExperience reorganize!
('core protocol' descString setValue:)
('level values' levelValue setLevelValue:)
('private- exp to level calculation' expForLevel: levelForExperience:)
!


!GmDungeonLevel reorganize!
('core protocol' descString value)
('tests' testAndClearChanged)
!


!GmNumStat reorganize!
('initialization' initialize)
('arithmetic' add: asNumber subtract:)
('tests' isSet)
('core protocol' name)
!


!GmBestiary reorganize!
('initialization' initialize)
('monster generation' createPlayer)
('calculations' numForUpdateIn: numRequiredIn:)
!

GmObjGenManager removeSelector: #itemsAvailableOnLevel:!

!GmObjGenManager reorganize!
('initialization' addToItemInfo: fillItemInfoFrom: initialize on:)
('map population' setupMap: updateMap:)
('item generation' addItem:to:ifUnable: addRandomItemTo:ifUnable: generateItemsIn:count: itemsAvailableOnMap: pickItemForMap:or: prepareObject:forMap:)
('accessing' itemInfo slotForClass:)
('calculations' numForUpdateIn: numRequiredIn:)
!

GmAttackedUnsuccessfully class removeSelector: #desc:byCreature:!
GmAttackedUnsuccessfully class removeSelector: #theCreature:does:!
GmAttacked class removeSelector: #desc:byCreature:!
GmAttacked class removeSelector: #theCreature:does:!
GmNotification class removeSelector: #desc:byCreature:!
GmAttackedUnsuccessfully removeSelector: #hostilityLevel!
GmAttacked removeSelector: #hostilityLevel!

!GmMapEntry class reorganize!
('instance creation' new)
('display class' descriptionClass)
!

GmMapEntry removeSelector: #nonCreatureTile!

!GmMapEntry reorganize!
('initialization' initialize)
('accessing' addThing: creature creature: feature feature: pileOfStuff)
('contents' firstThing nonCreatureTopmostObject removeCreature topmostObject)
('tests' contains: hasCreature hasStuff terrainAllows:)
('map visibility')
('display' asciiTile nonCreatureAsciiTile)
!


!GmMapBuilder class reorganize!
('instance creation' mapExtent: new)
!


!GmBigRoomBuilder reorganize!
('map building' buildMap)
!


!GmMapBuilder reorganize!
('initialization' initializeToExtent:)
('build parameters' initialExtent:)
('map building' addDoorAt: at:putDoorOr: at:putFeature: buildMap initializeMap)
('utilities' fillRegion:with: randomInsidePoint randomPointBetween:and:)
('accessing' map mapBounds mapExtent)
('construction-walls' addCornersFor: addEWWallFrom:to: addNSWallFrom:to: addWallsFor:)
('debug' displaySoFar)
!


!GmMap class reorganize!
('instance creation' new withExtent:)
('instance creation-sixx' createInstanceOf:withSixxElement:)
!

GmMap removeSelector: #hasMonsterAt:!

!GmMap reorganize!
('initialization' game: initializeToExtent: itemsWithExtent:)
('accessing' addPortal: adjacentMaps allCreatures at:addThing: at:putCreature: at:putFeature: at:putObject: bounds coordinatesOf: creationState creationState: creatureAt: entryAt: extent featureAt: game lowerLevels portals shuffledNonPlayerCreatures thingsAt: upperLevels)
('removing' removeCreature: removeCreatureAt:)
('random placement' placeCreature: placeThing:or:)
('display' asciiTileAt: nonCreatureAsciiTileAt:)
('geometry' center directionFrom:to:)
('enumeration' doAndSetFeatures: entriesDo: entriesSelect: entriesWithPointsDo: selectPoints:)
('queries' canPutCreature:at: containsPlayer containsPoint: descriptionString difficultyLevel hasCreatureAt: player playerCoordsOr: positionOf: positionOf:ifAbsent: quickRandomCoordMatching:onFailure: randomCoordMatching:onFailure: randomSpotFor:or: sectorsWithCreatures terrainAt:fitFor:)
('changes' changedPoints clearChangedPoints getAndClearChangedPoints)
('creature movement' moveCreature:to: moveEast: moveNorth: moveNorthEast: moveNorthWest: moveSouth: moveSouthEast: moveSouthWest: moveWest:)
('constants' randomPlacementAttempts)
('constants-directions' directionNames east north northEast northWest south southEast southWest west)
('private' at:putThing: changedAt: purgeMissingCreatures)
('debug' displaySoFar)
('serialization-not used' itemsAsPointAndValuePairs sixxFix)
!


!GmManagedObjectInfo reorganize!
('initialization' initializeOn:)
('accessing' itemClass maxAllowed numCreated)
('testing' canCreateIn: countExhausted)
('item creation' create uncreate)
('printing' printOn:)
!


!GmGenericBrain reorganize!
('stimulus' notify:)
('attacking' canAttackPlayer)
('response' getsDistracted goInRandomDirection makeMove tryToAttackPlayer tryToMoveTowardPlayer walkableDirections)
('player direction' directionOfPlayer possibleDirections)
!


!GmDungeonBuilderState reorganize!
('initialization' initialize)
('copying' nextLevelOnBranch:)
('level information' mapGenerator outPortalsHere totalMapsToBeGenerated)
('level customization' finalChangesTo:)
('map information' descriptionString)
('advancing')
('testing' isBottom isTop)
('accessing' level level:)
('constants' defaultMapExtent maxLevelsPerBranch)
!


!GmDungeonBuilder reorganize!
('initialization' game:initialState:genManagers: initialize)
('accessing' dungeon)
('dungeon creation' attachMap:to: buildDungeon buildDungeonUpdating: generateLevel:fromPortal: generateNextLevelFrom:accordingTo:)
('progress' updateProgressBar)
('constants')
!


!GmDeployments class reorganize!
('instance creation' new newForHumanoid)
('constants' knownSlotTypeNames putOnSlotTypeNames wearSlotTypeNames wieldSlotTypeNames)
('private instance creation' fromDescrArray:)
!


!GmDeployments reorganize!
('initialization' initialize)
('deployment' deploy:or: undeploy:or:)
('queries' allInSlots allInSlots: allPutOn allWielded allWorn isDeploying: sumOf:)
('slots' addSlot: emptySlotFor:or: slotHolding:or:)
!


!GmBuilderHack reorganize!
('all' addDefaultStatsAc:level:damage:toHit: constMethodNamed:string: constMethodNamed:value: creationTestForLevel: makeClass: makeClassForCreature:subclassOf: makeCreatureClassTo: makeSubclassTo: monsterList)
('gems' addAsciiTileMethodTo:for:and: gemList makeClass:subclassOf: makeGemClass: makeRingClass: makeRingClass:subclassOf: ringTypes)
('armor' armorEntries makeArmorClass: makeClassForArmor:subclassOf:)
('broken' addAsciiTileMethodFor:and:)
!

GmAttack removeSelector: #withWeaponString!

!GmAbstractCreatureBrain reorganize!
('initialization' for:)
('stimulus' notify:)
('response' makeMove)
('constants' directions)
('tests' isPlayerBrain)
!


!Collection reorganize!
('accessing' anyOne atRandom capacity size)
('adapting' adaptToCollection:andSend: adaptToNumber:andSend: adaptToPoint:andSend: adaptToString:andSend:)
('adding' add: add:withOccurrences: addAll: addIfNotPresent:)
('arithmetic' * + - / // \\)
('comparing' hash)
('converting' asArray asBag asByteArray asCharacterSet asIdentitySet asIdentitySkipList asOrderedCollection asSet asSkipList asSkipList: asSortedArray asSortedCollection asSortedCollection: topologicallySortedUsing:)
('copying' copyWith: copyWithDependent: copyWithout: copyWithoutAll:)
('enumerating' allSatisfy: anySatisfy: associationsDo: collect: collect:thenSelect: count: detect: detect:ifNone: detectMax: detectMin: detectSum: difference: do: do:separatedBy: do:without: groupBy:having: inject:into: intersection: noneSatisfy: reject: select: select:thenCollect: union:)
('filter streaming' contents flattenOnStream: write:)
('math functions' abs average ceiling floor log max median min negated range reciprocal rounded sqrt squared sum truncated)
('printing' printElementsOn: printNameOn: printOn: storeOn:)
('private' emptyCheck errorEmptyCollection errorNoMatch errorNotFound: errorNotKeyed toBraceStack:)
('removing' remove: remove:ifAbsent: removeAll: removeAllFoundIn: removeAllSuchThat:)
('testing' identityIncludes: includes: includesAllOf: includesAnyOf: includesSubstringAnywhere: isCollection isEmpty isEmptyOrNil isSequenceable notEmpty occurrencesOf:)
('*ObjHack-GUI' ifChoicePickOneOr:withCaption: pickOneOr: pickOneOr:withCaption: pickOneOr:withCaption:ifMatches:addLabel: pickOneWithCaption: pickOneWithFirst:appending:withCaption:or: pickWeaponWhileHolding:withCaption:or:)
('*ObjHack-printing' contentsString objDescriptionListString)
('*ObjHack-converting')
('*ObjHack-debugging' showHistogram)
!

